#include <intuition/intuition.h>
#include <workbench/startup.h>
#include <graphics/sprite.h>
#include <dos/dos.h>
#include <exec/memory.h>

#include <proto/graphics.h>
#include <proto/exec.h>
#include <proto/intuition.h>

#include "all_protos.h"

__far extern char *fabtab[],*lttab[];

extern APTR muzyka;

extern struct IntuiMessage *mes;
static struct BitMap mubekbm,pic1,pic2,pic3,pic4;
extern APTR MesPort;

#define SPRITASIZ 18*2*2
extern BYTE *spradat;
__far extern BYTE *spritblank;
extern struct SimpleSprite spr[4];

UWORD __far akcjapaleta[]=
{
	0x0000,0x0fff,0x0311,0x0443,0x0111,0x0511,0x0a24,0x0655,0x0221,0x0332,
	0x0544,0x0722,0x0211,0x0554,0x0522,0x999,
	0x0000,0x0999,0x0bbb,0x0fff,0x0000,0x0000,0x0246,0x0468,0x0000,0x0ccc,
	0x0000,0x0f00,0x0000,0x0999,0x0666,0x0333

};
extern UWORD menupaleta[];
extern ULONG cla,cod;
extern struct TextFont *ub16font,*ub8font;
extern WORD OpcDz,score;
extern ULONG s_czas,s_krok,s_fire;
extern BOOL LoadIFF(struct BitMap *bm,char* nazwa);
extern FreeIFF(struct BitMap *bm);
extern struct Window *menuwin;
extern struct RastPort *menurp;
extern struct ViewPort *menuvp;
extern char txttmp[100];
extern WORD a,b,i;

WORD full,Przerwano;
static char** aktlin;
WORD ktoryraz=0;

WORD Nacisniete()
{
if (mes=GetMsg(menuwin->UserPort))
	{
	cla=mes->Class; cod=mes->Code;
	ReplyMsg(mes);
	if ((cla==IDCMP_VANILLAKEY)&&(cod==27)) Przerwano=1;
	if ((cla==IDCMP_MOUSEBUTTONS)&&(!(cod&128))) return 0;
	full=0;
	return 1;
	}
if (!(*((BYTE *)0xbfe001)&128)) { full=0; return 1; }
return 0;
}

Napisz(char *t)
{
WORD d,x=0;

d=strlen(t);
switch (t[0])
	{
	case '=':
		x=160-TextLength(menurp,++t,--d)/2;
	break;
	case '>':
		x=320-TextLength(menurp,++t,--d);
	break;
	}
	Move(menurp,x,menurp->cp_y);
	Text(menurp,t,d);
if (full) Czekanie(10);
Move(menurp,menurp->cp_x,menurp->cp_y+menurp->TxHeight+2);
}

ZnajdzPoz(WORD poz)
{
WORD p=0;
aktlin=fabtab;
while (p<poz) if (**(aktlin++)=='#') p++;
}

NapiszTxt()
{
if (**aktlin=='^') { aktlin++; if (ktoryraz<3) return;}
if (**aktlin=='%') aktlin++;
while (((**aktlin)!='%')&&((**aktlin)!='^')&&((**aktlin)!='#')) 
	Napisz(*(aktlin++));
}

RysObr(WORD x,WORD y,struct BitMap *pic)
{
	BltBitMapRastPort( pic,0,0,
				menurp,x,y,(pic->BytesPerRow)<<3,pic->Rows,0xC0 );
}

RysFile(char *obr,WORD x,WORD y)
{
struct BitMap bm;
LoadIFF(&bm,obr);
RysObr(x,y,&bm);
FreeIFF(&bm);
}

Wskaz(WORD s,WORD x,WORD y,WORD obr)
{
WORD a;
if (!full) return;
		spr[s].x=x;
		spr[s].y=y;
		for (a=0;a<6;a++)
			{
			spr[s].height=a&1 ? 0 : 16;
			ChangeSprite(menuvp,&spr[s],spradat+obr*SPRITASIZ);
			Czekanie(5);
			}			
}

Ruch(s,x1,y1,x2,y2,o1,o2,at,t)
WORD s,x1,y1,x2,y2,o1,o2,t;
{
WORD xx,yy,a,f,att;

if (!full) return;
xx=((x2-x1)<<8)/t;
yy=((y2-y1)<<8)/t;
f=o1; att=at;
spr[s].height=16;
for (a=0;a<t;a++)
	{
	spr[s].x=x1+((xx*a)>>8);
	spr[s].y=y1+((yy*a)>>8);
	ChangeSprite(menuvp,&spr[s],spradat+f*SPRITASIZ);
	if (!--att) { att=at; if ((++f)>o2) f=o1; }
	if (Nacisniete()) break;
	GutDelay1();	
	}	
spr[s].height=0;
ChangeSprite(menuvp,&spr[s],&spritblank);
}

WORD Czekanie(WORD cz)
{
WORD t; APTR m;
WORD y;
if (!full) return;
for (t=0;t<cz;t++)
	{
	if (Nacisniete()) return 1;

/*
	y=menurp->cp_y;
	sprintf(txttmp,"%d,%d     ",menuwin->MouseX,menuwin->MouseY);
	Move(menurp,0,6); SetAPen(menurp,1); SetDrMd(menurp,JAM2);
	Text(menurp,txttmp,9);
	menurp->cp_y=y;	
*/
	GutDelay1();
	}
return 0;
}

WORD Akcja(WORD nr)
{
MusicOff();
MusicOn(muzyka,27);
AkcjaOn();
RysFile("pic/malyubek",0,0);
full=1;
Przerwano=0;
SetFont(menurp,ub16font);
Move(menurp,180,25);
sprintf(txttmp,lttab[95],nr+1);
SetAPen(menurp,1);
Text(menurp,txttmp,10);
SetFont(menurp,ub8font);
Move(menurp,160,35);
Text(menurp,lttab[nr+70],strlen(lttab[nr+70]));

Move(menurp,0,41); Draw(menurp,319,41);
SetAPen(menurp,9);
Move(menurp,0,40); Draw(menurp,319,40);
Move(menurp,0,42); Draw(menurp,319,42);

ModifyIDCMP(menuwin,IDCMP_VANILLAKEY | IDCMP_MOUSEBUTTONS);
MesPort=menuwin->UserPort;
ClearPort(MesPort);
ZnajdzPoz(nr);
SetFont(menurp,ub8font);
SetAPen(menurp,15); SetBPen(menurp,0);

switch(nr)
	{
	case 0:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/elektrownia.ham6",160,110);
		SetAPen(menurp,1);
		NapiszTxt();
		Ruch(2,170,100,237,210,4,5,10,50);
		SetAPen(menurp,15);
		NapiszTxt();
		Wskaz(2,254,205,2);
		NapiszTxt();
	break;

	case 1:
		Move(menurp,0,50);
		SetAPen(menurp,1);
		NapiszTxt();
		SetAPen(menurp,15);
		RysFile("pic/piwnica.ham6",170,80);
		NapiszTxt();
		NapiszTxt();
	break;

	case 2:
		SetAPen(menurp,1);
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/elektrownia.ham6",160,60);
		Wskaz(2,258,138,2);
		NapiszTxt();
		NapiszTxt();
	break;

	case 3:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/elektrownia.ham6",160,60);
		Wskaz(2,223,106,2);
		NapiszTxt();
		NapiszTxt();
	break;

	case 4:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/elektrownia.ham6",160,70);
		Wskaz(2,237,94,2);
		NapiszTxt();
		full=1; Czekanie(250);full=1;
		Move(menurp,0,50); ClearScreen(menurp);
		NapiszTxt();
		RysFile("pic/reaktor.ham6",80,70);
		Move(menurp,0,205);
		NapiszTxt();
		NapiszTxt();
	break;

	case 5:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/wajcha.ham6",0,80);
		NapiszTxt();
		NapiszTxt();
	break;

	case 6:		// expl.f1 60,3 - 64,36
				//      f2 44,0 - 80,40
		RysFile("pic/elektrownia.ham6",80,70);
		Czekanie(30);
		RysFile("pic/el-ex1.ham6",80+60,70+3);
		Czekanie(10);
		RysFile("pic/el-ex2.ham6",80+44,70+0);
		Czekanie(10);
		Move(menurp,0,50);
		ClearScreen(menurp);
		RysFile("pic/morze.ham6",0,50);
		Ruch(2,108,42,148,71,6,9,4,30);
		spr[2].height=16; ChangeSprite(menuvp,&spr[2],spradat+19*SPRITASIZ);
		Czekanie(10); 
		spr[2].height=0; ChangeSprite(menuvp,&spr[2],spradat+18*SPRITASIZ);
		Move(menurp,0,110);
		NapiszTxt();
	break;

	case 7:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/baza1.ham6",160,80);
		NapiszTxt();
		full=1; Czekanie(600); full=1;
		Move(menurp,0,50); ClearScreen(menurp);
		RysFile("pic/telefon.ham6",80,50);
		Move(menurp,0,166);
		NapiszTxt(); Czekanie(20);
		NapiszTxt(); Czekanie(20);
		NapiszTxt(); Czekanie(20);
		NapiszTxt(); Czekanie(20);
		NapiszTxt(); Czekanie(20);
		full=1; Czekanie(400); full=1;
		Move(menurp,0,50);
		ClearScreen(menurp);
		NapiszTxt();
	break;

	case 8:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/rusbaza.ham6",160,70);
		Ruch(2,227,85,227,148,0,0,999,50);
		NapiszTxt();
		NapiszTxt();
	break;

	case 9:
		Move(menurp,0,60);
		NapiszTxt();
		RysFile("pic/ufo1-dym.ham6",0,100);
		Move(menurp,0,228);
		NapiszTxt();
		RysFile("pic/ufo2-dym.ham6",160,100);
		NapiszTxt();
		full=1; Czekanie(600); full=1;
		Move(menurp,0,50); ClearScreen(menurp);
		NapiszTxt();
		RysFile("pic/baza2.ham6",80,90);
	break;

	case 10:
		Move(menurp,0,60);
		NapiszTxt();
		RysFile("pic/baza2.ham6",160,70);
		Wskaz(2,222,103,2);
		NapiszTxt();
		NapiszTxt();
	break;

	case 11:
		Move(menurp,0,60);
		NapiszTxt();
		RysFile("pic/planetaX.ham6",160,72);
		NapiszTxt();
	break;

	case 12:
		Move(menurp,0,200);
		RysFile("pic/alien.ham6",80,50);
		NapiszTxt();
		full=1; Czekanie(400); full=1;
		Move(menurp,0,200);
		ClearScreen(menurp);
		NapiszTxt();
	break;

	case 13:
		Move(menurp,0,200);
		RysFile("pic/alien.ham6",80,50);
		NapiszTxt();
		NapiszTxt();
	break;

	case 14:
		Move(menurp,0,50);
		RysFile("pic/krater.ham6",160,70);
		Wskaz(2,186,199,0);
		NapiszTxt();
	break;

	case 15:
		Move(menurp,0,50);
		RysFile("pic/krater.ham6",80,100);
		NapiszTxt();
		full=1; Czekanie(100);
		Move(menurp,0,100); ClearScreen(menurp);
		NapiszTxt();
		NapiszTxt();
	break;

	case 16:
		Move(menurp,0,50);
		RysFile("pic/krater.ham6",160,70);
		NapiszTxt();
		Wskaz(2,255,81,0);
		NapiszTxt();
	break;

	case 17:
		Move(menurp,0,50);
		NapiszTxt();
		RysFile("pic/planetaX.ham6",80,70);
		Ruch(2,120,124,0,140,15,15,999,30);
		Move(menurp,0,190);
		NapiszTxt();
		Czekanie(70);
		Move(menurp,0,50);
		ClearScreen(menurp);
		RysFile("pic/ziemia.ham6",128,70);
		Ruch(2,0,90,191,104,15,15,999,40);
		Move(menurp,0,190);
		NapiszTxt();
		full=1; Czekanie(100); full=1;
		RysFile("pic/baza2.ham6",80,50);
		Ruch(2,160,40,160,110,18,18,999,60);
		spr[2].height=16; ChangeSprite(menuvp,&spr[2],spradat+18*SPRITASIZ);
		full=1; Czekanie(300); 
		spr[2].height=0; ChangeSprite(menuvp,&spr[2],spradat+18*SPRITASIZ);
		Move(menurp,0,50);
		ClearScreen(menurp);
		NapiszTxt();
		NapiszTxt();
	break;

	}
	full=1;
	Przerwano=0;
	Czekanie(2200);

AkcjaOff();
MusicOff();
return (Przerwano);
}

Gratul()
{
char *an; ULONG len;
AkcjaOn();
RysFile("pic/malyubek",80,0);
SetAPen(menurp,1);
Move(menurp,0,41); Draw(menurp,319,41);
SetAPen(menurp,9);
Move(menurp,0,40); Draw(menurp,319,40);
Move(menurp,0,42); Draw(menurp,319,42);

MusicOff();
MusicOn(muzyka,27);

ModifyIDCMP(menuwin,IDCMP_VANILLAKEY | IDCMP_MOUSEBUTTONS);
MesPort=menuwin->UserPort;
full=1;
ClearPort(MesPort);
ZnajdzPoz(18);
SetFont(menurp,ub8font);
SetAPen(menurp,15); SetBPen(menurp,0);

		// exp. f1 52,32 - 80,52
		//      f2 42,12 - 112,82

	RysFile("pic/baza2.ham6",80,80);
	Ruch(2,160,130,160,50,18,18,999,30);
	RysFile("pic/ba-ex1.ham6",80+52,80+32);
	Czekanie(10);
	RysFile("pic/ba-ex2.ham6",80+42,80+12);
	Czekanie(10);

	Move(menurp,0,50);
	ClearScreen(menurp);

	NapiszTxt();
	full=1; Czekanie(1500);
	Move(menurp,0,50);
	ClearScreen(menurp);
	NapiszTxt();
	RysFile("pic/ziemia.ham6",0,116);
	PPLoadData("pic/extro",&an,&len,1);
	if (an)
	{
	PlayAn(an,len,menurp,64,100,4);
	FreeMem(an,len);
	}
	Move(menurp,0,100);
	SetAPen(menurp,1);
	SetFont(menurp,ub16font);
	NapiszTxt();
	SetFont(menurp,ub8font);
	full=1; Czekanie(2000);
	Move(menurp,0,50);	
	ClearScreen(menurp);

	Move(menurp,0,80);	

aktlin++;
Napisz(*(aktlin++));
sprintf(txttmp,*(aktlin++),s_czas/60);
Napisz(txttmp);
sprintf(txttmp,*(aktlin++),s_krok);
Napisz(txttmp);
sprintf(txttmp,*(aktlin++),s_fire);
Napisz(txttmp);
sprintf(txttmp,*(aktlin++),score);
Napisz(txttmp);

	full=1;
	Przerwano=0;
	Czekanie(2200);

AkcjaOff();
MusicOff();
}

AkcjaOn()
{
SetRast(menurp,0);
LoadRGB4(menuvp,akcjapaleta,32);

SetDrMd(menurp,JAM1);
}

AkcjaOff()
{
LoadRGB4(menuvp,menupaleta,32);
}
