#include <intuition/intuition.h>
#include <graphics/sprite.h>
#include <dos/dos.h>
#include <devices/timer.h>
#include <exec/interrupts.h>

#include <proto/graphics.h>
#include <proto/exec.h>
#include <proto/intuition.h>

#include <graphics/gfxmacros.h>

#include "obiekty.h"
#include "ver.h"

#include "all_protos.h"

#define PLIK_OPCJE "s:UBEK-opcje"
#define PLIK_HISCO "UBEK-rekordy"

#ifdef _CD32_
__far static char klaw_cd[50]="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ !\010\015";
__far char aktu_has[17]="";
#endif

__far extern char *lttab[];

struct	Screen		*menuekr;
struct	ViewPort	*menuvp;
struct	RastPort	*menurp;
struct	Window		*menuwin;
struct IntuiMessage	*mes;
struct timerequest	Time_Req ;
struct MsgPort		*Timer_Port = NULL, *CreatePort(),*MesPort ;
ULONG waittimer,waitinput;

ULONG	cla,cod;
struct	BitMap menubm;
extern APTR muzyka;
extern WORD i;
UWORD menupaleta[]=
{
	0x0000,0x0fff,0x0311,0x0443,0x0111,0x0511,0x0a24,0x0655,0x0221,0x0332,
	0x0544,0x0722,0x0211,0x0554,0x0522,0x999,
	0x0000,0x0fff,0x0ddd,0x0bbb,0x0999,0x0666,0x0444,0x0222,0x0050,0x00a0,
	0x00f0,0x0d95,0x0ea6,0x0eb7,0x0147,0x0169

},spychpaleta[]=
{
	0x0000,0x0fff,0x0311,0x0443,0x0111,0x0511,0x0a24,0x0655,0x0221,0x0332,
	0x0544,0x0722,0x0211,0x0554,0x0522,0x999,
	0x0000,0x0fff,0x0ddd,0x0bbb,0x0000,0x0eee,0x0000,0x09b9,0x0000,0x0fff,
	0x0000,0x009d,0x0ea6,0x0eb7,0x0147,0x0169
};
extern __far UWORD *akcjapaleta;

char ubekfont[]="ubek.font";
struct TextAttr 	ub16txt={ubekfont,16,0,0},
						ub8txt={ubekfont,8,0,0};
struct TextFont *ub16font,*ub8font;

#define RYSEKRAN BltBitMapRastPort( &menubm,0,0,&(menuekr->RastPort),0,0,320,256,0xC0);


char	*m_funkcje[10],
		*m_koniec[4],
		*m_opcje[8],
		*m_opcjeg[11],
		*m_opcjed[8],
		*m_opcjei[12],
		*m_OK[2],
		*m_wczyt[2],
		*m_OpMe[4],

		m_savetab[5][20],
		m_opow[20],
		*(m_saveg[6]),
		infotxt[10][32],
		*infotab[10],
		*helptab[18],
		*ostrztab[4];

struct hiscor	{char imie[10];
				UWORD pkt;
				UWORD lev;}	hiscor[10]=
{	">>.S.U.<<",7777,1,
	"* AMIGA *",6666,1,
	"S.RUSHDIE",5555,1,
	" /UBEK/  ",4444,1,
	"#DOHAR!#",3333,1,
	"HEXIS! :)",2222,1,
	"100%>>>>>",1111,1,
	">KAMIKAZE",111,1,
	"+GLIZDOR+",11,1,
	"SHADOWNOS",1,1,
};

__far char ZapisTxt[]=".save.X";
__far char ZapRAMTxt[]="RAM:UBEK_tmp1";
char txttmp[100];

__chip struct {char naz[10]; WORD ok; BYTE obr[64*50*4/8];}
	 	savegam[4];
WORD zappoz=0,zapene=32*9+31,zappocz=1,zapnr=0;

BYTE *obrpuste;

extern BOOL LoadIFF(struct BitMap *bm,char* nazwa);
extern FreeIFF(struct BitMap *bm);

extern __far BYTE *sloadtabdis[];
extern __far ULONG spritblank;

#define SPRITASIZ 18*2*2
extern BYTE *spradat;
extern struct SimpleSprite spr[4];
extern WORD full;

extern loadint();
extern diskint();
__far struct Interrupt interr=
	{ {0},0,&loadint };
__far struct Interrupt interr2=
	{ {0},0,&diskint };
__far WORD loadanim,SprDisk; 
__far WORD splostan=0;

extern WORD energ,amu,wybbron,poziom,pauza,los,lob,score,lmu2;
ULONG s_czas,s_krok,s_fire;
extern WORD ktoryraz;
extern __far struct mam mam[MAXMAM];

extern char gametoload[];

extern WORD *buf,*buf2;
#define SZER 64
#define WYS 100

#define OKOPCJA(o) ((o>=0)&&(o<lp)&&(*lista[o]=='1'))

WORD OpcPS=1,OpcGr=0,OpcDz=1,OpcOp=1,OpcPr=0,OpcCe=1,OpcZo=0,OpcBr=1,OpcPa=1;
ULONG OpcBl=0;
extern WORD helpwanted;

WORD Wybor(char *lista[],WORD wyb,WORD spec,WORD dy)
{
WORD w=0,s=0,x,y,i=0,xx,yy,powyb=-1,wyb0,a,py=menuwin->MouseY,lp,t=0,tk=1,niewyb=0;
static WORD spectab[]={35,39,42,47,42,39,35};

ModifyIDCMP(menuwin, IDCMP_MOUSEBUTTONS | IDCMP_VANILLAKEY | IDCMP_RAWKEY | IDCMP_INACTIVEWINDOW);

while (*(lista[i]))
	{ 
	if ((*lista[wyb]) != '1') wyb=i;
	s=__builtin_max(s,TextLength(menurp,lista[i]+1,strlen(lista[i]+1)));
	  i++;
	 }
if ((*lista[wyb]) != '1') { wyb=-1; goto koniec; }
wyb0=wyb;
lp=i;
x=160-s/2; w=i*18; y=145-w/2+dy;
BevelBox(x-8,y-8,x+s+8,y+w+8);
while (1)
{

if (powyb!=wyb)
{
yy=y+15;
SetBPen(menurp,9);
	for (i=0;i<lp;i++)
 {
	if (i==wyb) SetAPen(menurp,1);
		else	SetAPen(menurp,((*lista[i])=='1')?15:0);
	if (*lista[i]=='2')
		 { SetAPen(menurp,1); Move(menurp,x,yy+2); Draw(menurp,x+s,yy+2); }
	Move(menurp,x,yy); Text(menurp,lista[i]+1,strlen(lista[i]+1));
	 yy+=18;
 }
}


powyb=wyb;
if (niewyb) { Wait(waitinput); }
				
while (mes=GetMsg(menuwin->UserPort))
	{
	cla=mes->Class;
	cod=mes->Code;
	ReplyMsg(mes);
	
	switch(cla)
	{
	case IDCMP_INACTIVEWINDOW:
		ClearPort(menuwin->UserPort);
		niewyb=1;
	break;
	case IDCMP_MOUSEBUTTONS:
		if (cod&128)	{ if (!niewyb) goto koniec; }
			else niewyb=0;
	break;
	case IDCMP_RAWKEY:
		switch (cod)
		{
		case CURSORUP:
			for (a=1;a<lp;a++)
			if OKOPCJA(wyb-a) {wyb-=a; break;}
				break;

		case CURSORDOWN:
			for (a=1;a<lp;a++)
			if OKOPCJA(wyb+a) {wyb+=a; break;}
				break;
		case 0x5f:			
			if (spec) break;
			else
				{
				APTR font=menurp->Font;
				Help();
				RYSEKRAN
				BevelBox(x-8,y-8,x+s+8,y+w+8);
				SetFont(menurp,font);
				powyb=-1;
				}
			break;
		}
		break;

	case IDCMP_VANILLAKEY:
		switch (cod)
		{
		case 13:
		case 32:	goto koniec; 

		case 27:	wyb=-1;
					goto koniec;


		default:
		for (a=0;a<lp;a++)
		if (OKOPCJA(a) && (toupper(cod&0x7f)==lista[a][1]))
			{wyb=a; break;}
		break;
		}
	break;
	}
	}

i=(*(WORD*)0xdff00c);
if (((i&(1<<1))>>1)^(i&(1<<0)))
	for (a=1;a<lp;a++)
		if OKOPCJA(wyb+a) {wyb+=a; GutDelay(5); break;}
if ((i&(1<<8))^((i&(1<<9))>>1))
	for (a=1;a<lp;a++)
		if OKOPCJA(wyb-a) {wyb-=a; GutDelay(5); break;}
if (!(*((BYTE *)0xbfe001)&128))
	{ GutDelay(10); while (!(*((BYTE *)0xbfe001)&128)); goto koniec; }
	
	if (py!=menuwin->MouseY) 
		{ a=((py=menuwin->MouseY)-y)/18;
		 	if (a>=lp) a=lp-1;
			if (a<0) a=0;
			if (*lista[a]=='1') wyb=a;
		}
	GutDelay1();
	if (spec)
		{
			SetAPen(menurp,0);
			Move(menurp,13,64);
			Draw(menurp,13,64+49);
			Move(menurp,13,128);
			Draw(menurp,13,128+49);
			Move(menurp,245,64);
			Draw(menurp,245,64+49);
			Move(menurp,245,128);
			Draw(menurp,245,128+49);
			xx=13+((wyb-1)&1)*232;
			yy=64+((wyb-1)&2)*32;
			t+=tk;
			if (t>=49-7) tk=-1;
			if (t<1) tk=1;
			for (a=0;a<7;a++)
				{ SetAPen(menurp,spectab[a]);
					WritePixel(menurp,xx,yy+a+t);}
		}
}
	koniec:
	ModifyIDCMP(menuwin,IDCMP_VANILLAKEY);

return wyb;
}

BevelBox(WORD x,WORD y,WORD x2,WORD y2)
{
SetAPen(menurp,9);
RectFill(menurp,x,y,x2,y2);
SetAPen(menurp,15);
Move(menurp,x,y2);
Draw(menurp,x,y);
Draw(menurp,x2,y);
SetAPen(menurp,0);
Draw(menurp,x2,y2);
Draw(menurp,x,y2);
SetAPen(menurp,1);
WritePixel(menurp,x,y);
}

WORD RysSaveGame()
{
WORD i,x,y,xx,yy,j;
struct BitMap tbm;

SetFont(menurp,ub8font);
for (i=0;i<4;i++)
	{
	x=14+(i&1)*232;
	y=64+(i&2)*32;
	BevelBox(x-3,y-3,x+64+3,y+50+3);
	SetAPen(menurp,0);
	RectFill(menurp,x-1,y-1,x+64+1,y+50+1);
	InitBitMap(&tbm,4,64,50);
	for (j=0;j<4;j++) tbm.Planes[j]=savegam[i].obr+j*64*50/8;
	BltBitMapRastPort( &tbm,0,0,&(menuekr->RastPort),x,y,64,50,0xC0);
	SetDrMd(menurp,COMPLEMENT);
	SetAPen(menurp,48);
	RectFill(menurp,x,y,x+63,y+49);
	SetDrMd(menurp,JAM2);
	SetAPen(menurp,1);
	SetBPen(menurp,0);
	j=strlen(savegam[i].naz);
	Move(menurp,x+64-TextLength(menurp,savegam[i].naz,j),y+6);
	Text(menurp,savegam[i].naz,j);
	}

SetFont(menurp,ub16font);
}

ZrobSaveGam(WORD i)
{
WORD xx,yy,j,*tmp,k;
struct BitMap tbm;
struct RastPort trp;

	InitBitMap(&tbm,4,64,50);
	InitRastPort(&trp);
	trp.BitMap=&tbm;
	for (j=0;j<4;j++) tbm.Planes[j]=savegam[i].obr+j*64*50/8;
	tmp=buf2;
	for (yy=0;yy<50;yy++)
	{
		for (xx=0;xx<64;xx++)
		{
		SetAPen(&trp,15-((*tmp&0xf)+2*((*tmp&0xf0)/16)+((*tmp&0xf00)/256))/4);
		WritePixel(&trp,xx,yy);
		tmp++;
		}
	tmp+=SZER;
	}
}

#ifdef _CD32_

PackHas(char *has)
{
ULONG pack;
WORD i;

pack=poziom;
pack=(pack<<3)+amu/16;
pack=(pack<<4)+mam[2].co;
for (i=3;i<8;i++)
	pack=(pack<<4)+mam[i].co;
for (i=0;i<6;i++)
	{
	has[i]=pack%45;
	pack=pack/45;
	}
has[6]=energ/8;
has[7]=mam[2].gfx%45;
for (i=0;i<6;i++)
has[8+i]=mam[2+i].gfx;

has[14]=(has[0]+2*has[1]+has[2]+has[3]+has[4]+3*has[5]+
		2*has[6]+has[7]+5*has[8]+4*has[9]+has[10]+2*has[11]+has[12]+3*has[13])%45;
has[15]=(6*has[0]+3*has[1]+has[2]+5*has[3]+has[4]+2*has[5]+
		3*has[6]+has[7]+4*has[8]+5*has[9]+has[10]+has[11]+3*has[12]+2*has[13]+7*has[14])%45;

for (i=0;i<16;i++) has[i]=klaw_cd[has[i]];
}

char SzukKlaw(char kl)
{
WORD i;
for (i=0;i<45;i++)
	if (klaw_cd[i]==kl) return i;
return -1;
}

BOOL UnPackHas(char *has)
{
ULONG pack; WORD suma=0;
char tmp[16];

for (i=0;i<16;i++)
	if ((tmp[i]=SzukKlaw(has[i]))<0) return 0;

if (tmp[14]!=(tmp[0]+2*tmp[1]+tmp[2]+tmp[3]+tmp[4]+3*tmp[5]+2*tmp[6]+
	tmp[7]+5*tmp[8]+4*tmp[9]+tmp[10]+2*tmp[11]+tmp[12]+3*tmp[13])%45)
		return 0;
if (tmp[15]!=(6*tmp[0]+3*tmp[1]+tmp[2]+5*tmp[3]+tmp[4]+2*tmp[5]+3*tmp[6]+
	tmp[7]+4*tmp[8]+5*tmp[9]+tmp[10]+tmp[11]+3*tmp[12]+2*tmp[13]+7*tmp[14])%45)
		return 0;

pack=0;
for (i=5;i>=0;i--)
	pack=(pack*45)+tmp[i];
for (i=7;i>=2;i--)
	{
	mam[i].co=pack&15;
	pack>>=4;
	}
amu=(pack&7)*16+8; pack>>=3;
poziom=pack&31;
if (poziom>18) { poziom=0; return 0;}
energ=8*tmp[6]+4;
mam[2].gfx=tmp[7];
for (i=0;i<6;i++)
	mam[2+i].gfx=tmp[8+i];

return 1;
}

RysKlaw(WORD x,WORD y,char znak)
{
switch(znak)
	{
	case 13: znak=''; break;
	case 8: znak=''; break;
	case 27: znak=''; break;
	case ' ': znak=''; break;
	}
BevelBox(x,y,x+19,y+19);
SetAPen(menurp,1);
Move(menurp,x+10-TextLength(menurp,&znak,1)/2,y+17);
Text(menurp,&znak,1);
}

WORD PytTekst(char* napis,char *txt,WORD maxlen)
{
WORD s,x,y,d,xk,yk;
char *zn=klaw_cd;
unsigned char kod;

s=__builtin_max(maxlen*16+16,8*strlen(napis))+10;
x=160-s/2;
y=120-55;
BevelBox(x,y,x+s,y+10+10+20);
SetFont(menurp,ub8font);
Move(menurp,x+5,y+10);
SetAPen(menurp,1);
Text(menurp,napis,strlen(napis));
SetFont(menurp,ub16font);
d=strlen(txt);
BevelBox(58,108,262,212);
for (yk=110;yk<210;yk+=20)
for (xk=60;xk<260;xk+=20)
	RysKlaw(xk,yk,*(zn++));

ModifyIDCMP(menuwin,IDCMP_VANILLAKEY | IDCMP_MOUSEBUTTONS);
while (1)
	{
	txt[d]='_';
	SetAPen(menurp,0);
	RectFill(menurp,x+3,y+35-16,x+s-2,y+35+2);
	SetAPen(menurp,1);
	SetBPen(menurp,0);
	Move(menurp,x+5,y+35);
	Text(menurp,txt,d+1);
	txt[d]=0;

	Wait(waitinput);
	if (mes=GetMsg(menuwin->UserPort))
	{
	kod=mes->Code;
	switch(mes->Class)
	{
	case IDCMP_MOUSEBUTTONS:
		if ((kod&128)&&(mes->MouseX>=60)&&(mes->MouseX<260)&&(mes->MouseY>=110)&&(mes->MouseY<210))
			{
			kod=klaw_cd[((mes->MouseX-60)/20)+10*((mes->MouseY-110)/20)];
			}
		else break;
	case IDCMP_VANILLAKEY:
		switch(kod)
			{case 13:
				kod=1; goto wyjscie;
			case 8:
				if (d>0) d--;
				break;
			case 27:
				kod=0; goto wyjscie;
			default:
				if ((kod>=' ')&&(d<maxlen))
					txt[d++]=(((kod>96)&&(kod<123))||(kod>=224))?kod-32:kod;
			}
	}
	ReplyMsg(mes);
	}
	}

wyjscie:
ModifyIDCMP(menuwin,IDCMP_VANILLAKEY);

return(kod);
}

#else

WORD PytTekst(char* napis,char *txt,WORD maxlen)
{
WORD s,x,y,d,kod;

s=__builtin_max(maxlen*16+16,8*strlen(napis))+10;
x=160-s/2;
BevelBox(x,120,x+s,120+10+10+20);
SetFont(menurp,ub8font);
Move(menurp,x+5,120+10);
SetAPen(menurp,1);
Text(menurp,napis,strlen(napis));
SetFont(menurp,ub16font);
d=strlen(txt);
ModifyIDCMP(menuwin,IDCMP_VANILLAKEY);
while (1)
	{
	txt[d]='_';
	SetAPen(menurp,0);
	RectFill(menurp,x+3,120+35-16,x+s-2,120+35+2);
	SetAPen(menurp,1);
	SetBPen(menurp,0);
	Move(menurp,x+5,120+35);
	Text(menurp,txt,d+1);
	txt[d]=0;

	Wait(waitinput);
	if (mes=GetMsg(menuwin->UserPort))
	{
	if (mes->Class==IDCMP_VANILLAKEY)
		switch(kod=mes->Code)
			{case 13:
				kod=1; goto wyjscie;
			case 8:
				if (d>0) d--;
				break;
			case 27:
				kod=0; goto wyjscie;
			default:
				if ((kod>=' ')&&(kod<=255)&&(d<maxlen))
					txt[d++]=kod;
			}
	ReplyMsg(mes);
	}
	}

wyjscie:
ModifyIDCMP(menuwin,IDCMP_VANILLAKEY);

return(kod);
}


#endif

ZrobSGTab(WORD forsave)
{
WORD i;
for (i=0;i<4;i++)
	{
	strcpy(m_savetab[i+1]+1,savegam[i].naz);
	m_savetab[i+1][0]=( (forsave || savegam[i].ok) ? '1' : '0' );
	}
}

__far WORD SaveGame(WORD g)
{
APTR file;
ULONG SG_ID='UBSG';
WORD ok=0;

	ZapisTxt[6]='1'+g;
if (g!=4)
	{
	if (!(file=MOpen(ZapisTxt,MODE_NEWFILE))) return 0;
	}
else
	{
	if (!(file=Open(ZapRAMTxt,MODE_NEWFILE))) return 0;
	}

	Write(file,&SG_ID,4);
	Write(file,&savegam[g&3],sizeof(savegam[0]));
	ZapiszSyt(file);
	Write(file,&wybbron,2);
	Write(file,&mam[0],MAXMAM*sizeof(mam[0]));
	Write(file,&energ,2);
	Write(file,&poziom,2);
	Write(file,&amu,2);
	Write(file,&lob,2);
//	Write(file,&score,2);
	Write(file,&lmu2,2);
	Write(file,&s_czas,4);
	Write(file,&s_krok,4);
	Write(file,&s_fire,4);

	Close(file);
    if (g!=4) ZapiszIkone(ZapisTxt,savegam[g].naz);
	return 1;
}

TestSG()
{
APTR file; WORD g,i; ULONG TestID;

for (g=0;g<4;g++)
	{
	ZapisTxt[6]='1'+g;	
	savegam[g].ok=0;
	if (file=Open(ZapisTxt,MODE_OLDFILE))
		{
		Read(file,&TestID,4);
		if (TestID=='UBSG')
			{
			Read(file,&savegam[g],sizeof(savegam[g]));
			savegam[g].ok=1;
			}
		Close(file);
		}
	if (!savegam[g].ok)
		{
		strcpy(savegam[g].naz,lttab[61]);
		savegam[g].naz[6]='1'+g;
		CopyMem(obrpuste,savegam[g].obr,1600);
		}
	}
}

WORD LoadGame(char *nazwa)
{
APTR file;
ULONG TestID;
WORD ok=0;

SpritLoad();
energ=0;

if (file=MOpen(nazwa,MODE_OLDFILE))
	{
		Read(file,&TestID,4);
		if (TestID=='UBSG')
		{
		ok=1;
		Seek(file,sizeof(savegam[0]),OFFSET_CURRENT);
		CzytSyt(file);
		Read(file,&wybbron,2);
		Read(file,&mam[0],MAXMAM*sizeof(mam[0]));
		Read(file,&energ,2);
		Read(file,&poziom,2);
		Read(file,&amu,2);
		los=lob;
		Read(file,&lob,2);
		// Read(file,&score,2);
		score=0;
		Read(file,&lmu2,2);
		Read(file,&s_czas,4);
		Read(file,&s_krok,4);
		Read(file,&s_fire,4);
		}
	Close(file);
	}

if (ok)
	LoadGfx(0);

SpritLoadOff();

return ok;
}

Menu()
{
WORD wyb=0,noexit=1,g,i;
char *m_saveg[6]; 

#ifndef _CD32_
CzytHisco();
#endif

if (TestAGA())
	{ OpcGr=1; m_opcjeg[1][0]='0'; m_opcjeg[3][0]='0'; }

if (AvailMem(0)<820000)
	{
	MusicOn(muzyka,6);
	BevelBox(10,104,320-10,152);
	SetFont(menurp,ub16font);
	SetAPen(menurp,1);
	PiszLin(lttab[129],-40);
	SetFont(menurp,ub8font);
	PiszText(20,120,&ostrztab[0]);
	full=1;
	ModifyIDCMP(menuwin, IDCMP_MOUSEBUTTONS | IDCMP_VANILLAKEY | IDCMP_RAWKEY | IDCMP_INACTIVEWINDOW);
	ClearPort(MesPort);
	Czekanie(9999);
	MusicOff();
	}

	RYSEKRAN

for (i=0;i<4;i++)
	{
	strcpy(m_savetab[i+1]+1,savegam[i].naz);
	*m_savetab[i+1]='1';
	}
for (i=0;i<5;i++) m_saveg[i]=m_savetab[i];
m_saveg[5]=0;

if (*gametoload) 
	{
		SetAPen(menurp,1);
		SetFont(menurp,ub8font);
		TestSG();
		PiszLin(lttab[97],-30);
		if (LoadGame(gametoload))
			{  zapnr=4; zappoz=-1; zappocz=0; Gra(0,1); if (!energ) HiScor(1); }
	}
	else 
	{
		MusicOn(muzyka,18);
		Info();
	}

	RYSEKRAN

while(noexit)
{
MusicOn(muzyka,18);
	*m_funkcje[1]=(energ ? '1' : '0');
#ifdef _CD32_
#define	OPCJA_REK 4 
		m_funkcje[3]=lttab[23];
		*m_funkcje[3]=(zappoz ? '1' : '0');
		stci_d(&m_funkcje[3][9],zappoz+1);
#else
#define	OPCJA_REK 5 
	if (zappocz)
		{
		m_funkcje[2]=lttab[23];
		*m_funkcje[2]=(zappoz ? '1' : '0');
		stci_d(&m_funkcje[2][9],zappoz+1);
		}
	else
		{
		m_funkcje[2]=txttmp;
		strcpy(txttmp,"1>");
		if (zapnr<4) strcpy(txttmp+3,savegam[zapnr].naz);
		}
	*m_funkcje[4]=(energ ? '1' : '0');
#endif
	SetFont(menurp,ub16font);
	spritblank=0;
	MenuSpritOff();
	wyb=Wybor(m_funkcje,wyb,0,0);
	switch(wyb)
	{
	case 0:	
		if ( energ || zappoz )
			{
			m_koniec[0]=lttab[99];
			if (Wybor(m_koniec,1,0,0)!=1) break;
			}
		energ=32*9+31;
		if (zappoz) ktoryraz=0;
		amu=50;
		wybbron=0;
		s_fire=s_czas=s_krok=0;
		mam[0].co=1; mam[0].obiekt=0;
		mam[1].co=2; mam[1].obiekt=0;
		for (i=2;i<MAXMAM;i++) {mam[i].co=0; mam[i].obiekt=0;}
		poziom=0;
		score=0;
		Gra(1,1);
		if (!energ) HiScor(1);
		RYSEKRAN
		break;

	case 1:		// ...dalej
		Gra(0,0);
		if (!energ) HiScor(1);
		RYSEKRAN
		break;

#ifdef _CD32_
	case 2:		// haslo
		*txttmp=0;
		strcpy(txttmp,aktu_has);
		if (!PytTekst(lttab[135],txttmp,16)) break;
		RYSEKRAN
		if (!UnPackHas(txttmp)) break;
		strncpy(aktu_has,txttmp,16);
		energ=0;
		ktoryraz=0;
		if (!(zappoz=poziom)) break;

	case 3:	// od poziomu N
		UnPackHas(aktu_has);
		score=wybbron=0;
		Gra(1,1);
		if (!energ) HiScor(1);
		RYSEKRAN
		break;

#else
	case 2:	// od poziomu N
		LoadGame(ZapRAMTxt);
		ktoryraz=0;
		Gra(0,zappocz);
		if (!energ) HiScor(1);
		RYSEKRAN
		break;

	case 3:		// wczyt
		TestSG();
		RYSEKRAN
		RysSaveGame();
		strcpy(m_savetab[0]+1,lttab[24]+1);
		*m_savetab[0]='2';
		ZrobSGTab(0);
		g=Wybor(m_saveg,1,1,0)-1;
		if (g<0)
			{
				RYSEKRAN
				break;
			}

		zapnr=g;
		ZapisTxt[6]='1'+g;
		i=LoadGame(ZapisTxt);
		if (!i)
			 {	RYSEKRAN
				break; }
		zappocz=0;
		zappoz=-1;
		Gra(0,1);
		if (!energ) HiScor(1);
		RYSEKRAN
		break;
	
	case 4:		// zapis
		TestSG();
		RYSEKRAN
		RysSaveGame();
		strcpy(m_savetab[0]+1,lttab[25]+1);
		m_savetab[0][0]='2';
		ZrobSGTab(1);
		g=Wybor(m_saveg,1,1,0)-1;
		if (g>=0)
			{strcpy(txttmp,savegam[g].naz);
			 if (PytTekst(lttab[62],txttmp,8))
				{
			 	ZrobSaveGam(g);
				strcpy(savegam[g].naz,txttmp);
				if (*txttmp==0)
					{savegam[g].naz[0]='1'+g;
					savegam[g].naz[1]=0;}
				savegam[g].ok=1;
				if (!SaveGame(g)) TestSG();
				SaveGame(4);
				zappoz=poziom;
				zappocz=0;
				zapnr=g;
				}
			}
		RYSEKRAN
		break;
#endif

	case OPCJA_REK:
		HiScor(0);
		RYSEKRAN		
		break;

	case OPCJA_REK+1:
		WybOpcje();
		RYSEKRAN		
		break;

	case OPCJA_REK+2:
		Info();
		RYSEKRAN
		break;

	case OPCJA_REK+3:
	case -1:
		m_koniec[0]=lttab[30];
		noexit=Wybor(m_koniec,1,0,0)-1;
		break;
	}
}
MusicOff();

DeleteFile(ZapRAMTxt);
DeleteFile("RAM:UBEK_tmp2");
}

ProcentInit()
{
BevelBox(32-8,120,320-32+8,140);
SetAPen(menurp,0);
RectFill(menurp,32-4,124,320-32+4,136);
}

Procent(WORD p)
{
SetAPen(menurp,60);
RectFill(menurp,32,128,32+p,132);
SetAPen(menurp,54);
RectFill(menurp,32,127,32+p,127);
RectFill(menurp,32,133,32+p,133);
SetAPen(menurp,1);
RectFill(menurp,32,129,32+p,129);
}

Info()
{
WORD x,y,xx,yy,en,pk,po,j,*tmp;
struct BitMap tbm;

info:
BevelBox(16,65,320-16,190);

SetFont(menurp,ub16font);
SetAPen(menurp,1);
PiszLin(lttab[63],-61);
SetFont(menurp,ub8font);
PiszLin("AUTOR: SZYMON ULATOWSKI",-34);

en=energ; pk=score; po=poziom;
if (energ)
	{ en=energ; pk=score; po=poziom; }
	else
	{ en=zapene; pk=0; po=zappoz; }
sprintf(infotxt[4],lttab[58],po+1);
sprintf(infotxt[5],lttab[59],pk);
sprintf(infotxt[6],lttab[60],(en*100)/(32*9+31));
PiszText(24,122,&infotab[0]);
#ifdef _CD32_
if (poziom>0)
	{
	Move(menurp,150,162);
	Text(menurp,aktu_has,8);
	Move(menurp,150,170);
	Text(menurp,aktu_has+8,8);
	}
#endif
x=224; y=125;
BevelBox(x-3,y-3,x+64+3,y+50+3);
SetAPen(menurp,0);
RectFill(menurp,x-1,y-1,x+64+1,y+50+1);
if (energ)
	{
	tmp=buf2;
	for (yy=0;yy<50;yy++)
	{
		for (xx=0;xx<64;xx++)
		{
		SetAPen(menurp,48+((*tmp&0xf)+2*((*tmp&0xf0)/16)+((*tmp&0xf00)/256))/4);
		WritePixel(menurp,x+xx,y+yy);
		tmp++;
		}
	tmp+=SZER;
	}
	}
	else
	{
	SetAPen(menurp,63);
	SetBPen(menurp,0);
	Move(menurp,x,y+22);
	Text(menurp,lttab[64],8);
	Move(menurp,x,y+32);
	Text(menurp,lttab[65],7);
	}

SetFont(menurp,ub16font);

m_opow[0]=energ?'1':'0';
switch	(Wybor(m_OpMe,0,0,74))
	{
	case 1:
		Akcja(poziom);
		MusicOn(muzyka,18);
		RYSEKRAN
		goto info;
	case 2:
		Help();
	}
}

Help()
{
BevelBox(10,35,320-10,256-35);
SetFont(menurp,ub16font);
SetAPen(menurp,1);
PiszLin(lttab[108],-120);
SetFont(menurp,ub8font);
PiszText(20,49,&helptab[0]);
full=1;
ModifyIDCMP(menuwin, IDCMP_MOUSEBUTTONS | IDCMP_VANILLAKEY | IDCMP_RAWKEY | IDCMP_INACTIVEWINDOW);
ClearPort(MesPort);
Czekanie(9999);
}

#ifndef _CD32_
CzytHisco()
{
int i; APTR file;
if (file=MOpen(PLIK_HISCO,MODE_OLDFILE))
	{
	for (i=0;i<10;i++) Read(file,&hiscor[i],sizeof(hiscor[i]));
	Close(file);
	}
}

ZapHisco()
{
int i; APTR file;
if (file=MOpen(PLIK_HISCO,MODE_NEWFILE))
	{
	for (i=0;i<10;i++) Write(file,&hiscor[i],sizeof(hiscor[i]));
	Close(file);
	}

}

ZapOpcje()
{
APTR file;
if (file=Open(PLIK_OPCJE,MODE_NEWFILE))
	{
	Write(file,&OpcGr,2);
	Write(file,&OpcPS,2);
	Write(file,&OpcDz,2);
	Write(file,&OpcOp,2);
	Write(file,&OpcBl,4);
	Write(file,&OpcPr,2);
	Write(file,&OpcCe,2);
	Write(file,&OpcZo,2);
	Write(file,&OpcBr,2);
	Write(file,&OpcPa,2);
	Close(file);
	}
}
#endif

CzytOpcje()
{
APTR file;
if (file=Open(PLIK_OPCJE,MODE_OLDFILE))
	{
	Read(file,&OpcGr,2);
	Read(file,&OpcPS,2);
	Read(file,&OpcDz,2);
	Read(file,&OpcOp,2);
	Read(file,&OpcBl,4);
	Read(file,&OpcPr,2);
	Read(file,&OpcCe,2);
	Read(file,&OpcZo,2);
	Read(file,&OpcBr,2);
	Read(file,&OpcPa,2);
	Close(file);
	Priorytet();
	}
}


Priorytet()
{
SetTaskPri(FindTask(0),OpcPr);
}

WybOpcje()
{
WORD i,op,op2;
op=1;
while (op>=0)
	{
	RYSEKRAN
	op=Wybor(m_opcje,op,0,0);
	if (op==6) op=-1;
	switch(op)
	{
		case 1:
		op2=1;
		while (op2>=0)
		{
		m_opcjeg[1][1]=((OpcGr==0)?'':'');
		m_opcjeg[2][1]=((OpcGr==1)?'':'');
		m_opcjeg[3][1]=((OpcGr==2)?'':'');
		for (i=0;i<3;i++)
			m_opcjeg[i+5][1]=((OpcPS==i) ? '' : ''); 
		op2=Wybor(m_opcjeg,op2,0,0);
		if (op2==9) op2=-1;
		if ((op2>=1)&&(op2<=3)) OpcGr=op2-1;
		if ((op2>=5)&&(op2<=7)) OpcPS=op2-5;
		}
		break;
	
		case 2:
		op2=1;
		while (op2>=0)
		{
		for (i=1;i<=2;i++)
			m_opcjed[i][1]=((OpcDz&i) ? '' : ''); 
		op2=Wybor(m_opcjed,op2,0,0);
		if (op2==4) op2=-1;
		if ((op2==1)||(op2==2)) {OpcDz^=op2;}	
				// if (OpcDz==3) OpcDz=op2;}
		}
		break;

		case 3:
		op2=1;
		while (op2>=0)
		{
		m_opcjei[1][1]=(OpcOp ? '' : '');
		m_opcjei[2][1]=(OpcBl ? '' : '');
		sprintf(&m_opcjei[3][5],OpcBl ? "%d " : lttab[66],OpcBl/1000);
		i=strlen(m_opcjei[4]);
		m_opcjei[4][i-1]=OpcPr?'1':'0';
		m_opcjei[4][i-2]=(OpcPr<0)?'-':'+';
		m_opcjei[5][1]=(OpcCe ? '' : '');
		m_opcjei[6][1]=(OpcBr ? '' : '');
		m_opcjei[7][1]=(OpcPa ? '' : '');
		m_opcjei[8][1]=(OpcZo ? '' : '');
			op2=Wybor(m_opcjei,op2,0,0);
			switch(op2)
			{ 
			case 1:	OpcOp=!OpcOp;				break;
			case 2: OpcBl=OpcBl ? 0 : 70000;	break;
			case 3:	stcl_d(txttmp,OpcBl/1000);
				if (PytTekst(lttab[96],txttmp,2))
				{stcd_l(txttmp,&OpcBl); OpcBl=abs(OpcBl)*1000; }
												break;
			case 4: if (++OpcPr>1) OpcPr=-1; Priorytet();	break;
			case 5: OpcCe=!OpcCe;				break;
			case 6:	OpcBr=!OpcBr;				break;
			case 7: OpcPa=!OpcPa;				break;
			case 8: OpcZo=!OpcZo;				break;
			case 10:	op2=-1;					break;
			}
		}
		break;
#ifndef _CD32_
		case 4:
		ZapOpcje();
		break;
#endif
	}
	}
}

HiScor(int wpis)
{
WORD d,i;
WORD y=0;
UWORD pat;

if (wpis) { MusicOn(muzyka,13); GoToPat(13); }
	else MusicOn(muzyka,18);
RYSEKRAN

wypiszliste:

BevelBox(50,30,270,240);
SetFont(menurp,ub8font);
SetAPen(menurp,1);
PiszLin(lttab[67],-93);
SetDrMd(menurp,JAM1);

	for (i=0;i<10;i++)
	{
	SetFont(menurp,ub16font);
	SetAPen(menurp,0);
	Move(menurp,76+2,70+18*i+2);
	Text(menurp,hiscor[i].imie,strlen(hiscor[i].imie));
	SetAPen(menurp,1);
	Move(menurp,76-1,70+18*i-1);
	Text(menurp,hiscor[i].imie,strlen(hiscor[i].imie));
	SetAPen(menurp,15);
	Move(menurp,76,70+18*i);
	Text(menurp,hiscor[i].imie,strlen(hiscor[i].imie));
	SetFont(menurp,ub8font);
	Move(menurp,54,70+18*i);
	sprintf(txttmp,"%d.",i+1);
	Text(menurp,txttmp,strlen(txttmp));
	Move(menurp,233,70+18*i-1);
	if (hiscor[i].lev<19) sprintf(txttmp,"%c%d",*lttab[95],hiscor[i].lev);
		else strcpy(txttmp,"!!!");
	Text(menurp,txttmp,strlen(txttmp));
	sprintf(txttmp,"%d",hiscor[i].pkt);
	Move(menurp,268-8*strlen(txttmp),70+18*i-9);
	SetAPen(menurp,1);
	Text(menurp,txttmp,strlen(txttmp));
	}	

if (wpis)
	{
	for (i=0;i<10;i++)
	if (hiscor[i].pkt<score)
	{
	Wylatuje();
	if (i<9)
	for (d=0;d<18;d++)
		{ ScrollRaster(menurp,0,-1,73,70+18*i-15,268,70+18*9+2); WaitTOF(); }
	for (d=9;d>i;d--)	CopyMem(&hiscor[d-1],&hiscor[d],sizeof(hiscor[0]));
	sprintf(txttmp,lttab[68],i+1);
	*hiscor[i].imie=0;
	PiszLin(txttmp,-30);
	ClearPort(MesPort);
	PytTekst(lttab[101],hiscor[i].imie,9);
	hiscor[i].pkt=score;
	hiscor[i].lev=poziom+1;
	if (!*hiscor[i].imie) strcpy(hiscor[i].imie,lttab[69]);
	y=70+18*i-17;
	wpis=0;
#ifndef _CD32_
ZapHisco();
#endif
	goto wypiszliste;
	}
	}

ModifyIDCMP(menuwin,IDCMP_VANILLAKEY | IDCMP_MOUSEBUTTONS);
SetFont(menurp,ub16font);
d=strlen(hiscor[0].imie);
i=0; pat=0;
SetBPen(menurp,0);
while (!Nacisniete())
	{
	if (++i>d) i=0;
	GutDelay1();
	Move(menurp,76,70);
	SetAPen(menurp,15);
	SetDrMd(menurp,JAM1);
	Text(menurp,hiscor[0].imie,i);
	if (i<d)
		{ SetAPen(menurp,1); Text(menurp,&hiscor[0].imie[i],1); }
	if (y)
		{
		SetDrMd(menurp,JAM2);
		if (!(pat<<=1)) pat=0x3333;
		SetDrPt(menurp,pat);
		SetAPen(menurp,47);
		Move(menurp,74,y);
		Draw(menurp,70+151,y);
		Draw(menurp,70+151,y+19);
		Draw(menurp,74,y+19);
		Draw(menurp,74,y);
		SetDrPt(menurp,0xffff);
		}
	}
GoToPat(18);
}

Wylatuje()
{
WORD x;

LoadRGB4(menuvp,spychpaleta,32);

	spr[0].height=16;
	spr[1].height=16;
	spr[1].y=spr[0].y=70+18*9-14;

full=1;
ClearPort(MesPort);

for (i=80;i>=0;i-=3)
	{
	spr[0].x=75-i-16;
	spr[1].x=75+143+i;
	ChangeSprite(menuvp,&spr[0],spradat+10*SPRITASIZ);
	ChangeSprite(menuvp,&spr[1],spradat+11*SPRITASIZ);
	Czekanie(1);
	}
SetBPen(menurp,9);

for (i=73;i>0;i--)
	{
	spr[0].x=75+73-i-16;
	spr[1].x=75+143-73+i;
	ChangeSprite(menuvp,&spr[0],spradat+10*SPRITASIZ);
	ChangeSprite(menuvp,&spr[1],spradat+11*SPRITASIZ);
	x=((rand()&255)*i)/256;	
	ScrollRaster(menurp,-1,0,149-i,70-15+18*9,151-x,70+2+18*9);
	x=((rand()&255)*i)/256;	
	ScrollRaster(menurp,1,0,148+x,70-15+18*9,150+i,70+2+18*9);
	Czekanie(1);
	}
	spr[3].y=70+18*9-1;
	spr[3].x=147;
	spr[3].height=16;
	ChangeSprite(menuvp,&spr[3],spradat+15*SPRITASIZ);
	SetAPen(menurp,9);
	RectFill(menurp,147,70+18*9-15,150,70+18*9+2);

for (i=72;i>50;i--)
	{
	spr[0].x=75+i-16;
	spr[1].x=75+143-i;
	ChangeSprite(menuvp,&spr[0],spradat+10*SPRITASIZ);
	ChangeSprite(menuvp,&spr[1],spradat+11*SPRITASIZ);
	Czekanie(1);
	}
	spr[2].y=70+18*9-14;
	Ruch(2,114,70+18*9-14,140,70+18*9-14,12,13,3,20);
	spr[2].height=16;
	ChangeSprite(menuvp,&spr[2],spradat+13*SPRITASIZ);	
GutDelay(10);
	ChangeSprite(menuvp,&spr[2],spradat+14*SPRITASIZ);	
	Ruch(3,147,70+18*9-1,320,100,15,15,999,20);
	Ruch(2,140,70+18*9-14,114,70+18*9-14,16,17,3,20);
GutDelay(10);
	ChangeSprite(menuvp,&spr[0],spradat+11*SPRITASIZ);
	ChangeSprite(menuvp,&spr[1],spradat+10*SPRITASIZ);
GutDelay(10);
for (i=50;i>-90;i-=5)
	{
	spr[0].x=74+i-16;
	spr[1].x=74+143-i;
	ChangeSprite(menuvp,&spr[0],spradat+11*SPRITASIZ);
	ChangeSprite(menuvp,&spr[1],spradat+10*SPRITASIZ);
	Czekanie(1);
	}

spr[0].height=0;
spr[1].height=0;
ChangeSprite(menuvp,&spr[0],spradat+11*SPRITASIZ);
ChangeSprite(menuvp,&spr[1],spradat+10*SPRITASIZ);
MenuSpritOff();
LoadRGB4(menuvp,menupaleta,32);
}

PiszLin(char *txt,WORD y)
{
WORD d=strlen(txt),dg;

dg=TextLength(menurp,txt,d);
BevelBox(150-dg/2,128+y,170+dg/2,128+y+10+menurp->TxHeight);
Move(menurp,160-dg/2,128+y+menurp->TxBaseline+5);
SetBPen(menurp,9);
Text(menurp,txt,d);

}

PiszText(WORD x,WORD y,char *teksty[])
{
while (*teksty)
	{
	Move(menurp,x,y);
	Text(menurp,*teksty,strlen(*teksty));
	y+=10;
	teksty++;
	}
}

SpritLoad()
{
if (splostan) return;

LoadRGB4(menuvp,menupaleta,32);
spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=30;
spr[0].x=spr[1].x=4;
spr[0].y=spr[1].y=220;
spr[2].x=spr[3].x=4+16;
spr[2].y=spr[3].y=220;

for (i=0;i<4;i++)
	 ChangeSprite(menuvp,&spr[i],sloadtabdis[i]);
loadanim=0;

 AddIntServer(5,&interr);
splostan=1;
}

SpritLoadOff()
{
if (!splostan) return;
spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=0;
for (i=0;i<4;i++)
	 ChangeSprite(menuvp,&spr[i],&spritblank);

 RemIntServer(5,&interr);
 MenuSpritOff();
splostan=0;
}

WORD zapispalety[32];

SavePal()
{
WORD i;
for (i=0;i<32;i++) zapispalety[i]=GetRGB4(menuvp->ColorMap,i);
}

__far SpritDisk(WORD d)
{
SavePal();
LoadRGB4(menuvp,menupaleta,32);

spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=30;
spr[0].x=spr[1].x=3;
spr[0].y=spr[1].y=220;
spr[2].x=spr[3].x=3+16;
spr[2].y=spr[3].y=220;

SprDisk=d;

for (i=0;i<4;i++)
	 ChangeSprite(menuvp,&spr[i],sloadtabdis[i]);
loadanim=0;

 AddIntServer(5,&interr2);
}

__far SpritDiskOff()
{
 RemIntServer(5,&interr2);
 MenuSpritOff();
LoadRGB4(menuvp,zapispalety,32);
}


APTR ReadFile(char *naz,ULONG *dlug)
{
APTR file,mem=0; ULONG len;
if (file=MOpen(naz,MODE_OLDFILE))
	{
	Seek(file,0,OFFSET_END);
	len=Seek(file,0,OFFSET_BEGINNING);
	if (len) *dlug=len;
	if (mem=malloc(len))
		Read(file,mem,len);
	Close(file);
	}
return mem;
}

MenuInit()
{
APTR file;

ULONG extens[]={SA_DisplayID,0x00021800,TAG_END};
struct ExtNewScreen daneekr=
	{0,0,	320,256,6,	1,0,
	0x800,CUSTOMSCREEN | SCREENQUIET | SCREENBEHIND, //| NS_EXTENDED,
	0,0,0,0,
	0};
struct NewWindow daneokna={
	0,0,	320,256,
	-1,-1,
	IDCMP_VANILLAKEY | IDCMP_MOUSEBUTTONS,
	WFLG_SMART_REFRESH | WFLG_NOCAREREFRESH
	 | WFLG_BACKDROP | WFLG_BORDERLESS
     | WFLG_ACTIVATE | WFLG_RMBTRAP,
	NULL,NULL,NULL,NULL,NULL,
	0,0,0,0,
	CUSTOMSCREEN};

daneekr.Extension=extens;
menuekr=OpenScreen(&daneekr);
daneokna.Screen=menuekr;
menuwin=OpenWindow(&daneokna);
MesPort=menuwin->UserPort;
waitinput=1<<menuwin->UserPort->mp_SigBit;

menuvp=&(menuekr->ViewPort);
menurp=&(menuekr->RastPort);
LoadRGB4(menuvp,menupaleta,32);

// inicjacja z loctext
#ifdef _CD32_
m_funkcje[0]=lttab[21];
m_funkcje[1]=lttab[22];
m_funkcje[2]=lttab[134];
m_funkcje[3]=lttab[23];
m_funkcje[4]=lttab[26];
m_funkcje[5]=lttab[27];
m_funkcje[6]=lttab[28];
m_funkcje[7]=lttab[29];
m_funkcje[8]=0;
*lttab[37]='0';
#else
m_funkcje[0]=lttab[21];
m_funkcje[1]=lttab[22];
m_funkcje[2]=lttab[23];
m_funkcje[3]=lttab[24];
m_funkcje[4]=lttab[25];
m_funkcje[5]=lttab[26];
m_funkcje[6]=lttab[27];
m_funkcje[7]=lttab[28];
m_funkcje[8]=lttab[29];
m_funkcje[9]=0;
#endif

m_koniec[0]=lttab[30];
m_koniec[1]=lttab[31];
m_koniec[2]=lttab[32];
m_koniec[3]=0;

m_opcje[0]=lttab[33];
m_opcje[1]=lttab[34];
m_opcje[2]=lttab[35];
m_opcje[3]=lttab[36];
m_opcje[4]=lttab[37];
m_opcje[5]="0 ";
m_opcje[6]=lttab[38];
m_opcje[7]=0;

m_opcjeg[0]=lttab[39];
m_opcjeg[1]=lttab[40];
m_opcjeg[2]=lttab[41];
m_opcjeg[3]=lttab[104];
m_opcjeg[4]=lttab[42];
m_opcjeg[5]=lttab[43];
m_opcjeg[6]=lttab[44];
m_opcjeg[7]=lttab[45];
m_opcjeg[8]="0 ";
m_opcjeg[9]=lttab[38];
m_opcjeg[10]=0;

m_opcjed[0]=lttab[46];
m_opcjed[1]=lttab[47];
m_opcjed[2]=lttab[48];
m_opcjed[3]="0 ";
m_opcjed[4]=lttab[38];
m_opcjed[5]=0;

m_opcjei[0]=lttab[49];
m_opcjei[1]=lttab[50];
m_opcjei[2]=lttab[51];
m_opcjei[3]=lttab[52];
m_opcjei[4]=lttab[98];
m_opcjei[5]=lttab[105];
m_opcjei[6]=lttab[127];
m_opcjei[7]=lttab[128];
m_opcjei[8]=lttab[106];
m_opcjei[9]="0 ";
m_opcjei[10]=lttab[38];
m_opcjei[11]=0;

sprintf(infotxt[0],lttab[55],WERSJA);
sprintf(infotxt[1],lttab[56],DATA);
strcpy(infotxt[3],lttab[57]);
strcpy(infotxt[2]," ");

m_OK[0]=lttab[53];
m_OK[1]=0;

m_wczyt[0]=lttab[97];
m_wczyt[1]=0;

m_OpMe[0]=lttab[38];
m_OpMe[1]=m_opow;
strcpy(m_opow,lttab[50]+2);
m_OpMe[2]=lttab[107];
m_OpMe[3]=0;

for (i=0;i<10;i++) infotab[i]=infotxt[i];
infotab[7]=0;
for (i=0;i<17;i++) helptab[i]=lttab[109+i];
helptab[17]=0;
for (i=0;i<3;i++) ostrztab[i]=lttab[130+i];
ostrztab[3]=0;

if ((Timer_Port = CreatePort("UBEK Timer", 0)) == NULL)
		return(1) ;
if (OpenDevice(TIMERNAME, UNIT_VBLANK, (char *) &Time_Req, 0) != NULL)
		return(1) ;
waittimer=1 << Timer_Port -> mp_SigBit;
Time_Req . tr_node . io_Message . mn_ReplyPort = Timer_Port ;
Time_Req . tr_node . io_Command = TR_ADDREQUEST ;
Time_Req . tr_node . io_Flags = 0 ;
Time_Req . tr_node . io_Error = 0 ;

if (menubm.Depth)	
	RYSEKRAN
	else
	{
	struct BitMap t_bm;
	struct RastPort t_rp;
	char *an; long len;
	PPLoadData("pic/intro",&an,&len,1);
	if (an)
		{
		SetRGB4(menuvp,1,9,9,9);
		ScreenToFront(menuekr);
		InitRastPort(&t_rp);
		InitBitMap(&t_bm,1,320,256);
		t_rp.BitMap=&t_bm;
		t_bm.Planes[0]=menuekr->RastPort.BitMap->Planes[0];
		MusicOn(muzyka,36);
		PlayAn(an,len,&t_rp,0,48,4);
		FreeMem(an,len);
		full=1;	
		Czekanie(150);
		for (len=8;len>=0;len--) { SetRGB4(menuvp,1,len,len,len); GutDelay1(); }
		SetRast(menurp,0);
		LoadRGB4(menuvp,menupaleta,32);
		SetAPen(menurp,1);
		MusicOff();
		}
	PiszLin(lttab[54],0);
	ClearPort(MesPort);
	}

ScreenToFront(menuekr);

#ifdef _CD32_
LoadIFF(&menubm,"pic/tytul.CD");
#else
LoadIFF(&menubm,"pic/tytul");
#endif
ub16font=OpenDiskFont(&ub16txt);
ub8font=OpenDiskFont(&ub8txt);
obrpuste=ReadFile("pic/puste",0);
if (ub16font&&ub8font) return 0;
return 1;
}

MenuClose()
{
if (menuwin) CloseWindow(menuwin);
if (menuekr) CloseScreen(menuekr);
if (ub16font) CloseFont(ub16font);
if (ub8font) CloseFont(ub8font);
FreeIFF(&menubm);
free(obrpuste);
AbortIO((char *) &Time_Req . tr_node) ;
if (Time_Req . tr_node . io_Message . mn_ReplyPort)
					CloseDevice(&Time_Req) ;
if (Timer_Port) DeletePort(Timer_Port) ;
}

SetTimer()
{
    Time_Req . tr_time . tv_secs = 0 ;
    Time_Req . tr_time . tv_micro = OpcBl;
    SendIO((char *) &Time_Req . tr_node) ;
}

GutDelay1()
{
    Time_Req . tr_time . tv_secs = 0 ;
    Time_Req . tr_time . tv_micro = 20000;
    SendIO((char *) &Time_Req . tr_node) ;
	Wait(waittimer);
	GetMsg(Timer_Port);
}

GutDelay(WORD cz)
{
    Time_Req . tr_time . tv_secs = 0 ;
    Time_Req . tr_time . tv_micro = cz*20000;
    SendIO((char *) &Time_Req . tr_node) ;
	Wait(waittimer);
	GetMsg(Timer_Port);
}
