#include <graphics/gfxbase.h>
#include <graphics/gfx.h>
#include <intuition/screens.h>
#include <dos/dos.h>
#include <dos/dosextens.h>
#include "obiekty.h"
#include "all_protos.h"

extern struct DosLibrary *DOSBase;

extern WORD OpcGr,OpcCe;
extern WORD celx,myszx,myszy;

#define min(a,b) __builtin_min(a,b)

extern WORD *buf,*buf_end;
#define SZER 64
#define WYS 100

#define MEMFORCOP WYS*276+500

__far extern char *lttab[],*pliktab[];

__far WORD tabodl[2*SZER];
__far WORD *to_end=tabodl+SZER;
WORD *zaoknem;


/* rodzaje ta:	Z	N

			0	*   b
			1	*	*
			2	*	b,w*
			3	*	w*
			4	+	b

*/

void (*RysTloPelne[])()=
		{&RysBackdrop,&Rysp,&Nic,
		&Rys_sp,&Nic,&Nic,
		&RysBackdrop,&Rysswys,&Rysp,
		&Rysswys,&Rysp,&Nic,
		&RysBackdrop,&Rysp2,&Nic,
		&RysBackdrop,&Rysswys,&Rysp2,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		};
void (*RysTloJedno[])()=
		{&RysBackdrop,&Rysp2,&Nic,
		&Rys_sp2,&Nic,&Nic,
		&RysBackdrop,&Rysswys2,&Rysp2,
		&Rysswys2,Rysp2,&Nic,
		&RysBackdrop,&Rysp2,&Nic,
		&RysBackdrop,&Rysswys2,&RysPod,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		};
void (*RysTloGladkie[])()=
		{&RysBackdrop,&RysPod,&Nic,
		&RysSufPod,&Nic,&Nic,
		&RysBackdrop,&RysPod,&Nic,
		&RysSufPod,&Nic,&Nic,
		&RysBackdrop,&Rysp2,&Nic,
		&RysBackdrop,&RysPod,&Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		Nic,Nic,Nic,
		};

extern __far ULONG spritblank;

extern struct gfx a_track;
extern WORD usetrack;
extern struct gfx gfx[];
__far extern struct gfx gfx_bis[];
WORD gfx_cache=0;
__far extern struct mur mur[];
__far extern struct pkt pkt[];
extern struct rodzaj jakisrodzaj;
extern struct obiekt obiekt[];
#define MAXOBUCKET 300
extern __far APTR obucket[MAXOBUCKET];
#define MAXMBUCKET 300
extern __far APTR mbucket1[MAXMBUCKET];
extern __far APTR mbucket2[MAXMBUCKET];

extern ULONG	*ww;
extern struct mur	*wm;
extern struct obiekt	*wo;

extern WORD boli;
extern WORD camx,camy;
extern BYTE camh;

extern WORD poziom;
void (*RysTlo)();
void (*RysTlo2)();
void (*RysTlo3)();
extern WORD OpcPS;

extern WORD lmur,lmu2,lob,lpkt,los;

__far extern char *naztab[];

#define WIELPS 32
__far UBYTE tabpod2[WIELPS*WIELPS],tabsuf2[WIELPS*WIELPS];
__far ULONG tabpod[WIELPS*WIELPS],tabsuf[WIELPS*WIELPS];
ULONG podgfx,sufgfx;

struct Screen *ekr;
struct Window *ewin;
char *ekrPort;
struct ViewPort *ekrvp;
struct BitMap *ekrbm;

extern struct	Window		*menuwin;
__far extern UWORD celownik[];

extern struct Screen *statekr;

__far WORD *copper;
UBYTE *BPlanes,*bp;
LONG __far BitPlanes[]=
		{
		0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f,
		0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f,0x0f0f0f0f,
		
		0x00ff00ff,0x00ff00ff,0x00ff00ff,0x00ff00ff,
		0x00ff00ff,0x00ff00ff,0x00ff00ff,0x00ff00ff,
		
		0x0000ffff,0x0000ffff,0x0000ffff,0x0000ffff,
		0x0000ffff,0x0000ffff,0x0000ffff,0x0000ffff,
		
		0x00000000,0xffffffff,0x00000000,0xffffffff,
		0x00000000,0xffffffff,0x00000000,0xffffffff,
		
		0x00000000,0x00000000,0xffffffff,0xffffffff,
		0x00000000,0x00000000,0xffffffff,0xffffffff,
		
		0x00000000,0x00000000,0x00000000,0x00000000,
		0xffffffff,0xffffffff,0xffffffff,0xffffffff};

APTR copbuf;

BYTE *tabrgb;
__far BYTE *ZrobTabRGB();

char stri[100],str2[100];
extern WORD a,b;
WORD g,s,p1,p2;

WORD lastobx,lastoby,lastobs,lastobw;
struct obiekt *lastob;
WORD wiadt;

#define BP(x) (((ULONG)x)<<2)

int CzyJestD(char *naz)
{
struct DeviceList *elem;
int len=strlen(naz),jest=0,n=0;
elem=BP(((struct DosInfo*)BP(DOSBase->dl_Root->rn_Info))->di_DevInfo);
while (elem)
	{
	if (len==*((BYTE*)BP(elem->dl_Name)))
		if (!strnicmp(naz,(((BYTE*)BP(elem->dl_Name))+1),len))
		if (elem->dl_Type==DLT_VOLUME)
			{ if (elem->dl_Task) jest=1; break; }
		else { jest=1; break; }
	elem=BP(elem->dl_Next);
	if (n++>1000) break; 
	}
return jest;
}

char * SzukDysk(char *pli,char *path,int wszystkie)
	// wszystkie=0 -> tylko dostpne
	// return: dysk na ktorym bylo
{
static char niemoz[]="ram:thatsimpossible!";
int jest,d,faza;
char **lista,*vol,*dysk=0;

// printf("Szukdysk(%s,...,%c)",pli,wszystkie ? '+':'-');
if (!pliktab[1])
	{ strcpy(path,pli); return 0; }

for (faza=0;faza<2;faza++)
	{
	lista=pliktab+1; d=-1;

	while ((**lista)!='#')	
		{
		if ((**lista)==':')
			{ jest=CzyJestD((*lista)+1); d++;
			  vol=(*lista)+1; }
		else
			if (!stricmp(pli,*lista))		// jest na licie
			{
			dysk=vol;
			if (faza && wszystkie)
				{
				// printf("faza II - potrzebny dysk %s\n",vol);
				DajDysk(vol); jest=1;
				}
			if (jest)
				{
				sprintf(path,"%s:%s",vol,pli);
				// printf("  -> %s\n",path);
				return 0;
				}
			}
		lista++;
		}
	if (!wszystkie) goto niema;
	}

niema:
if (dysk) strcpy(path,niemoz); else strcpy(path,pli);
// printf("  -> %s, dysk %s\n",path,dysk);
return dysk;
}

APTR MOpen(char *file,long access)
{
char path[100];
SzukDysk(file,path,1);
return (*path)?Open(path,access):0;
}

APTR PPOpen(char *naz)
{
APTR file; ULONG id,len;
APTR mem;
if (file=MOpen(naz,MODE_OLDFILE))
	{
	Read(file,&id,4);
	if (id=='PP20')
		{
		Close(file);
		PPLoadData(naz,&mem,&len,1);
		if ((mem)&&(file=Open("ram:UBEK_tmp2",MODE_NEWFILE)))
			{
			Write(file,mem,len);
			Close(file);
			FreeMem(mem,len);
			return(Open("ram:UBEK_tmp2",MODE_OLDFILE));
			}
		return 0;
		}
	else
		{
		Seek(file,0,OFFSET_BEGINNING);
		return file;
		}
	}
else return 0;
}

KillGfxCache()
{
WORD i;
if (!gfx_cache) return;
for (i=1;i<MAXGFX;i++)
	if ((*gfx_bis[i].nazwa)&&(gfx_bis[i].dane))
	{
	free(gfx_bis[i].dane);
	gfx_bis[i].dane=0;
	*gfx_bis[i].nazwa=0;
	}
gfx_cache=0;
}

FreeGfx()
{
WORD i;
for (i=1;i<MAXGFX;i++)
	if ((*gfx[i].nazwa)&&(gfx[i].dane))
	{
	free(gfx[i].dane);
	gfx[i].dane=0;
	}
}

DajDysk(char *naz)
{
if (CzyJestD(naz)) return;
SpritLoadOff();
SpritDisk((naz[strlen(naz)-1]&0xf)-1);
while (!CzyJestD(naz)) Delay(30);
SpritDiskOff();
}

LoadGfx(WORD testmode)
{
WORD i=1,j,k,dobrze,biore,jest=0,mabyc;
char *dysk,*dy;

dobrze=1;

while (*gfx[i].nazwa)
	{
	if (gfx[i].dane) free(gfx[i].dane);
	for (k=1;k<MAXGFX;k++)
		{
		if ((!strcmp(gfx[i].nazwa,gfx_bis[k].nazwa))
			&&gfx_bis[k].dane
			&&gfx_bis[k].typ==gfx[i].typ)
			{ CopyMem(&gfx_bis[k],&gfx[i],sizeof(struct gfx));
			gfx_bis[k].dane=0;
			*gfx_bis[k].nazwa=0;
			jest++;
			 goto bylo_w_cache; }
		}
		dobrze=0;

	bylo_w_cache:

	i++;
	}
	// zaladowana grafika z cache

mabyc=i-1;
if (!testmode)
	{
	ProcentInit();
	Procent((jest<<8)/mabyc);
	}

KillGfxCache();
	// niepotrzebny cache zlikwidowany

while (!dobrze)
{
dobrze=1;
dysk=0;
i=1;
while (*gfx[i].nazwa)
{
  if (!gfx[i].dane)
  {
		if (gfx[i].typ&256)
		{
		strmfn(stri,0,"sfx",gfx[i].nazwa,0);
		if (dy=SzukDysk(stri,str2,0)) if (!dysk) dysk=dy;
		Load8SVX(str2,&gfx[i]);
		}
		else
		{
		strmfn(stri,0,"gfx",gfx[i].nazwa,0);
		if (dy=SzukDysk(stri,str2,0)) if (!dysk) dysk=dy;
		if (gfx[i].typ&1)	gfx[i].dane=LoadSUwall(str2,&gfx[i].szer);
			else		gfx[i].dane=LoadSUim(str2,&gfx[i].szer);
		}

	gfx[i].szer/=gfx[i].fazy+1;
	for (j=0;j<=gfx[i].fazy;j++)
		gfx[i].danf[j]=gfx[i].dane+j*(gfx[i].wys*gfx[i].szer);

	if (!gfx[i].dane) dobrze=0; else jest++;

if (!testmode)	Procent((jest<<8)/mabyc);
  }
	i++;
}
if (testmode) break;
if (!dobrze) if (dysk) DajDysk(dysk);
}

}

MemorizeGfxCache()
{
WORD i;
if (gfx_cache) KillGfxCache();
for (i=1;i<MAXGFX;i++) if ((*gfx[i].nazwa)&&gfx[i].dane)
	{ CopyMem(&gfx[i],&gfx_bis[i],sizeof(struct gfx));
		gfx[i].dane=0; }
	else { *gfx_bis[i].nazwa=0; gfx_bis[i].dane=0; }
gfx_cache=1;
}


CzytSyt(APTR file)
{
WORD size,n,i;
BYTE b;

	MemorizeGfxCache();

	Read(file,&n,2);
	Read(file,&size,2);
	size=min(size,sizeof(struct gfx));
	for (i=1;i<=n;i++)
	{
	Read(file,&gfx[i],size);
	gfx[i].dane=0;
	}
	for (;i<=MAXGFX;i++)
	{ gfx[i].dane=0; *gfx[i].nazwa=0; }

	Read(file,&lpkt,2);
	Read(file,&size,2);
	size=min(size,sizeof(struct pkt));
	for (i=1;i<=lpkt;i++)
	Read(file,&pkt[i],size);

	Read(file,&lmur,2);
	Read(file,&size,2);
	size=min(size,sizeof(struct mur));
	for (i=1;i<=lmur;i++)
	Read(file,&mur[i],size);

	Read(file,&lob,2);
	Read(file,&size,2);
	size=min(size,sizeof(struct obiekt));
	for (i=1;i<=lob;i++)
	Read(file,&obiekt[i],size);

	Read(file,&camx,2);
	Read(file,&camy,2);
	Read(file,&camh,1);

	Read(file,tabsuf2,WIELPS*WIELPS);
	Read(file,tabpod2,WIELPS*WIELPS);
}

ZapiszSyt(APTR file)
{
WORD size,n,i;

	n=1;
	while (gfx[n++].nazwa[0]); n--;
	Write(file,&n,2);
	size=sizeof(struct gfx);
	Write(file,&size,2);
	for (i=1;i<=n;i++)
	Write(file,&gfx[i],size);

	Write(file,&lpkt,2);
	size=sizeof(struct pkt);
	Write(file,&size,2);
	for (i=1;i<=lpkt;i++)
	Write(file,&pkt[i],size);

	Write(file,&lmur,2);
	size=sizeof(struct mur);
	Write(file,&size,2);
	for (i=1;i<=lmur;i++)
	Write(file,&mur[i],size);

	Write(file,&los,2);
	size=sizeof(struct obiekt);
	Write(file,&size,2);
	for (i=1;i<=los;i++)
	Write(file,&obiekt[i],size);

	Write(file,&camx,2);
	Write(file,&camy,2);
	Write(file,&camh,1);

	Write(file,tabsuf2,WIELPS*WIELPS);
	Write(file,tabpod2,WIELPS*WIELPS);
}

WczytajMape(char *plik)
{
#define MapID 'Map!'
APTR file;
ULONG TestID;

	if (file=PPOpen(plik,MODE_OLDFILE))
		{	
		Read(file,&TestID,4);
		if (TestID==MapID)
			CzytSyt(file);
		Close(file);
		}
}

ZrobTlo()
{
	for (a=0;a<WIELPS*WIELPS;a++)
	{
	if (tabpod2[a]) tabpod[a]=gfx[tabpod2[a]].dane;
			else	tabpod[a]=0;
	if (tabsuf2[a]) tabsuf[a]=gfx[tabsuf2[a]].dane;
			else	tabsuf[a]=0;
	}
switch (OpcPS&3)
	{case 0:	RysTlo=RysTloPelne[3*mur[1].dx];
				RysTlo2=RysTloPelne[3*mur[1].dx+1];
				RysTlo3=RysTloPelne[3*mur[1].dx+2];

		break;
	case 1:		RysTlo=RysTloJedno[3*mur[1].dx];
				RysTlo2=RysTloJedno[3*mur[1].dx+1];
				RysTlo3=RysTloJedno[3*mur[1].dx+2];
				podgfx=tabpod[0];
				sufgfx=tabsuf[0];
		break;
	case 2:		RysTlo=RysTloGladkie[3*mur[1].dx];
				RysTlo2=RysTloGladkie[3*mur[1].dx+1];
				RysTlo3=RysTloGladkie[3*mur[1].dx+2];
				sufgfx=Sredkol(tabsuf[0]);
				podgfx=Sredkol(tabpod[0]);
		break;
	}

}

rys()
{
static WORD lotime=0,lox,loy,lox2,loy2,lobx,loby,lobs,lobw;
static struct obiekt *lob;

	(*RysTlo)();
	(*RysTlo2)();
	(*RysTlo3)();
	
	for (s=0;s<SZER;tabodl[s++]=0);

if (lmu2)
for (ww=&mbucket2[0];ww<&mbucket2[MAXMBUCKET];ww++)
	if (wm=*ww)
		{
		*ww=0;
		p1=wm->p1; p2=wm->p2;
		if ((pkt[p1].odl) && (pkt[p2].odl)
		&&	(abs(pkt[p1].xe-pkt[p2].xe)<128))
			if (gfx[g=wm->gfx].typ&2)
			PutWallWys2(gfx[g].danf[wm->faza],pkt[p1].xe,pkt[p1].odl,
											pkt[p2].xe,pkt[p2].odl);
			else
			PutWallWys(gfx[g].danf[wm->faza],pkt[p1].xe,pkt[p1].odl,
											pkt[p2].xe,pkt[p2].odl);
		}
for (ww=&mbucket1[0];ww<&mbucket1[MAXMBUCKET];ww++)
	if (wm=*ww)
		{
		*ww=0;
		p1=wm->p1; p2=wm->p2;
		if ((pkt[p1].odl) && (pkt[p2].odl)
		&&	(abs(pkt[p1].xe-pkt[p2].xe)<128))
		if (gfx[g=wm->gfx].typ&2)
		PutWall2(gfx[g].danf[wm->faza],pkt[p1].xe,pkt[p1].odl,
											pkt[p2].xe,pkt[p2].odl);
		else
		PutWall(gfx[g].danf[wm->faza],pkt[p1].xe,pkt[p1].odl,
											pkt[p2].xe,pkt[p2].odl);
		}

lob=0;
for (ww=&obucket[MAXOBUCKET-40];ww>&obucket[0];ww--)
	if (wo=*ww)
	{
	*ww=0;
	if (wo->odl)
		if (gfx[g=wo->gfx].typ&64)
		PutImagTR(gfx[g].danf[wo->faza],wo->xe,wo->odl,gfx[wo->gfx].szer,
							gfx[wo->gfx].wys,wo->z);
			else
		PutImag(gfx[g].danf[wo->faza],wo->xe,wo->odl,gfx[wo->gfx].szer,
							gfx[wo->gfx].wys,wo->z);
		if ((tabodl[wo->xe]<wo->odl)&&(abs(wo->xe-celx)<8))
			{
			lobx=lastobx;
			loby=lastoby;
			lobw=lastobw;
			lobs=lastobs;
			lob=wo;
			}
	}
		lotime++;
	if (!--wiadt)
	{
	wiadt=1;
	if (lob!=lastob)
		{
			lastob=lob;
			lotime=0;
			lox=0; loy=0;
			lox2=63; loy2=99;
			if ((lastob)&&(b=lastob->txt))
			{
			StatText(naztab[b],naztab[b+1]-naztab[b]-1);
			 Play8SVX(&a_track,2,1,64,0);
			}
			else
			StatText(0,0);
		}
		if (usetrack)
		{
		RCelow(lox,loy,lox2,loy2);
		lox=(lox+lobx)/2;
		loy=(loy+loby)/2;
		lox2=(lox2+lobx+lobs)/2;
		loy2=(loy2+loby+lobw)/2;
		}
		else
		if ((lotime<15)||((lotime<30)&&(lotime&1)))
		{
		RProstok(lox,loy,lox2,loy2);
		lox=(lox+lobx)/2;
		loy=(loy+loby)/2;
		lox2=(lox2+lobx+lobs)/2;
		loy2=(loy2+loby+lobw)/2;
		}
	}
	if (boli>0) Boli();
}

rys2()
{
for (ww=&obucket[MAXOBUCKET-40];ww>&obucket[0];ww--)
	if (wo=*ww)
	{
	*ww=0;
	if (wo->odl)
		if (gfx[g=wo->gfx].typ&64)
		PutImagTR(gfx[g].danf[wo->faza],wo->xe,wo->odl,gfx[wo->gfx].szer,
							gfx[wo->gfx].wys,wo->z);
			else
		PutImag(gfx[g].danf[wo->faza],wo->xe,wo->odl,gfx[wo->gfx].szer,
							gfx[wo->gfx].wys,wo->z);
	}
}

Wiadom(char *txt,WORD czas)
{
StatText(txt,strlen(txt));
wiadt=czas;
}

Zoom(WORD *img)
{
	for (a=0;a<SZER;tabodl[a++]=0);
	for (a=10;a<56;a++)
		{
		DispConvert();
		PutImag(img,32,a,32,64,32);
		}
}

Boli()
{
register WORD a;
register char *b=buf;
for (a=SZER*WYS;a;a--)
	{*b=0xf; b+=2;}
}

Zalewanas(WORD kol,WORD ile)
{
WORD x,j,*b2,d;
for (;ile;ile--)
  {
  for (x=0;x<SZER;x++)
	{
	b2=buf+x;
	d=(rand()/123)&7;
	for (j=0;j<=d;j++)
		b2[SZER*j]=kol;
	b2+=SZER*(WYS-1-d);
	for (j=WYS-d;j;j--)
		{b2[SZER*d]=b2[0]; b2-=SZER;}
	}
  DispConvert();
  }
}

#define MEMF_CHIP (1<<1)
#define MEMF_CLEAR (1<<16)

__far ChuToPla(BYTE *ba, BYTE *pl)
{
WORD p,b;
BYTE w;

for (p=0;p<4;p++)
	{
		w=0;
		for(b=0;b<4;b++)
			{w<<=1; w|=(ba[b]>>p)&1;}
		pl[p]=w;
	}

}

__far BYTE *ZrobTabRGB()
{
BYTE *pam;
WORD r,g,b,k;
BYTE bajt[4];

if (!(pam=malloc(4096*4))) return 0;

for (r=0;r<16;r++)	
	for (g=0;g<16;g++)
		for (b=0;b<16;b++)
		{
		k=(r<<8)+(g<<4)+b;
		bajt[0]=r;
		bajt[1]=g;
		bajt[2]=b;
		bajt[3]=b;
		ChuToPla(bajt,pam+(k<<2));
		}
return pam;
}


__far DispClose()
{
CloseWindow(ewin);
if (ekr->UserData) ekr->FirstGadget=ekr->UserData;
CloseScreen(ekr);
if (OpcGr)
	{
free(tabrgb);
	}
else
	{
	RestoreCop();
	FreeMem(copper,MEMFORCOP);
	FreeMem(bp,6*32+2);
	}
}

__far DispOn()
{
int k;

struct BitMap *bm;
struct ExtNewScreen daneekr=
	{32,0,SZER*4,WYS*2,6,
	1,0,
	0x800,		/* HAM */
	CUSTOMSCREEN | SCREENQUIET | SCREENBEHIND,
	0,0,0,0};
struct NewWindow daneokna=
	{0,0,SZER*4,WYS*2,-1,-1,
	IDCMP_MOUSEBUTTONS | IDCMP_RAWKEY | IDCMP_INACTIVEWINDOW | IDCMP_ACTIVEWINDOW,
	WFLG_ACTIVATE | WFLG_BACKDROP | WFLG_RMBTRAP | WFLG_BORDERLESS,
	0,0,0,0,0,0,0,0,0,CUSTOMSCREEN};
ULONG nieprzes[]={ SA_Draggable, 0 ,0,0};
static __far UWORD paleta[] =
{
	0x0000,0x0fff,0x0008,0x0dbb,0x07a0,0x0442,0x0db0,0x0c43,0x0b88,0x0888,
	0x0102,0x0a76,0x0732,0x000e,0x0f97,0x0755,
	0x0360,0x0fff,0x0ccc,0x0888,0x0444,0x0000,0x0532,0x0853,0x0a73,0x0d94,
	0x0eb7,0x0ff0,0x0e83,0x0f00,0x0a30,0x00ff
};

for (k=SZER;k<2*SZER;tabodl[k++]=30000);

druga_szansa:

switch (OpcGr)
	{
	case 0:
		daneekr.LeftEdge=32;
		daneekr.Width=SZER*4;
		daneekr.Height=WYS*2-20;
		daneokna.Height=WYS*2-20;
		daneekr.ViewModes=0x800;
		daneekr.Type=CUSTOMSCREEN | SCREENQUIET | SCREENBEHIND | NS_EXTENDED;
		daneekr.Extension=nieprzes;
		break;
	case 1:
		daneekr.LeftEdge=32;
		daneekr.Width=SZER*4;
		daneokna.Height=WYS*2;
		daneekr.Height=WYS*2;
		daneekr.ViewModes=0x800;
		daneekr.Type=CUSTOMSCREEN | SCREENQUIET | SCREENBEHIND;
		break;
	case 2:
		daneekr.LeftEdge=192;
		daneekr.Width=SZER*4;
		daneekr.Height=WYS;
		daneokna.Height=WYS;
		daneekr.ViewModes=0x8800;
		daneekr.Type=CUSTOMSCREEN | SCREENQUIET | SCREENBEHIND;
		break;
	}

if (ekr=OpenScreen(&daneekr))
{
ekrvp=&(ekr->ViewPort);
ekrbm=ekr->RastPort.BitMap;
daneokna.Screen=ekr;
ewin=OpenWindow(&daneokna);
ekrPort=ewin->UserPort;
LoadRGB4(ekrvp,paleta,32);
ScreenToFront(ekr);	
}
else if (OpcGr==2) { OpcGr=1; goto druga_szansa; }

if (OpcGr)
	{
	tabrgb=ZrobTabRGB();
	bm=ekr->RastPort.BitMap;
	memset(bm->Planes[5],0xcc,bm->BytesPerRow*bm->Rows);
	memset(bm->Planes[4],0x77,bm->BytesPerRow*bm->Rows);
	if (OpcCe) SetPointer(ewin,celownik,16,14,-7,-7);
	ekr->UserData=0;
	}
else
	{
	ekr->UserData=ekr->FirstGadget;
	ekr->FirstGadget=0;
	copper=AllocMem(MEMFORCOP,MEMF_CHIP);
	bp=AllocMem(6*32+2,MEMF_CHIP);
	BPlanes=((ULONG)bp+2)&0xfffffffc;
	CopyMem(&BitPlanes,BPlanes,6*32);
	MakeCop(copper);
	CustomCop(copper);
	spritblank=0;
	}
}

DispConvert()
{
switch(OpcGr)
	{
	case 0: ChuToCop(buf,copbuf); break;
	case 1:	ChuToHAM(tabrgb,ekrbm,SZER>>3,WYS); break;
	case 2:	ChuToHAM2(tabrgb,ekrbm,SZER>>3,WYS);
	}
}
