#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <graphics/gfx.h>
#include <dos/dos.h>

#include <proto/exec.h>
#include <proto/graphics.h>

#include "obiekty.h"
#include "all_protos.h"

#define min(a,b) __builtin_min(a,b)
#define max(a,b) __builtin_max(a,b)

extern struct IntuitionBase *IntuitionBase;
extern unsigned long _MemType;

__far extern aktu_has[10];
__far extern char *lttab[];

UWORD tpersp[256];		/* perspektywa: wysokosc odcinka 256 w odl. d */
WORD tsi[256];		/* sinus dla 64 ktw (do poruszania si */
WORD tsi2[10][256];		/* sinus dla 64 ktw (do poruszania ob */
UBYTE tatan[257];
UWORD todl[256];
UWORD poprawka[256];

__far WORD tabmisz[100];
extern struct obiekt *lastob;
extern WORD OpcDz,OpcOp,OpcPS,OpcGr,OpcCe,OpcZo,OpcPa;
extern ULONG OpcBl;
WORD helpwanted=0;
extern struct Screen *ekr;
extern struct	Screen		*menuekr;
extern char txttmp[100];

extern __far WORD tabodl[];
extern WORD *zaoknem;
extern APTR	podgfx;

extern void (*RysTlo)();
extern void (*RysTlo2)();
extern void (*RysTlo3)();

WORD *znaki;
WORD *brawo;
char napis[20];

#define SZER 64
#define WYS 100


struct gfx gfx[MAXGFX];
__far struct gfx gfx_bis[MAXGFX];
__far struct pkt pkt[MAXPKT];
__far struct mur mur[MAXSCI];
WORD lmu2,lmur,lpkt,lob,los;
				// los = ostatni dzwiek tla
				// lob = ostatni obiekt zwykly

struct obiekt obiekt[MAXOB];

#define MAXOBUCKET 300
__far APTR obucket[MAXOBUCKET];
#define MAXMBUCKET 300
__far APTR mbucket1[MAXMBUCKET];
__far APTR mbucket2[MAXMBUCKET];

UWORD camx=130*256,camy=128*256;
UWORD xbezkol,ybezkol;
UBYTE camh=0;
WORD rotv=0,vx=0,vy=0;
WORD fire,firet;

extern __far ULONG tabpod[],tabsuf[];
extern __far BYTE tabpod2[],tabsuf2[];
#define WIELPS 32

extern WORD bronx,brony;
extern struct MsgPort *MesPort,*ekrPort;
extern ULONG waitinput;
extern WORD boli;
extern struct obiekt *lastob;
extern WORD zappoz,zapene,zappocz;

UWORD tuptup;
ULONG stoi;
WORD celx=32,myszx,myszy;
#define TUPLEN 200

#define WIDACOB (Kolizlin(camx,camy,wo->x,wo->y)||((!(wo->xe&0xC0)&&(tabodl[wo->xe]<wo->odl))))

struct MsgPort *TestPort=0, *CreatePort();
struct UBEKMes
	{ struct Message	execmes;
	  WORD lpkt;
	  WORD lmur;
      WORD lob;
      struct pkt* pkt;
      struct mur* mur;
      struct obiekt* obiekt;
      struct gfx* gfx;
	  BYTE *tabpod;
	  BYTE *tabsuf;
	  UWORD camx,camy;
      BYTE camh;

	} *UBEKMes;

UBYTE flipanim=0;

__far struct mam	mam[MAXMAM];
__far struct przedmiot
	{WORD	moc,	zasieg,	rozrzut,	amu,	delay,	len,	obiekt;}
	przedmiot[]
	=
	{		0,		0,		0,			0,		0,		0,		0,
			50,		35,		10,			0,		5,		4,		0, 
			110,	150,	2,			1,		6,		2,		0,
			200,	150,	4,			2,		3,		2,		0,
			300,	200,	6, 			2, 		4,		3,		0,
			20,		30,		15,			0,		6,		5,		0,
			0,		0,		0,			0,		6,		4,		0,
			0,		0,		0,			0,		6,		4,		0,
			0,		0,		0,			0,		4,		3,		0,
			0,		0,		0,			0,		5,		4,		0,
			0,		0,		0,			999,	0,		-3,		0,
			0,		0,		0,			999,	0,		-4,		0,
			0,		0,		0,			0,		3,		2,		0,
 };
WORD usetrack=0;
WORD energ=0,amu,wybbron,score,jade;
extern ULONG s_czas,s_krok,s_fire;
extern WORD ktoryraz;
__far struct DateStamp s_ds;

#define GFX_EXPLO	1
#define GFX_WIDOK	2
#define GFX_OGIEN	3
#define SFX_DRZWI	4
#define GFX_BIGBANG 5
#define GFX_GROB	6
#define	SFX_OGIEN	7
#define GFX_REKA	8
#define GFX_POPIOL	9

// uywane jako globalne:
LONG d,e;
WORD kat;
//
WORD a,b,c,i,j,k;

struct gfx *wg;
struct mur *wm;
struct obiekt *wo,*wo2;
ULONG	*ww;

LONG dmin;
WORD najbp=0;	//najbliszy punkt
WORD najbm;		//najbliszy mur
WORD kol=0;		//kolizja
#define OBIEKTKOL 22
				//odleglosc, ktra powoduje kolizj
#define MURKOL 45
				// tak jakby kt tzn.128-MURKOL
#define ROGKOL 8
				// odlegosc od punktu czyli rogu muru
#define MURPKTKOL 40
				// odleglosc zeby mur od pktu powodowal kol. 
#define MURKOL2 50
				// odleglosc od pktow podzialowych

__far struct BitMap kolBM;
__far struct RastPort kolRP;
__far WORD kolBMdx,kolBMdy;
#define KOLSIZ 16

// komputer:

WORD ob_komput;
WORD k_status=0;
WORD k_czas=0;
char *k_poztxt=0;
WORD k_dx,k_dy;
LONG k_has,k_hasgut;
WORD k_faza=0;

BYTE st_up,st_down,st_left,st_right,st_fire,st_shift,st_gou;

WORD tabch; char cheat[8];
#define TOPSECRET 6
char topsecret[TOPSECRET][8]={
	{ 0x22,0x12,0x20,0x22,0x35,0x12,0x12,0x23 },	// DEADBEEF
	{ 0x27,0x20,0x36,0x18,0x36,0x35,0x20,0x28 },	// KANONBAL
	{ 0x20,0x28,0x14,0x25,0x17,0x36,0x24,0x31 },	// ALTHINGZ
	{ 0x24,0x22,0x37,0x15,0x13,0x36,0x17,0x36 },	// GDMYRNIN
	{ 0x23,0x13,0x12,0x12,0x12,0x12,0x31,0x12 },	// FREEEEZE
	{ 0x16,0x35,0x12,0x13,0x20,0x37,0x35,0x18 },	// UBERAMBO
					};

struct IntuiMessage *Message;
extern APTR Timer_Port;
extern ULONG czczek,waittimer;
 
char klawisz;
WORD zalicz, poziom=0, przerwagry, pauza, t_pauz,i_am_rambo;

extern __far char *nazwypoz[];
__far char plany[10]="plan";
extern void (*akcjepoz[])();
extern void (*pozinit[])();
extern void (*pozclose[])();
extern WORD kolorytla[];

/******************  audio  ************************/
#define K_LEW	-2
#define K_PRA	-3
#define K_DOW	-1

struct gfx *tlo_sfx,*tlo_sfx_p;
struct obiekt *tlo_ob;
ULONG tlo_sfx_min;

#define L_AREQ 3
struct	
	{ struct gfx* sfx; WORD vol; } aud_req[L_AREQ+1]={ { NULL, 999 } };
	// aud_req[0] jest nieuywane, glosnosc 999 jako zabezpieczenie

WORD lareq;

__far struct  gfx2 {
 	UWORD per,len;
 	APTR dane;
	    }
	a_tup,a_bron[7],a_explo,a_pstryk,a_reload,a_jdzwiek,a_zombie;
struct gfx2 a_track,a_boli[3];
UWORD jadeper,jadep2;

far extern UBYTE mt_SongPos;
APTR muzyka;
#define MUZTR 3
far UBYTE muztraf[]={4,12,16,17};
#define MUZKL 1
far UBYTE muzklucz[]={7,8};

WORD *buf,*buf_end,*buf2;
#define SZER 64
#define WYS 100

CzasStart()
{
DateStamp(&s_ds);
}

CzasStop()
{
struct DateStamp ds2;
LONG dt;
DateStamp(&ds2);
dt=(ds2.ds_Tick-s_ds.ds_Tick)/TICKS_PER_SECOND+(ds2.ds_Minute-s_ds.ds_Minute)*60;
while (dt<0) dt+=86400;
s_czas+=dt;
}

BufInit()
{
#define ZDERZAK SZER*2*8
buf=malloc(SZER*WYS*2+2*ZDERZAK)+ZDERZAK;
buf_end=buf+SZER*WYS;
buf2=malloc(SZER*WYS*2);
}

GfxInit()
{
znaki=LoadSUim("pic/znaki",0);
}

TestMode()
{
char pl[100];
WORD dalej;
ULONG sig;

BufInit();
printf("UBEK v0.9\n");
tablice();
TestPort=CreatePort("UBEK Test",0);
printf("Port komunikacyjny utworzony.\n");

los=0;
OpcPS=0;
OpcGr=1;
poziom=0;

DispOn();

while (dalej)
	{
	sig=Wait((1<<TestPort->mp_SigBit) | SIGBREAKF_CTRL_C);
	if (sig==SIGBREAKF_CTRL_C)
		dalej=0;
	if (UBEKMes=GetMsg(TestPort))
		{
		lpkt=UBEKMes->lpkt;
		lmur=UBEKMes->lmur;
		lob=UBEKMes->lob;
		CopyMem(UBEKMes->pkt,&pkt[0],MAXPKT*sizeof(struct pkt));
		CopyMem(UBEKMes->mur,&mur[0],MAXSCI*sizeof(struct mur));
		CopyMem(UBEKMes->obiekt,&obiekt[0],MAXOB*sizeof(struct obiekt));
		CopyMem(UBEKMes->gfx,&gfx[0],MAXGFX*sizeof(struct gfx));
		CopyMem(UBEKMes->tabpod,tabpod2,WIELPS*WIELPS);
		CopyMem(UBEKMes->tabsuf,tabsuf2,WIELPS*WIELPS);
		camx=UBEKMes->camx;
		camy=UBEKMes->camy;
		camh=UBEKMes->camh;

		for (a=0;a<MAXGFX;a++)
			if (gfx[a].typ&256) strcpy(gfx[a].nazwa,"___sound___");

		LoadGfx(1);
		SprawdzMape();
		ZrobTlo();
		zaoknem=((UBYTE*)gfx[GFX_WIDOK].dane)+32768;
		for (a=0;a<SZER;tabodl[a++]=0);
		Oblicz();
		ObiektyIMury();
		rys();
		DispConvert();
		MemorizeGfxCache();

		ReplyMsg(UBEKMes);
		}
	}
DeletePort(TestPort);

DispClose();

}

Gra(WORD newgame,WORD opow)
{
ULONG czas0;
MusicOff();
do
{
przerwagry=0;
st_fire=0; st_shift=0;
st_down=0; st_up=0; st_left=0; st_right=0; st_gou=0;
helpwanted=0;
pauza=0;
vx=vy=0; rotv=0;
fire=0; firet=0;
jade=0;
najbm=0;
if (OpcOp&&opow)
	przerwagry=Akcja(poziom);

KillTloSfx();

if (newgame) {	SpritLoad();
				sprintf(plany+4,"%d",poziom+1);
				WczytajMape(plany);
				MusicOn(muzyka,35);
				LoadGfx(0);
				MusicOff();
				SprawdzMape();
				pauza=0;
				SpritLoadOff();
				for (a=2;a<MAXMAM;a++)
					{
					obiekt[a-1].x=0;
					obiekt[a-1].y=0;
					obiekt[a-1].typ=0;
					if (mam[a].co)
						{
						if ((mam[a].co==11)||(mam[a].co==10)||(!mam[a].obiekt))
							{ mam[a].co=0;
							if (wybbron==a) WybierzInne();
							}
						mam[a].obiekt=a-1;
						obiekt[a-1].initgfx=mam[a].gfx;
						obiekt[a-1].gfx=mam[a].gfx;
						obiekt[a-1].txt=mam[a].txt;
						}
					}
				SpritLoadOff();
			}
	else
for (a=0;a<MAXMAM;a++)
	if (mam[a].co==11)
	{
	jade=1;
	jadeper=((struct gfx2*)(&gfx[b=obiekt[mam[a].obiekt].p3]))->per;
	jadep2=0;
	tuptup=0;
	Play8SVX(&gfx[b],2,0,64,1);
	}

		newgame=1;
//if (przerwagry) goto OminGre;

	myszx=266; myszy=100; celx=32;

	DispOn();
	StatusOn();
	StatusUpdate(1);

ZrobTlo();
zaoknem=((UBYTE*)gfx[GFX_WIDOK].dane)+32768;
			
	(*pozinit[poziom])();

if (zappoz!=poziom)
#ifdef _CD32_
	{
		PackHas(aktu_has);  
		zappoz=poziom;
		zapene=energ;
	}
#else
	{  
		zappocz=(zappoz>=0)?1:0;
		zappoz=poziom;
		zapene=energ;
		SaveGame(4);
	}
#endif

	InitKolBM();
	RysKolBM();

zalicz=0;
k_has=0;
i_am_rambo=0;

if (OpcDz&2) MusicOn(muzyka,0);
PojawGre();

sprintf(napis,lttab[12],poziom+1,lttab[70+poziom]);
Wiadom(napis,20);

SpritBron();

if (OpcBl) 
	SetTimer();

CzasStart();
czas0=s_czas;
stoi=0;

while (energ&&!zalicz&&!przerwagry)
  {
	kol=0;
	lareq=1;	// NewAReq();	
	tlo_sfx_min=999999; tlo_sfx=0;

	Sterow();
	if (!pauza)
	{	
	if (OpcBl) 
	{
	Wait (waittimer);
	GetMsg(Timer_Port);
	SetTimer();
	}
	Oblicz();
	ObiektyIMury();
	StatusUpdate(0);
	if (boli>0) 
			{if (boli>47) Play8SVX(&a_boli[2],K_DOW,1,64,0);
					else Play8SVX(&a_boli[boli>>4],K_DOW,1,64,0);
			GoToPat(muztraf[rand()&MUZTR]); stoi=0;
			}
	(*akcjepoz[poziom])();

	PlayTloSfx();
	PlayAReq();
	rys();
	DispConvert();
	camh+=rotv>>3;
	rotv=(rotv/2);
	if (kol)
		 {camx=xbezkol; camy=ybezkol;
		  vx=vy=0;
		 }
	else
		{
		xbezkol=camx; ybezkol=camy;
		if (jade)
		{
		if (Kolizmur(camx+vx,camy+vy) ||
			Kolizmur(camx+2*vx,camy+2*vy) ||
			Kolizmur(camx+vx+KOLSIZ,camy+vy) ||
			Kolizmur(camx+vx-KOLSIZ,camy+vy) ||
			Kolizmur(camx+vx,camy+vy+KOLSIZ) ||
			Kolizmur(camx+vx,camy+vy-KOLSIZ)) 
		{
		 mur[najbm].nacis=1;
		 energ+=mur[najbm].enkol;
		// kol=najbm;
		if (!Kolizmur(camx+vx,camy))
			camx+=vx;
		if (!Kolizmur(camx,camy+vy))
			camy+=vy;
		 }
		else	
			{
			camx+=2*vx;
			camy+=2*vy;
			tuptup=rand()&255;
			}
		}
		else
		{
		if (Kolizmur(camx+vx,camy+vy))
		{
		 mur[najbm].nacis=1;
		 energ+=mur[najbm].enkol;
		// kol=najbm;
		if (!Kolizmur(camx+vx,camy))
			camx+=vx;
		if (!Kolizmur(camx,camy+vy))
			camy+=vy;
		 }
		else
		{
			camx+=vx;
			camy+=vy;
		}
		if ((stoi++)>100) GoToPat2(6);
		}
		vx=(vx*3)/4;
		vy=(vy*3)/4;
		}
	bronx=(rotv/4)+celx-32;	
	SpritBronRys();
	}
	else
	{
	WORD *b=buf,*b2=buf_end,*b3=buf+SZER-1;
	if (t_pauz++>15) Wait(1<<ekrPort->mp_SigBit);
	else
	{
	Blur();
	GoToPat2(6);
	CopyMem(buf2,buf,SZER*WYS*2);
	for (a=0;a<SZER*2;a++) { *b++=0; *--b2=0; }
	for (a=0;a<WYS-1;a++) { *b3++=0; *b3=0; b3+=SZER-1; }
	DispConvert();
	Wiadom(lttab[13],1);
	}
	}
  }
CzasStop();
if (OpcBl) 
	{
	Wait (waittimer);
	GetMsg(Timer_Port);
	}

SpritOff();
KanOff(0);
KanOff(1);
KanOff(2);
KanOff(3);

	CloseKolBM();
	(*pozclose[poziom])();

if (energ&&!przerwagry) {poziom++; score+=1000; ktoryraz=0; opow=1;}
if (!energ)
	{
	MusicOff();
	MusicOn(muzyka,5);
	Zalewanas(0xf00,20);
	for (d=0xe00;d>0;d-=0x100)
	Zalewanas(d,1);
	Zalewanas(0x000,35);
	DrogaDucha();
	ktoryraz++;
	}
else
	{
	if (zalicz)	Wiadom(lttab[126],1);
	ZnikGre();
	}

DispClose();
StatusHide();
MusicOff();
MenuSpritOff();

if (helpwanted&&energ) Help();

if (poziom==18)
	{ Gratul();
	  energ=0;
	}

OminGre:
}
while (energ&&!przerwagry);
ClearPort(MesPort);
}

DrogaDucha()
{
#define RDROGI 160
#define V_ROT 2
UWORD dedx=camx,dedy=camy;
UWORD dedh=camh,d;
WORD y;
WORD t=0;

if (poziom==6)
	Wiadom(" ",999);
else
	{
	obiekt[1].x=dedx;
	obiekt[1].y=dedy;
	obiekt[1].z=0;
	obiekt[1].head=dedh;
	obiekt[1].gfx=GFX_GROB;
	obiekt[1].txt=30;
	obiekt[1].typ=0;
	obiekt[1].cechy=0;
	}

ClearPort(ekrPort);

for (y=0;y<100;y++)
		tabmisz[y]=(y&1)?(115-abs(50-y)):(-115+abs(50-y));

for (;;)
for (d=0;d<256;d+=V_ROT)
	{
	if ((DDPrzerw()) || (t++>300)) return;
	camh=dedh+d;
	camx=dedx+(RDROGI*tsi[(camh+128)&255])/32;
	camy=dedy+(RDROGI*tsi[(camh+128+64)&255])/32;
	Oblicz();
	ObiektyIMury();
	boli=0;
	energ=0;
	rys();
	if (t<250)
		for (y=0;y<100;y++)
		{
		if (tabmisz[y]>20) tabmisz[y]-=4;
			else if (tabmisz[y]>0) tabmisz[y]--;
		if (tabmisz[y]<-20) tabmisz[y]+=4;
			else if (tabmisz[y]<0) tabmisz[y]++;
		}
	else
		for (y=0;y<100;y++)
		{
		tabmisz[y]+=((y&1) ? (rand()/523)&3 : -((rand()/523)&3));
		}
	Miszobraz();
	DispConvert();
	}
}

PojawGre()
{
WORD t,p,y;
	lareq=1;
	Oblicz();
	ObiektyIMury();
	rys();
	CopyMem(buf,buf2,SZER*WYS*2);
	for (t=20;t>=0;t--)
		{
		p=0;
		for (y=0;y<50;y++)
			{
			tabmisz[y]=(p+=t)/8;
			tabmisz[99-y]=-tabmisz[y];
			}
	CopyMem(buf2,buf,SZER*WYS*2);	
	Miszobraz();
	DispConvert();
		}
}

ZnikGre()
{
WORD t,p,y;
	CopyMem(buf,buf2,SZER*WYS*2);
	for (t=0;t<20;t++)
		{
		p=0;
		for (y=0;y<50;y++)
			{
			tabmisz[y]=(p+=t)/8;
			tabmisz[99-y]=-tabmisz[y];
			}
	CopyMem(buf2,buf,SZER*WYS*2);	
	Miszobraz();
	DispConvert();
		}
}

LotTele(WORD gut)
{
WORD cz1,cz2,v;
WORD head,rota;
lpkt=0;
los=0;

for (a=0;a<SZER;tabodl[a++]=0);

camx=32768;
camy=32768;
head=rand()&0xfff;
zaoknem=((UBYTE*)gfx[26].dane)+32768;
v=1;
lob=1;
rotv=0;

for (cz1=0;cz1<26;cz1++)
	{
	if (cz1<3) { podgfx=gfx[30+cz1].dane; }
		else
	if (cz1>17) { podgfx=gfx[50-cz1].dane; }

	if (v<9) v++;
	rota=((rand()/42)&7)-4;
	if (!((rand()/36)&7))
		rotv=0;
	if (!((rand()/36)&7))
		rotv=rand()&255-128;

	if ((cz1<20)&&(!(cz1&3)))
	{
	lob++;
	obiekt[lob].faza=0;
	obiekt[lob].z=rand()&63;
	obiekt[lob].cechy=0;
	obiekt[lob].x=camx+30*tsi2[9][camh];
	obiekt[lob].y=camy+30*tsi2[9][(camh+64)&255];
	obiekt[lob].gfx=27+(rand()&1);
	}

	if (cz1>=20) { rotv=0; rota=0; }
	if (cz1==20) 
		{	obiekt[1].x=camx+30*tsi2[9][camh];
			obiekt[1].y=camy+30*tsi2[9][(camh+64)&255];
			obiekt[1].z=0;
			obiekt[1].faza=0;
			obiekt[1].cechy=0;
			obiekt[1].gfx=27+2*gut;
		}
	for (cz2=0;cz2<8;cz2++)
		{
		Oblicz();
		RysBackdrop();
		if ((cz1>=0)&&(cz1<=20)) Rys_sp2_sym();
		rys2();
		DispConvert();
		camx+=2*tsi2[v][camh];
		camy+=2*tsi2[v][(camh+64)&255];
		rotv+=rota;		
		head+=rotv;
		camh=(head>>4)&255;
		if (obiekt[1].d<80) if (!(v--)) if (obiekt[1].d>20) v=1; else goto dolecial;
		}
	dolecial:
	}

podgfx=gfx[30].dane;
for (a=0;a<MAXOBUCKET;a++)
	obucket[a]=0;
for (a=0;a<MAXMBUCKET;a++)
	{ mbucket1[a]=0;
	mbucket2[a]=0; }

RysTlo=&Nic;
RysTlo2=&Nic;
RysTlo3=&Nic;

}

ClearPort(APTR port)
{
while (Message=GetMsg(port))
 	ReplyMsg(Message);
}

DDPrzerw()
{
a=0;
while (Message=GetMsg(ekrPort))
	{
 	ReplyMsg(Message);
	if (Message->Class==IDCMP_RAWKEY)
		a|=(!((Message->Code) & 0x80));
	else
	if (Message->Class==IDCMP_MOUSEBUTTONS)
		a|=!((Message->Code)&0x80);
	}
if (!(*((BYTE *)0xbfe001)&128)) return 1;
return a;
}

// Procedury do kolizji metod BitMap
InitKolBM()
{
UWORD minx=-1,miny=-1,maxx=0,maxy=0;
UWORD szer,wys;

for (i=1;i<=lpkt;i++)
	{
	if (pkt[i].x<minx) minx=pkt[i].x;
	if (pkt[i].y<miny) miny=pkt[i].y;
	if (pkt[i].x>maxx) maxx=pkt[i].x;
	if (pkt[i].y>maxy) maxy=pkt[i].y;
	}
	szer=(maxx-minx)/KOLSIZ+16;
	wys=(maxy-miny)/KOLSIZ+16;
	InitBitMap(&kolBM,1,szer,wys);
	kolBM.Planes[0]=AllocRaster(szer,wys);
	InitRastPort(&kolRP);
	kolRP.BitMap=&kolBM;
	kolBMdx=minx;
	kolBMdy=miny;
}

RysKolBM()
{
SetRast(&kolRP,0);
SetAPen(&kolRP,1);
for (i=1;i<=lmur;i++)
	if ((mur[i].cechy&1)&&((!(mur[i].cechy&2))||((mur[i].cechy&2)&&(!mur[i].stan))))
	RMurKolBM(	pkt[mur[i].p1].x,	pkt[mur[i].p1].y,
				pkt[mur[i].p2].x,	pkt[mur[i].p2].y);
}

RPixKolBM(UWORD x,UWORD y)
{
x=(x-kolBMdx)/KOLSIZ+8;
y=(y-kolBMdy)/KOLSIZ+8;

//		 XXX
//		XXXXX
//		XXXXX
//		XXXXX
//		 XXX

RectFill(&kolRP,x-2,y-1,x+2,y+1);
RectFill(&kolRP,x-1,y-2,x+1,y+2);
}

RMurKolBM(UWORD x1,UWORD y1,UWORD x2,UWORD y2)
{
x1=(x1-kolBMdx)/KOLSIZ+8;
y1=(y1-kolBMdy)/KOLSIZ+8;
x2=(x2-kolBMdx)/KOLSIZ+8;
y2=(y2-kolBMdy)/KOLSIZ+8;

//		 XXX
//		X...X
//		X.X.X
//		X...X
//		 XXX

Move(&kolRP,x1+2,y1-1);
Draw(&kolRP,x2+2,y2-1);
Move(&kolRP,x1+2,y1);
Draw(&kolRP,x2+2,y2);
Move(&kolRP,x1+2,y1+1);
Draw(&kolRP,x2+2,y2+1);

Move(&kolRP,x1-2,y1-1);
Draw(&kolRP,x2-2,y2-1);
Move(&kolRP,x1-2,y1);
Draw(&kolRP,x2-2,y2);
Move(&kolRP,x1-2,y1+1);
Draw(&kolRP,x2-2,y2+1);

Move(&kolRP,x1-1,y1-2);
Draw(&kolRP,x2-1,y2-2);
Move(&kolRP,x1,y1-2);
Draw(&kolRP,x2,y2-2);
Move(&kolRP,x1+1,y1-2);
Draw(&kolRP,x2+1,y2-2);

Move(&kolRP,x1-1,y1+2);
Draw(&kolRP,x2-1,y2+2);
Move(&kolRP,x1,y1+2);
Draw(&kolRP,x2,y2+2);
Move(&kolRP,x1+1,y1+2);
Draw(&kolRP,x2+1,y2+2);

Move(&kolRP,x1,y1);
Draw(&kolRP,x2,y2);

}

CloseKolBM()
{
	FreeRaster(kolBM.Planes[0],8*kolBM.BytesPerRow,kolBM.Rows);
}

Zegarek(WORD nrgfx)
{
static struct 
	{LONG d,m,t;} ds;
static WORD g,m,t=3;

if (!(t--))
	{ t=2;
		DateStamp(&ds);
		m=ds.m%60; g=ds.m/60;
		sprintf(napis,"\005%2d:%02d ",g,m);
		KPrintxt(gfx[nrgfx].dane,napis,znaki);
	}
}
Komputer(struct obiekt *ob,WORD nrgfx)
{
static WORD t=3;
static UWORD x1,y1,x2,y2;
static WORD p_stat;
static char czek[]="_      ";
static struct 
	{LONG d,m,t;} ds;
static testszyb=0;
static poptest=0;

if (!(--t))
	{ t=3;
		k_czas++;
		if (p_stat!=k_status) {p_stat=k_status; KKasekr(gfx[nrgfx].dane);}
		switch(k_status)
			{
				case 0:
			KPrintxt(gfx[nrgfx].dane,"Czekam",znaki);
			KPrintxt2(gfx[nrgfx].dane,czek+(k_czas & 1),znaki);
			break;
			 case 1: 		//lecitext
			 if (!k_poztxt)	k_poztxt=lttab[14];
				KPrintxt2(gfx[nrgfx].dane,k_poztxt,znaki);
				++k_poztxt;
				if (!k_poztxt[6]) k_poztxt=0;
			break;
			  case 2:		//sterow.drzwi
					KPrintxt(gfx[nrgfx].dane,lttab[15],znaki);
					napis[0]=napis[1]=napis[2]=
					napis[3]=napis[4]=napis[5]=32;
					b=0;
					for (a=ob->p4;a<=lmur;a++)
						{
						if (mur[a].cechy&2)
							{
							napis[2*b]='1'+b;	
							napis[2*b+1]=(mur[a].cechy&8 ? ( mur[a].stan ? 1 : 2 ) : 3 ); 
							if (++b>2) break;
							}
						//kody 1:otwarte 2:zamknite 3:zablokowane
						}
					KPrintxt2(gfx[nrgfx].dane,napis,znaki);
			break;
				case 3:		//zegarek
			KPrintxt(gfx[nrgfx].dane,lttab[16],znaki);
			KPrintxt2(gfx[nrgfx].dane,napis,znaki);
				break;
				case 4:		//mapa
					if (!(k_czas&3))
					{
					UWORD cx=camx+k_dx,cy=camy+k_dy;
					KKasekr(gfx[nrgfx].dane);
					for (a=1;a<=lmur;a++)
						{
						x1=pkt[mur[a].p1].x;
						x2=pkt[mur[a].p2].x;
						y1=pkt[mur[a].p1].y;
						y2=pkt[mur[a].p2].y;
			if (mur[a].cechy&2)
				{ if (mur[a].cechy&8) {b=0xaa0; c=0xff0;}
							else	  {b=0xa00; c=0xf33;} }
				else {b=0x0a0; c=0x3f3;}
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1+x2)>>1))>>(6)),21+((((y1+y2)>>1)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1*3+x2)>>2))>>(6)),21+((((y1*3+y2)>>2)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1+x2*3)>>2))>>(6)),21+((((y1+y2*3)>>2)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1*7+x2)>>3))>>(6)),21+((((y1*7+y2)>>3)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1*5+x2*3)>>3))>>(6)),21+((((y1*5+y2*3)>>3)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1*3+x2*5)>>3))>>(6)),21+((((y1*3+y2*5)>>3)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-((x1+x2*7)>>3))>>(6)),21+((((y1+y2*7)>>3)-cy)>>5),b);
		KRysPkt(gfx[nrgfx].dane,24+((cx-x1)>>(6)),21+((y1-cy)>>5),c);
		KRysPkt(gfx[nrgfx].dane,24+((cx-x2)>>(6)),21+((y2-cy)>>5),c);
						}
					}
		KRysPkt(gfx[nrgfx].dane,x1=(24+(k_dx/64)),y1=(21-(k_dy/32)),b=(0xfff>>(k_czas&7)));
		KRysPkt(gfx[nrgfx].dane,x1+1,y1,b>>=4);
		KRysPkt(gfx[nrgfx].dane,x1-1,y1,b);
		KRysPkt(gfx[nrgfx].dane,x1,y1+1,b);
		KRysPkt(gfx[nrgfx].dane,x1,y1-1,b);
				break;

				case 5:		// test szybkosci
					if (!(testszyb--))
					{
					DateStamp(&ds);
					x1=ds.t-poptest;
					poptest=ds.t;
					x2=2000/x1;
					testszyb=10;
					KPrintxt(gfx[nrgfx].dane,"\005 Test",znaki);
					if (x2<1000) sprintf(napis,"%-3dfps",x2);
					KPrintxt2(gfx[nrgfx].dane,napis,znaki);
					}
				break;

				case 6:		// podaj haso !
					KPrintxt(gfx[nrgfx].dane,lttab[17],znaki);
					if (k_has)
						sprintf(napis,"%ld%c   ",k_has,k_czas&1 ? ' ':'_');
					else
						sprintf(napis,"%c    ",k_czas&1 ? ' ':'_');					
					KPrintxt2(gfx[nrgfx].dane,napis,znaki);					
				break;

				case 7:		// poka haso
				if (k_czas&3) break;
				if (!k_faza)
					{ KPrintxt(gfx[nrgfx].dane,lttab[17],znaki);
					KPrintxt2(gfx[nrgfx].dane,"_     ",znaki);
					k_faza++; } 
					else
					if (k_faza<6)
						{
						d=k_hasgut;
						for (x1=5;x1>k_faza;x1--) d/=10;	
						sprintf(napis,"%ld_   ",d);
						KPrintxt2(gfx[nrgfx].dane,napis,znaki);					
						k_faza++;
						}
				break;

				case 8:		// czeka na dysk
				CopyMem(gfx[GFX_REKA].dane,gfx[nrgfx].dane,64*64*2);
				break;

				case 9:		// adres do teleportu
					KPrintxt(gfx[nrgfx].dane,lttab[18],znaki);
					if (k_has)
						sprintf(napis,"%ld%c   ",k_has,k_czas&1 ? ' ':'_');
					else
						sprintf(napis,"%c    ",k_czas&1 ? ' ':'_');					
					KPrintxt2(gfx[nrgfx].dane,napis,znaki);					
				break;

					}
			}
}

SterowKomp(struct obiekt *ob)
{
k_hasgut=ob->longp;
k_status=ob->stan;

		if ((k_status==7) || (k_status==8)) return;

		if (k_status==0)
				{ k_has=0; 
			 	  k_status=1;
				  k_poztxt=0; }

		// if (klawisz) AddAReq(&a_pstryk,0);

		if (k_status==6)
			{
			if ((klawisz>=1)&&(klawisz<=9))
				k_has=10*k_has+klawisz;
				if (k_has>9999)
					if (k_has==k_hasgut)
							 {	k_has=0;
								k_poztxt=lttab[10]; k_status=1; }
									else k_has=0;
			goto koniec;
			}

		if (k_status==9)
			{
			if ((klawisz>=1)&&(klawisz<=9)&&(k_has<=9999))
									k_has=10*k_has+klawisz;
			goto koniec;
			}

		switch (klawisz)
			{
			case  0x14:		// test szybkosci
				k_status=5;
				break;
			case  0x22:		// tryb drzwi
				k_status=2;
				k_czas=0;
				break;
			case  0x25:		// help
			case  0x5f:
				switch (k_status)
					{case 4: k_poztxt=lttab[9]; break;
					 case 2: k_poztxt=lttab[8]; break;
					 default: k_poztxt=lttab[7];}				
				k_status=1;
				break;
			case 0x31 :		//zegarek
				k_status=3;
				break;
			case 0x37:		//mapa
				k_status=4;
			case 0x2e:		// num5 - center
				k_dx=k_dy=0;
				break;
			case 0x3e:		// num8
				k_dy-=200;	break;
			case 0x1e:		// num2
				k_dy+=200;	break;
			case 0x2d:		// num4
				k_dx+=200;	break;
			case 0x2f:		// num6
				k_dx-=200;	break;
			}
		if ((klawisz>=1)&&(klawisz<=3)&&(k_status==2))
			{
			b=1;
			for (a=ob->p4;a<=lmur;a++)
				if (mur[a].cechy&2)
					{
					if (b==klawisz)
						{
						if (!(mur[a].cechy&8))
								{ mur[a].cechy|=8;
								  mur[a].faza=0; break; }	
						if (!mur[a].stan)
								mur[a].nacis=1;
						break;
						}
					b++;
					}
			}

koniec:

klawisz=0;

ob->longp=k_hasgut;
ob->stan=k_status;
}

InitDzwieki()
{
if (InitAudio(4)!=4) { CloseAudio(); OpcDz=-1; return; }

_MemType=MEMF_CHIP;
muzyka=ReadFile("sfx/mod.UBEK",0);
_MemType=MEMF_ANY;

Load8SVX("sfx/tuptup",&a_tup);
Load8SVX("sfx/obrzyn",&a_bron[1]);
Load8SVX("sfx/pif",&a_bron[2]);
Load8SVX("sfx/karabin",&a_bron[3]);
Load8SVX("sfx/laser",&a_bron[4]);
Load8SVX("sfx/rakieta",&a_bron[5]);
Load8SVX("sfx/fantomer",&a_bron[6]);
Load8SVX("sfx/bol1",&a_boli[0]);
Load8SVX("sfx/bol2",&a_boli[1]);
Load8SVX("sfx/bol3",&a_boli[2]);
Load8SVX("sfx/explozja",&a_explo);
// Load8SVX("sfx/pstryk",&a_pstryk);
Load8SVX("sfx/reload",&a_reload);
Load8SVX("sfx/jdzwiek",&a_jdzwiek);
Load8SVX("sfx/tracking",&a_track);
a_zombie.len=a_bron[6].len;
a_zombie.dane=a_bron[6].dane;
a_zombie.per=2222;
}

CloseDzwieki()
{
CloseAudio();
Free8SVX(&a_tup);
Free8SVX(&a_bron[1]);
Free8SVX(&a_bron[2]);
Free8SVX(&a_bron[3]);
Free8SVX(&a_bron[4]);
Free8SVX(&a_bron[5]);
Free8SVX(&a_boli[0]);
Free8SVX(&a_boli[1]);
Free8SVX(&a_boli[2]);
Free8SVX(&a_explo);
// Free8SVX(&a_pstryk);
Free8SVX(&a_reload);
Free8SVX(&a_jdzwiek);
Free8SVX(&a_track);
free(muzyka);
}

AddAReq(struct gfx *sfx,WORD odl)
// dodaje danie dzwiku
// maksymalnie moe by L_AREQ, aktualnie lareq
{
static WORD v,m,a;

if (odl<256)
	{
	v=64-(odl >> 2);
	m=lareq;
	while (aud_req[m-1].vol<v) m--; 
	if (m<0) return;
	if (m < L_AREQ)
		{
		for (a=m;a<lareq;a++)
			{
			aud_req[a+1].sfx=aud_req[a].sfx;
			aud_req[a+1].vol=aud_req[a].vol;
			}
		if (lareq < L_AREQ) lareq++;
		aud_req[m].sfx=sfx;
		aud_req[m].vol=v;
		}
	}
	// else gosnosc zerowa
}

PlayAReq()
{
for (a=1;a<lareq;a++)
	Play8SVX(aud_req[a].sfx,K_DOW,1,aud_req[a].vol,0);
}

ObiektyIMury()
{

for (wo=&obiekt[1];wo<=&obiekt[lob];wo++)
	{
	wg=&gfx[wo->gfx];	// b = gfx(obiekt)
	// licznik czasu
	if ((--wo->czas)<0) wo->czas=0;
	// Animacja:
if (wg->lanim)
	if (!(flipanim&wg->t))
		if (wo->faza<wg->lanim) wo->faza++;
			else if (!(wg->typ&8)) wo->faza=0;		//od pocztku
					else if (wg->typ&16)			// moe znika?
					{
					 wo->x=wo->y=wo->typ=wo->cechy=0;	
					}
	// CECHY:gfx
	// $4 - widok z 4 stron (w gfx)
	if (wg->typ&4)
		wo->faza=((wo->xe+(32+128-SZER/2)+camh-wo->head)&255)>>6;
	// RUCH:
	if (wo->v>0)
		{
		wo->x+=tsi2[wo->v][wo->head];
		wo->y+=tsi2[wo->v][(wo->head+64)&255];
		if ((!(wo->cechy&2048))&&Kolizmur(wo->x,wo->y))
			{
			wo->x-=tsi2[wo->v][wo->head];
			wo->y-=tsi2[wo->v][(wo->head+64)&255];
			wo->kol=1;
			}
			else wo->kol=0;
		// fazy ruchu
		if (wo->cechy&8) { if (flipanim&4) 
								if (wg->fazy==7)
									wo->faza+=4;
										else
									wo->faza^=1;
							if (!(flipanim&7)) if (!(wo->cechy&64)) AddAReq(&a_tup,wo->d);
							}
		}

	switch(wo->typ)
	{
	case 0: break;

	case 1:		// stranik
		switch(wo->stan)
		{
		case 0:		// idzie...
			if ((!wo->czas)||(wo->kol)) 
				{wo->czas=wo->p1;
				wo->head+=((rand()/47)&127)-64;
				}
			if (wo->czas<30) wo->v=0; else	wo->v=wo->p2;

			if ((wo->odl) && ((wo->d<50)||(WIDACOB)) && (!wo->faza||fire))
				{wo->stan=3;	// goto ucieka
				wo->czas=10;
				wo->head=camh+128+wo->xe-96+((rand()/100)&127);
				wo->faza=0;
				}
			break;
		case 1:		// celuje... 
			if (!wo->czas)
							{wo->stan=4;
							wo->gfx=wo->initgfx+1;
							wo->faza=0;
							wo->czas=6;
							if ((b=abs(wo->p3-camx)+abs(wo->p4-camy))<200)
								if WIDACOB
								{
								 KillMe(wo->d,50-(b>>2));
								 AddAReq(&a_bron[3],wo->d);
								}
							wo->v=0;}
			break;
		case 2:		// trafiony... (czas==0 => strzala)
			if (!wo->czas)
				{ wo->stan=3; wo->gfx=wo->initgfx;
					wo->faza=0;
				}
			break;
		case 3:		// ucieka... 
			wo->v=wo->p2;
			wo->head+=(wo->xe>celx)?1:-1;
			if (wo->kol) wo->head+=(rand()&127)+64;
			if (!wo->czas) 
				{wo->p3=camx; wo->p4=camy;
					wo->stan=1; wo->czas=10;
				}
			break;
		case 4:		// strzela... (do skutku)
			if (!wo->czas) 
					{if (wo->d<20)
						{
						wo->czas=0;
						wo->stan=1;
						}
					else 
						{wo->stan=3;
						wo->czas=5;
						}
					wo->head=camh+128+wo->xe-96+((rand()/100)&127);
					wo->gfx=wo->initgfx;}
			break;
		case 5:	// czai si...
		if (!wo->czas)
			{
			wo->czas=5;
			wo->head+=32;
			if ((WIDACOB)&&(!wo->faza))
				wo->stan=2;
			}
		break;
		}
	break;

	case 2:	// czeka na zombie
	if ((!wo->czas)&&(wo->p4))
		{
		wo->typ=18;	wo->czas=10; break;
		}
	break;

	case 3:	// wrg ukryty
		switch(wo->stan)
		{
		case 0:
			if (wo->d>wo->p1) break;
			wo->stan=1;	// stan budzenia si
			wo->gfx=wo->initgfx;
			wo->faza=0;
			wo->czas=0;
			if (wo->p3) AddAReq(&gfx[wo->p3],wo->d);
		break;
		case 1:
			if (wo->czas) break;
			if (++wo->faza >= wg->fazy)
				{
				wo->gfx=wo->initgfx+1;
				wo->faza=0;
				wo->stan=2;	// stan GRONY
				}
			else
				wo->czas=wg->t;
		break;
		case 2:
			if (wo->d<wo->p2) 
					{
					if (!wo->faza)
						{
						if (wo->p4) AddAReq(&gfx[wo->p4],wo->d);
						if ((wo->cechy&64)&& WIDACOB ) KillMe(wo->d,-wo->enkol);
						}
					}
					else
					{
					wo->stan=3;	// stan chowania si
					wo->gfx=wo->initgfx;
					wo->faza=gfx[wo->initgfx].fazy-1;
					wo->czas=0;
					}
		break;
		case 3:
			if (wo->czas) break;
			if (!--wo->faza)
				wo->stan=0;	// stan pocztkowy
			else
				wo->czas=wg->t;
		break;
		}
	break;
	case 4:	// sterowanie np.drzwiami
		switch(wo->stan)
		{			
			case 1:			// zmniejszasie
			if (!wo->czas)
			{
			wo->czas=4;
			for (c=1;c<=lob;c++)
			if (obiekt[c].gfx==(wo->p1+1)) 
				if (!(--obiekt[c].faza)) {wo->stan=2;
										wo->czas=wo->p2;}
			}
			break;
			
			case 2:			//czeka
			if (!wo->czas)
			{
			wo->stan=3;
			wo->czas=4;
			if (wo->p3) AddAReq(&gfx[wo->p3],wo->d);
			}
			break;

			case 3:		// zwiekszasie
			if (!wo->czas)
			{
			for (c=1;c<=lob;c++)
			if (obiekt[c].gfx==(wo->p1+1)) 
				if (++obiekt[c].faza==wo->p4) wo->stan=4;
			wo->czas=4;
			}
			break;

			case 4:		// wracadonormy
			for (c=1;c<=lob;c++)
			if (obiekt[c].gfx==(wo->p1+1))
				{
				obiekt[c].gfx--;
				obiekt[c].faza=0; 
				obiekt[c].enkol=obiekt[c].p1;
				}
			wo->faza=0;
			wo->stan=0;
			break;
			}
	break;
	case 5:	// mina		(p1 = moc)
		if(wo->stan)
		{
		    // w trakcie wybuchu
			if (!wo->czas)
				// zapala inne i znika
				{
				wo->typ=0;
				wo->cechy=16;
				wo->energia=0;
				Trafiony(wo,1,1);
				for (c=1;c<=lob;c++)
					if ((d=abs(wo->x-obiekt[c].x)+abs(wo->y-obiekt[c].y))<256)
						Trafiony(&obiekt[c],d,wo->p1);
				if ((d=abs(wo->x-camx)+abs(wo->y-camy))<256)
					KillMe(d,wo->p1);
				}
		}
	break;

	case 6:	// np.latajca czaszka  lata w kko z odgosem p3
		if (!wo->czas) wo->gfx=wo->initgfx;
		if (!wo->stan)
			{
			wo->head+=3;
			if (!wo->czas)
				{
				wo->czas=20;
				if ((wo->d<120)&&Kolizlin(camx,camy,wo->x,wo->y))
					{
					wo->head=camh+128+wo->xe-32;
					wo->stan=1;
					}
				}
			}
		else
			{
			if (!wo->czas)
				{
				wo->czas=20;
				wo->head=camh+128+wo->xe-32;
				if (wo->d<30) 
					wo->head=camh+wo->xe-32;
				}
			}

		AddTloSfx(abs(camx-wo->x)+abs(camy-wo->y),wo,&gfx[wo->p3]);
	break;

	case 7: // cos, co spada
		if (wo->z>=5) wo->z-=5;
		 else if (wo->v) wo->v--;
		  else wo->z=wo->typ=0;
	break;

	case 8: // cos, co sie odbija od scian
		if (wo->kol)
					{ wo->head+=wo->p4;
					if (wo->p3) AddAReq(&gfx[wo->p3],wo->d);
					}
		if (wo->p2) AddTloSfx(abs(camx-wo->x)+abs(camy-wo->y),wo,&gfx[wo->p2]);
	break;
	
	case 9: // ogien
		AddTloSfx(abs(camx-wo->x)+abs(camy-wo->y),wo,&gfx[SFX_OGIEN]);
		if (!wo->czas)
			{
			wo->czas=30;
			if (!(--wo->p4))
				{
				wo->gfx=GFX_POPIOL;
				wo->faza=0;
				wo->typ=0;
				wo->cechy=0;
				ReName(wo,55);
				}
			for (c=1;c<=lob;c++)
				if ((d=abs(wo->x-obiekt[c].x)+abs(wo->y-obiekt[c].y))<110)
					if (obiekt[c].cechy&128)
					{
					ReName(&obiekt[c],25);
					obiekt[c].p1=wo->p1;
					obiekt[c].p2=wo->p2;
					obiekt[c].gfx=GFX_OGIEN;
					obiekt[c].initgfx=GFX_OGIEN;
					obiekt[c].faza=0;
					obiekt[c].enkol=wo->enkol;
					obiekt[c].czas=30;
					obiekt[c].typ=9;
					obiekt[c].cechy=0;
					obiekt[c].p4=30;
					}
			}
	break;
	
	case 10:	// bydle
		if (wo->kol) wo->head+=30;
		if (!wo->czas)
			{
			wo->czas=13;
			if ((!wo->faza)&&WIDACOB)
				{
				wo->v=8;
				wo->head=camh+128+wo->xe-32;
				if (wo->p1)
				AddAReq(&gfx[wo->p1],wo->d);	// wrzask
				 }
				else
				wo->v=2;
			}
	break;

	case 11:	// cos co wyrzucamy
		if ((wo->z-=5)<=0)
			{ wo->z=0;
				wo->typ=2;	
				wo->p1=3;
			}
	break;

	case 12:	// leccy granat
		if (((wo->z-=5)<=0)||wo->kol)
			{	wo->z=0;
				wo->typ=5;	
				wo->p1=997;
				wo->czas=2;
				wo->cechy=16;
				wo->stan=1;
				wo->gfx=GFX_BIGBANG;
				wo->faza=0;
				AddAReq(&a_explo,wo->d);
			}
	break;

	case 13:	// lecca rakieta
		wo2=wo->longp;
		if ((wo->kol)||(((wo->p4=abs(wo->x-wo2->x)+abs(wo->y-wo2->y))<50)&&wo2))
		{
			if (!wo->kol)
				{
				wo->x=wo2->x;
				wo->y=wo2->y;
				}
			wo->typ=5;	
			wo->p1=997;
			wo->czas=0;
			wo->cechy=16;
			wo->stan=1;
			wo->gfx=GFX_BIGBANG;
			wo->faza=0;
			AddAReq(&a_explo,wo->d);
			break;
		}

		if (wo2&&(wo->p4>wo->p3))	// korekta kursu
		{
			UWORD x,y,h;
			x=camx; y=camy; h=camh;
			camx=wo->x;
			camy=wo->y;
			camh=0;
			Biegu(wo2->x,wo2->y,&obiekt[0].xe);
			camx=x; camy=y; camh=h;
			wo->head=128+kat;
			wo->p1=wo2->x;
			wo->p2=wo2->y;
		}
		wo->p3=wo->p4;
	break;
	case 14:	// wrg ukryty ruchomy
		switch(wo->stan)
		{
		case 0:
			if (wo->czas) break;
			wo->czas=7;
			if ((wo->d>wo->p1)||(!(WIDACOB)))
			 	break;
			wo->stan=1;	// stan budzenia si
			wo->energia/=10;
			wo->gfx=wo->initgfx+1;
			wo->faza=0;
			wo->czas=gfx[wo->gfx].fazy*gfx[wo->gfx].t;
		break;
		case 1:
			if ((wo->z-=10)<0) wo->z=0;

			if (!wo->czas)
				{
				wo->z=0;
				wo->initgfx=wo->gfx=wo->initgfx+2;
				wo->faza=0;
				wo->stan=2;	// stan GRONY
				if (wo->txt==66) ReName(wo,67);
				}
		break;
		case 2:
			if (wo->czas) break;
			wo->czas=17;
			if (Kolizlin(camx,camy,wo->x,wo->y))
				{
				wo->v=6;
				wo->head=camh+128+wo->xe-(rand()&63);
				}
				else
				wo->v=0;
		}
	break;

	case 15:	// kierownik fantoma
		wo->gfx=wo->initgfx;	
		AddTloSfx(abs(camx-wo->x)+abs(camy-wo->y),wo,&gfx[wo->p3]);
		if (wo->czas) break;
		switch (wo->stan)
			{
			case 0:
			wo->head-=3;
				wo->czas=20;
				if (WIDACOB)
					{
					wo->head=camh+128+wo->xe-(rand()&63);
					wo->stan=1;
					}
			break;
			
			case 1:
				wo->czas=20;
				wo->head=camh+128+wo->xe-(rand()&63);
				if (wo->d<30) 
					wo->head=camh+wo->xe-(rand()&63);
				if (wo->d<140)
					{
					(wo+1)->x=wo->x;
					(wo+1)->y=wo->y;
					(wo+1)->z=wo->z-60;
					(wo+1)->typ=16;
					(wo+1)->czas=40;
					(wo+1)->gfx=(wo+1)->initgfx;
					(wo+1)->faza=0;
					(wo+1)->enkol=wo->enkol;
					(wo+1)->stan=0;
					(wo+1)->v=wo->v;
					(wo+1)->head=wo->head;
					(wo+1)->cechy = 49;
					wo->stan=2;
					wo->head+=128;
					}
			break;

			case 2:
				wo->czas=20;
					wo->head=camh+wo->xe-(rand()&63);
				if ((wo->d+wo->d)>500)
					{
					(wo+1)->energia=0;
					(wo+1)->typ=0;
					Trafiony(wo+1,0,1);
					wo->stan=1;
					}
			break;
			}

	break;

	case 16:	// fantom
		if (wo->stan)
			{
			wo->gfx=(wo-1)->initgfx;
			if (wo->z<(wo-1)->z)
				wo->z+=3;
			}
		if (wo->czas) break;
		wo->stan=1;
		wo->czas=20;
		wo->head=camh+128+wo->xe-32;
		if (wo->d<30) 
			wo->head=camh+wo->xe-32;
	break;

	case 17:	// dzida okresowa
		if	(wo->czas) break;
		if (wo->stan)
		{
		// malejemy
			wo->czas=wg->t;
			if (!--wo->faza)
				{
				wo->stan=0;
				wo->enkol=0;
				wo->czas=wo->p1;
				}
		}
		else
		{
		// roniemy
			wo->czas=wg->t;
			if (++wo->faza>=wg->fazy)
				{
				wo->stan=1;
				wo->enkol=wo->p4;
				wo->czas=wo->p2;
				if (wo->p3) AddAReq(&gfx[wo->p3],wo->d);
				}
		}
	break;

	case 18:	// Zombie...
		if (wo->czas>10) break;
		if (!wo->czas)
			{			//jak nowonarodzony
			switch(wo->p4)
				{
				case 1:
				wo->typ=1;
				wo->stan=0;
				wo->p1=77;
				wo->p2=4;
				ReName(wo,78); // wo->p3;
				wo->energia=100;
				wo->gfx=wo->initgfx;
				wo->z=0;
				wo->cechy=104;
				wo->pkt=55;
				break;

				case 2:
				wo->typ=14;
				wo->stan=3;
				ReName(wo,78); // wo->p3;
				wo->energia=200;
				wo->initgfx=wo->gfx;
				wo->z=0;
				wo->cechy=129;
				wo->pkt=33;
				wo->enkol=-2;
				break;				
				}
			}
		else
			{
			wo->cechy=0;
			wo->z=(wo->czas&1)*4;
			wo->p1=6;
			AddTloSfx(abs(camx-wo->x)+abs(camy-wo->y),wo,&a_zombie);
			}
		
		break;

	case 19:	// snajper
	switch (wo->stan)
		{
		case 0:	// czeka
		if (wo->czas) break;
		if WIDACOB
			{
			mur[wo->p1].gfx=wo->p3;
			AddAReq(&a_bron[2],wo->d);
	     	KillMe(wo->d,50);
			wo->stan=1;
			wo->czas=15;	// w cigu tego czasu mona go zabi
			}
			else
			wo->czas=21;
		break;

		case 1: // strzela
		mur[wo->p1].gfx=wo->p2;
		if (!wo->czas) { wo->stan=0; wo->czas=31; }
		break;
		
		case 2: // spada
		if ((wo->z-=wo->p4+=6)<=0)
			{ wo->z=0;
			AddAReq(&a_boli[0],wo->d);	// spad !
			wo->typ=2;
			wo->p1=1;		//daje amu
			wo->p2=6;		//6 szt.
			wo->p4=0;
			wo->faza=1;
			wo->cechy=128;
			}
		break;
		}
	break;

	case 20:	// co jakby zwoki
	if (wo->stan)
	{
	if (wo->czas) break;
	if (wo->faza<wg->fazy)
		{
		wo->faza++; wo->czas=wg->t;
		}
		else wo->stan=0;
	}
	break;

	case 21:	// stranik --> <--
	switch(wo->stan)
		{
		case 0:
		if (wo->kol) wo->head+=128;
		if (WIDACOB && (!(wo->faza&1)))
			{
			wo->stan=1;
			wo->v=0;
			wo->czas=10;
			wo->gfx=wo->initgfx+1;
			wo->faza=0;
			}
		break;
		case 1:
		AddAReq(&a_bron[2],wo->d);
     	KillMe(wo->d,150);
		if (!wo->czas)
		{
			if (!Kolizlin(camx,camy,wo->x,wo->y))
			{
			wo->gfx=wo->initgfx;
			wo->v=5;
			wo->stan=0;
			}
		}
		break;
		}
	break;

	case 22:		// specjalny rodzaj stranika kubanskiego
	switch(wo->stan)
		{
		case 0: // idzie
		if (wo->kol) wo->head^=128;
		if (((!wo->faza)&&(wo->d<40))||(wo->d<20)) { wo->stan=1; wo->faza=0; wo->gfx=wo->initgfx+1; wo->czas=3;}
		if ((abs(wo->x-obiekt[wo->p1].x)+abs(wo->y-obiekt[wo->p1].y))<60)
			{ wo->stan=2; wo->faza=0; wo->gfx=wo->initgfx+4;
			  wo->czas=5; }
		break;

		case 1:	// zabija
		if (!wo->faza)
		{
		AddAReq(&a_bron[2],wo->d);
     	KillMe(wo->d,150);
		}
		if (!wo->czas)
			{
			wo->gfx=wo->initgfx;
			wo->stan=0;
			}
		break;

		case 2:	// pada
		if (!wo->czas)
			{
			wo->v=0;
			wo->faza=gfx[wo->gfx=wo->initgfx+3].fazy;
			wo->stan=3;
			wo->cechy=0;
			ReName(wo,6);
			}
		break;

		break;
		}
	break;

	case 23:	// naukowiec
	if ((wo->xe>celx-4)&&(wo->xe<celx+4))
		{
		wo->gfx=wo->initgfx+2;
		if (lastob==wo) { Wiadom(lttab[(wo->txt==57)?133:19],12); lastob=0; }
		}
		else wo->gfx=wo->initgfx;
	break;

	case 24:// do fantomera
	if ((!wo->stan)&&(!wo->czas))
		{ wo->gfx=wo->initgfx+1; wo->faza=0; wo->stan=1;}
	break;

	 }
	}

dmin=99999;

for (wm=&mur[1],a=1;a<=lmur;wm++,a++)
	{
	// obliczanie fazy:
	// Animacja:
	if (gfx[wm->gfx].lanim)
		if (!(wm->faza--)) wm->faza=gfx[wm->gfx].lanim;
	// CECHY:
	// kolizja z murem
	// $1 = zatrzymuje ruch
	// szukamy najblizszej sciany

	d=pkt[wm->p1].d+pkt[wm->p2].d;

	if ((wm->cechy&1)&&(d<dmin)) { dmin=d; najbm=a;}

	if ((e=d>>1)<250)
		{
		if (a<=lmu2)
			ww=&mbucket2[0]+e;
		else
			ww=&mbucket1[0]+e;

		while (*ww) ww++;
		*ww=wm;
		}
	// $2 = drzwi
	if (wm->cechy&0x2)
		if (wm->cechy&8)
		{ b=wm->stan;
		  if ((wm->nacis)&&(wm->stan==0)) 
					{wm->stan=1; AddAReq(&gfx[SFX_DRZWI],pkt[wm->p1].d<<1);}
		  if ((b>0)&&(b<16))	 {pkt[wm->p1].x+=wm->dx;
							pkt[wm->p1].y+=wm->dy;
							wm->stan++;
							wm->czas=100;
						if (b==15)
						{
						SetAPen(&kolRP,0);
						RMurKolBM(pkt[wm->p1].x-16*wm->dx,pkt[wm->p1].y-16*wm->dy,
								pkt[wm->p2].x,pkt[wm->p2].y);
						SetAPen(&kolRP,1);
						RPixKolBM(pkt[wm->p1].x-16*wm->dx,pkt[wm->p1].y-16*wm->dy);
						RPixKolBM(pkt[wm->p2].x,pkt[wm->p2].y);
						}
								}
		  if ((b==16)&&(wm->cechy&16)) if (!(--wm->czas)) 
						{wm->stan=17;
						SetAPen(&kolRP,1);
						RMurKolBM(pkt[wm->p1].x-16*wm->dx,pkt[wm->p1].y-16*wm->dy,
									pkt[wm->p2].x,pkt[wm->p2].y);
						if (Kolizmur(camx,camy))
							{	// stoisz w drzwiach !
							SetAPen(&kolRP,0);
							RMurKolBM(pkt[wm->p1].x-16*wm->dx,pkt[wm->p1].y-16*wm->dy,
								pkt[wm->p2].x,pkt[wm->p2].y);
							SetAPen(&kolRP,1);
							RPixKolBM(pkt[wm->p1].x-16*wm->dx,pkt[wm->p1].y-16*wm->dy);
							RPixKolBM(pkt[wm->p2].x,pkt[wm->p2].y);
							wm->stan=16; wm->czas=50;
							}
						else AddAReq(&gfx[SFX_DRZWI],pkt[wm->p1].d);
						}
		  if ((b>16)&&(b<32))	 {pkt[wm->p1].x-=wm->dx;
							pkt[wm->p1].y-=wm->dy;
						if ((++wm->stan)==32) { wm->stan=0; wm->nacis=0; }
								 }
		}
		else if (wm->nacis) { Wiadom(lttab[20],10); wm->nacis=0;}
	wm->d=0;
	}

if (mur[najbm].cechy&32) mur[najbm].faza=1;

}


Sterow()
{
if (OpcCe)
{
if (OpcGr)
	{
	celx=ekr->MouseX/4;
	if (celx<0) celx=0; else if (celx>63) celx=63;
	}
	else
	{
	myszx=ekr->MouseX-7;
	myszy=ekr->MouseY+10;
	celx=myszx/4;
	}
}
while (Message=GetMsg(ekrPort))
  {
	a=Message->Code;
	d=Message->Class;
	ReplyMsg(Message);
	switch(d)
	{
	case IDCMP_ACTIVEWINDOW:
		if (pauza)
			{
			pauza=0; 
			st_fire=0; st_left=0; st_right=0; st_up=0; st_down=0; st_gou=0;
			CzasStart();
			}
		 break;
	case IDCMP_INACTIVEWINDOW:
		if (OpcGr)
			{
			if (OpcPa)
				{ pauza=1; CzasStop();
				t_pauz=0; 
				}
			}
		else
			przerwagry=1;
		break;
	case IDCMP_RAWKEY:
	b=!(a & 0x80);

	if ((a>=0x50)&&(a<=0x57)&&(mam[a-0x50].co)) { wybbron=a-0x50; brony=40; fire=firet=0;}

	switch(a&0x7f)
		{
		case CURSORUP:		st_down=b;		break;
		case CURSORDOWN:	st_up=b;		break;
		case CURSORLEFT:	st_right=b;		break;
		case CURSORRIGHT:	st_left=b;		break;
		case 0x40:
		case 0x65:
		case 0x64:			st_fire=b;		break;
		case 0x5f:	helpwanted=przerwagry=1; break;
		case 0x45:			przerwagry=1;	break;
		case 0x19:			if (pauza^=b)
						 CzasStop();
							else CzasStart();
							 t_pauz=0;		break;
		case 0x60:
		case 0x61:			st_shift=b;		break;
		case 0x62:
			if (b)
				tabch=7;
			else
			{
			for (i=0;i<TOPSECRET;i++)
				{
				for (j=0;j<8;j++)
					if (cheat[j]!=topsecret[i][j]) goto niepas;
				switch(i)
				{	case 0: energ=32*9+31; StatusUpdate(0); break;
					case 1: amu=83; StatusUpdate(0); break;
					case 2:	mam[1].co=2; mam[1].obiekt=0;
							mam[2].co=3; mam[2].obiekt=0;
							mam[3].co=4; mam[3].obiekt=0;
							mam[4].co=5; mam[4].obiekt=0;
							mam[5].co=6; mam[5].obiekt=0;
							mam[6].co=7; mam[6].obiekt=0;
							mam[7].co=10; mam[7].obiekt=0;
							wybbron=3;
							StatusUpdate(1);
							break;
					case 3: zalicz=1; break;
					case 4:	for (i=7;i<=lob;i++)
								switch(obiekt[i].typ)
								{case 1: case 18: case 10:
								obiekt[i].typ=0;
								ReName(&obiekt[i],80);
								obiekt[i].cechy=16+128;
								obiekt[i].enkol=0;
								}
							break;
					case 5:	i_am_rambo=1;	break;
				}
				niepas:
				}
			}
		break;
		}

	if (b)
		{ cheat[tabch]=klawisz=a; tabch=(tabch+1)&7; }
	break;
	case IDCMP_MOUSEBUTTONS:
	if 	(a&1)				// PRAWY
		{
		if ((!(a&0x80))
		&&(!((b=(menuekr->MouseY-4-8)/11)&0xfffc))
		&&(!((a=menuekr->MouseX/16)&0xfffe))
		&&(mam[b+=4*a].co))	
			{wybbron=b; brony=40; fire=firet=0;}
		else	
		st_down=st_gou= !(a&0x80);
		}
		else
		st_fire=!(a&0x80);	// LEWY
	break;
	}
  }	
	if (pauza) return;

if (klawisz==0x46)		// Del
	if ((mam[wybbron].co)&&(b=mam[wybbron].obiekt)&&
		(!Kolizmur(camx+7*tsi[camh+celx-32],camy+7*tsi[(64+camh+celx-32)&255])))
		{
		if (mam[wybbron].co==11) { jade=0; KanOff(2); }
		obiekt[b].p2=mam[wybbron].co;
		obiekt[b].faza=0;
		obiekt[b].initgfx=obiekt[b].gfx=mam[wybbron].gfx;
		mam[wybbron].co=0;
		WybierzInne();
		obiekt[b].x=camx+7*tsi[camh+celx-32];
		obiekt[b].y=camy+7*tsi[(64+camh+celx-32)&255];
		obiekt[b].z=50;
		obiekt[b].typ=11;
		obiekt[b].enkol=0;
		obiekt[b].cechy=16;
		obiekt[b].energia=50;
		obiekt[b].v=0;
		klawisz=0;
		}

if (firet>0) 
	{firet++;
	if (firet<przedmiot[mam[wybbron].co].len) brony+=3;
	if (firet==przedmiot[mam[wybbron].co].len)
		{
		fire=0;
		Use2();
		}
	if (firet==przedmiot[mam[wybbron].co].delay) firet=0;
	}
	else
	if (przedmiot[mam[wybbron].co].len<0)
	{	
	if (!firet)
		{ fire=1-fire;
		  firet=przedmiot[mam[wybbron].co].len;
		  Use3();
		}
		else firet++;
	}

a=(*(WORD*)0xdff00c);
if ((((a&(1<<1))>>1)^(a&(1<<0))) || st_up)
	{vx=(vx-4*tsi[camh])/8; vy=(vy-4*tsi[(camh+64)&0xff])/8;
	}
if ((a&(1<<1)) || st_left)
	if (st_shift && !jade) 
			{ vx=(vx+4*tsi[(camh+64)&0xff])/8;
			  vy=(vy-4*tsi[camh])/8;
			}
			else rotv+=25;
if (((a&(1<<8))^((a&(1<<9))>>1)) || st_down)
	{vx=(vx+7*tsi[camh])/8; vy=(vy+7*tsi[(camh+64)&0xff])/8;
	}
if (st_gou) {rotv+=celx-32;}
if ((a&(1<<9)) || st_right)
	if (st_shift & !jade) 
			{ vx=(vx-4*tsi[(camh+64)&0xff])/8;
			  vy=(vy+4*tsi[camh])/8;
			}
			else rotv-=25;
if ((st_fire || (!(*((BYTE *)0xbfe001)&128)))&&(firet==0)&&(przedmiot[mam[wybbron].co].amu<=amu))
	{
	fire=firet=1;
	s_fire++;
	Use();
	}

if (jade)
	{
	jadep2=(7*jadep2+512+16*(abs(vx)+abs(vy)))/8;
	SetPeriod(2,(jadeper*512)/jadep2);
	}
	else
	{
	if ((!vx)&&(!vy)) tuptup=0;
	if ((tuptup+=abs(vx)+abs(vy))>TUPLEN)
	{ tuptup=0; stoi=0; Play8SVX(&a_tup,0,1,64,1);
	  s_krok++; if (mt_SongPos==6) GoToPat(0); }
	}
brony=(brony+(tuptup>>5))>>1;
}

Use2()
{
WORD bron;
	bron=mam[wybbron].co;
	switch(bron)
	{
	case 6:	// klucz
	if ((mur[najbm].cechy&2)&&(!(mur[najbm].cechy&8)))
		{
		GoToPat(muzklucz[rand()&MUZKL]);
		Play8SVX(&a_reload,K_DOW,1,64,1);
		mam[wybbron].co=0;
		WybierzInne();
		mur[najbm].cechy |= 8;
		mur[najbm].faza=0;
		}
	break;

	case 7:	// dysk
	if (obiekt[ob_komput].d<25)
	{
		GoToPat(muzklucz[rand()&MUZKL]);
		Play8SVX(&a_reload,K_DOW,1,64,1);
		mam[wybbron].co=0;
		WybierzInne();
		k_poztxt=lttab[11]; obiekt[ob_komput].stan=1;
	}
	break;

	case 8:	// granat
	Play8SVX(&a_bron[1],K_DOW,1,64,1);
	b=mam[wybbron].obiekt;
	obiekt[b].p2=mam[wybbron].co;
	obiekt[b].faza=0;
	mam[wybbron].co=0;
	WybierzInne();
	obiekt[b].x=camx+7*tsi[camh+celx-32];
	obiekt[b].y=camy+7*tsi[(64+camh+celx-32)&255];
	obiekt[b].cechy=0;
	obiekt[b].z=65;
	obiekt[b].typ=12;
	obiekt[b].v=9;
	obiekt[b].head=camh+celx-32;
	obiekt[b].txt=10;
	obiekt[b].kol=0;
	break;

	case 9:	// rakieta
	if ((!lastob) || (lastob->xe&0xC0)) break;

	Play8SVX(&a_bron[5],K_DOW,1,64,1);
	b=mam[wybbron].obiekt;
	obiekt[b].faza=0;
	obiekt[b].gfx=mam[wybbron].gfx+1;
	mam[wybbron].co=0;
	WybierzInne();
	obiekt[b].x=camx+7*tsi[camh+celx-32];
	obiekt[b].y=camy+7*tsi[(64+camh+celx-32)&255];
	obiekt[b].cechy=0;
	obiekt[b].z=65;
	obiekt[b].typ=13;
	obiekt[b].czas=3;
	obiekt[b].v=9;
	obiekt[b].longp=lastob;
	obiekt[b].p1=lastob->x;
	obiekt[b].p2=lastob->y;
	obiekt[b].txt=9;
	obiekt[b].kol=0;
	obiekt[b].head=camh+lastob->xe-32;
	wo->p3=0;

/*			"wysza strategia"
	if (tabodl[lastob->xe]<=lastob->odl)
		obiekt[b].head=camh+lastob->xe-32;
	else
		{
		obiekt[b].czas=9999;
		for (d=10;d<100;d+=5)
			if (Kolizlin(camx+d*tsi2[9][camh],camy+d*tsi2[9][(64+camh)&255],lastob->x,lastob->y))
			{ obiekt[b].czas=d; break; }
		obiekt[b].head=camh;
		}
*/

	break;
	}
}

Use()
{
WORD bron;
	bron=mam[wybbron].co;
	switch(bron)
	{
	case 12: // fantomer
	Play8SVX(&a_bron[6],K_DOW,1,64,1);
	wo2=&obiekt[mam[wybbron].obiekt];
	if (!wo2->x)
		{
		wo2->x=camx+8*tsi[camh+celx-32];
		wo2->y=camy+8*tsi[(64+camh+celx-32)&255];
		wo2->head=camh+celx-32;
		wo2->v=3;
		wo2->typ=24;
		wo2->initgfx=wo2->gfx=mam[wybbron].gfx+1;
		wo2->faza=0;
		wo2->stan=0;
		wo2->czas=(gfx[wo2->gfx].t+1)*gfx[wo2->gfx].fazy;
		wo2->txt=73;
		}
		else
		if ((wo2->stan)&&(wo2->d<111))
		{
		wo2->faza=0;
		}
	break;

	case 5:	// widelec
	Play8SVX(&a_bron[1],K_DOW,1,64,1);
	for(b=1;b<=lob;b++)
		if ((abs(obiekt[b].xe-celx)<((obiekt[b].odl>>5)+przedmiot[bron].rozrzut))&&(obiekt[b].d<przedmiot[bron].zasieg)&&(tabodl[obiekt[b].xe]<=obiekt[b].odl))
			if (obiekt[b].cechy&512)
			{
				energ+=15;
				if ((obiekt[b].energia-=30)<=0)
					{
					obiekt[b].gfx=obiekt[b].initgfx+1;
					ReName(&obiekt[b],15);
					obiekt[b].faza=0;
					obiekt[b].typ=0;
					obiekt[b].cechy&=~512;
					}
			}
			else
		Trafiony(&obiekt[b],obiekt[b].d,przedmiot[bron].moc);
	break;

	case 1:
	case 2:
	case 3:
	case 4:	// bronie standardowe
	Play8SVX(&a_bron[bron],K_DOW,1,64,1);
	if ((amu-=przedmiot[bron].amu)<0) amu=0;
	for(b=1;b<=lob;b++)
		if ((abs(obiekt[b].xe-celx)<((obiekt[b].odl>>5)+przedmiot[bron].rozrzut))&&(obiekt[b].d<przedmiot[bron].zasieg)&&(tabodl[obiekt[b].xe]<=obiekt[b].odl))
		Trafiony(&obiekt[b],obiekt[b].d,przedmiot[bron].moc);
	}
}

Use3()
{
if (mam[wybbron].co==10)
	Rysradar();
}

KillMe(WORD d,WORD moc)
{
	if (d>180) d=180;
	if (jade)
	energ-=(moc*(256-d))>>9;
		else
	energ-=(moc*(256-d))>>8;
	rotv+=(rand()&255)-128;
}

ReName(struct obiekt *o,WORD nazwa)
{
if ((o==lastob)&&(o->txt!=nazwa)) lastob=0;
o->txt=nazwa;
}

Trafiony(struct obiekt *o,WORD d,WORD moc0)
{
WORD moc=moc0;

	if ((o->cechy&1024)&&(moc<999)) moc=0;

if (d>180) d=180;
		moc=(moc*(256-d))>>8;

	if ((o->energia-=moc)<0) o->energia=0;

switch(o->typ)
	{
	case 1:
	o->gfx=o->initgfx+2;	// boli..
	o->faza=o->v=0;
	o->stan=2;
	o->czas=2;
	if (!o->energia)
		{
		o->gfx=o->initgfx+3;
		o->typ=2;
		o->p3=o->txt;
		o->czas=250;
		o->p4=(OpcZo&&(moc0<300))?1:0;
		o->p1=1;		//daje amu
		o->p2=(o->txt==62)?12:6;		// 6 lub 12 szt.
		o->faza=0;
		ReName(o,6);
		o->cechy=128;
		AddAReq(&a_boli[2],o->d);	// wrzask smiertelny
		score+=o->pkt; o->pkt=0;
		}
		else AddAReq(&a_boli[0],o->d);	// wrzask
	break;
	if ((moc0>300)&&(o->p4)) { o->p4=0; o->faza=gfx[o->gfx].fazy-1; }
	case 18:	// dezynfekcja zombie
	if (moc0>300) { o->typ=0; o->gfx=o->initgfx+3; }
	break;
	
	case 5:	// mina
	if (!o->stan)
	{
	o->gfx=GFX_BIGBANG;
	ReName(o,1);
	o->faza=0;
	o->czas=5;
	o->stan=1;
	AddAReq(&a_explo,o->d);
	score+=o->pkt; o->pkt=0;
	}
	break;

	case 10:
	o->head=camh+128+o->xe-32;
	o->czas=0;
	if (!o->energia)
		{
		o->initgfx=o->initgfx+1;
		o->gfx=o->initgfx;
		o->typ=0;
		o->enkol=
		o->faza=0;
		o->cechy=128+512+16+32;
		o->energia=200;
		o->v=0;
		ReName(o,14);
		score+=o->pkt; o->pkt=0;
		}
	if (o->p2) AddAReq(&gfx[o->p2],o->d);	// wrzask
	break;

	case 20:	// trafienie puszcza animacj od klatki 1 jeden raz
	o->faza=1;
	o->stan=1;
	o->czas=gfx[o->gfx].t;
	if (o->p1) AddAReq(&gfx[o->p1],o->d);	// wrzask
	if (o->txt==39) ReName(o,6);

	break;	

	case 16:
	o->gfx=(o-1)->initgfx+1;
	o->faza=0;
	o->czas=2;
	break;

	case 19:	// snajper
	if ((moc>300)||(!o->energia)&&(o->stan==1))
		{
		score+=o->pkt; o->pkt=0;
		AddAReq(&a_boli[2],o->d);	// wrzask smiertelny
		o->cechy&=~256;
		o->stan=2;
		o->faza=0;
		o->czas=9999;
		mur[o->p1].gfx=o->p2;
		}
	break;

	case 21:
	case 22:
	if (o->stan) break;
	o->stan=1; o->faza=0; o->gfx=o->initgfx+1;
	wo->czas=1;
	break;

		// a te nie reaguj:
	case 4:
	case 9:
	case 11:  break;

	case 6:
	case 15:
	o->gfx=o->initgfx+1;
	o->faza=0;
	o->czas=2;
	if ((o->typ==15)&&(!o->energia))
		{
		(o+1)->energia=0;
		(o+1)->typ=0;
		(o+1)->enkol=0;
		(o+1)->cechy=49;
		Trafiony(o+1,0,1);
		}

	default:
	if ((!o->z)&&(!o->typ)) { o->z+=10; o->typ=7;}
	if (!o->energia)
	{
	//	dezynfekcja zombie ----------------\
	if ((o->typ==2)&&(moc0>300)&&(o->p4)) { o->p4=0; o->faza=gfx[o->gfx].fazy-1; }
	if (o->cechy&16)		// ginie
		{
		o->enkol=0;
		if (o->cechy&32)
							// zmiana w cos
		 		{
				score+=o->pkt; o->pkt=0;
				o->faza=0; 	o->cechy&=128;
				o->gfx=o->initgfx+1;
				o->typ=7;
				switch(o->txt)
					{
					case 57:
					case 53: ReName(o,6); o->cechy=128; 
						break;
					case 67: ReName(o,14);
							o->cechy=128+512+16+32;
							o->initgfx=o->gfx;
							o->energia=200;
						break;
					case 16: ReName(o,17); break;
					case 14: ReName(o,15); break;
					case 33: ReName(o,35);
							o->cechy=1;
							o->enkol=o->p3;
							o->p4=9999;							
							o->czas=5;
							o->typ=9;
						break;
					}
				}
						// std. wybuch
			else 
					{
					score+=o->pkt; o->pkt=0;
					o->faza=o->cechy=0;
					o->gfx=GFX_EXPLO;
					o->typ=7;
					ReName(o,1);
					AddAReq(&a_explo,o->d);
					}
		}
	else
		{
		score+=o->pkt; o->pkt=0;
		//o->cechy&=128+1+2;
		}
	}
	}
}

WybierzInne()
{
WORD i;

st_fire=0;
firet=fire=0;
for (i=wybbron+1; i<MAXMAM; i++)
	if ((mam[i].co)&&(przedmiot[mam[i].co].amu<=amu))
		{ wybbron=i; return; }

for (i=wybbron-1; i>=0; i--)
	if ((mam[i].co)&&(przedmiot[mam[i].co].amu<=amu))
		{ wybbron=i; return; }

}

Kolizja(WORD o)
{
WORD a,g;
switch (obiekt[o].typ)
	{
	case 2:
	// dawca (en,amu itp.)
		switch (obiekt[o].p1)
		{
		// 1. +amu
		case 1: if (amu>=83) break;
				amu+=obiekt[o].p2; 
				// GoToPat2(15);
				Play8SVX(&a_reload,K_DOW,1,64,1);
				if (obiekt[o].cechy&4) { wo->x=0; wo->y=0; wo->typ=0; }
				obiekt[o].faza=gfx[obiekt[o].gfx].fazy;
				obiekt[o].typ=obiekt[o].p4?18:0;
				obiekt[o].czas=160;
				break;
		// 2. +energ
		case 2: if (energ>=32*9+31) break;
		if (obiekt[o].txt==27) ReName(&obiekt[o],79);		
				energ+=obiekt[o].p2; 
				// GoToPat2(15);
				Play8SVX(&a_jdzwiek,K_DOW,1,64,1);
				if (obiekt[o].cechy&4) { wo->x=0; wo->y=0; wo->typ=0; }
				obiekt[o].faza=gfx[obiekt[o].gfx].fazy;
				obiekt[o].typ=0;
				break;
		// 3. +przedmiot
		case 3:	g=obiekt[o].p2;

				for (a=0;a<MAXMAM;a++)
				if (!mam[a].co)
					{
				GoToPat2(1);
					if (g==11)
						{
						if (jade) break;
						GoToPat(10);
						jade=1;
						jadeper=((struct gfx2*)(&gfx[obiekt[o].p3]))->per;
						jadep2=0;
						tuptup=0;
						Play8SVX(&gfx[obiekt[o].p3],2,0,64,1);
						}
     				obiekt[o].faza=gfx[obiekt[o].gfx].fazy;
					obiekt[o].typ=0;
					mam[a].co=g;
					mam[a].obiekt=o;
					mam[a].gfx=obiekt[o].gfx;
					mam[a].txt=obiekt[o].txt;
					obiekt[o].x=0;
					obiekt[o].y=0;
					obiekt[o].typ=0;
					wybbron=a; fire=firet=0;
					Play8SVX(&a_jdzwiek,K_DOW,1,64,1);
					break;
					}

				break;
		// 4. +pkt
		case 4:	score+=obiekt[o].p2;
				// GoToPat2(15);
				Play8SVX(&a_jdzwiek,K_DOW,1,64,1);
				obiekt[o].faza=gfx[obiekt[o].gfx].fazy;
				obiekt[o].typ=0;
				if (obiekt[o].cechy&4) { wo->x=0; wo->y=0; wo->typ=0; }
				break;
		}

			break;
	// ukryty wrg, wyzwalany dotkniciem
/*	case 3:
		if (!obiekt[o].stan)
		{
		obiekt[o].stan=1;	// stan budzenia si
		obiekt[o].gfx=obiekt[o].initgfx+1;
		}
		break;
*/
	case 4:	// sterowanie np. drzwiami
		if (!obiekt[o].stan)
			{
			obiekt[o].faza=obiekt[o].stan=1;
			obiekt[o].czas=4;
			if (obiekt[o].p3) AddAReq(&gfx[obiekt[o].p3],obiekt[o].d);
			for (c=1;c<=lob;c++)
			if (obiekt[c].gfx==obiekt[o].p1) 
				{
					obiekt[c].gfx++;
					obiekt[o].p4=obiekt[c].faza=gfx[obiekt[c].gfx].fazy;
					obiekt[c].p1=obiekt[c].enkol;
					obiekt[c].enkol=0;
				}
			}
		break;

	case 22:
		if (obiekt[o].stan==3)
		if (!mam[1].co)
			{
			amu=10;
			Play8SVX(&a_reload,K_DOW,1,64,1);
			mam[1].co=2;
			mam[1].obiekt=0;
			mam[2].co=6;
			mam[2].obiekt=1;
			mam[2].gfx=obiekt[o].p2;
			mam[2].txt=obiekt[o].p3;
			StatusUpdate(1);
			}
	break;

	}
}

// obliczenia wsprz. ekranowych i kolizje
// + dzwieki ta
Oblicz()
{
flipanim++;

najbp=0; dmin=99999;
for (a=1;a<=lpkt;a++)
	{
	Biegu(pkt[a].x,pkt[a].y,&pkt[a].xe);
	if (d<dmin) {dmin=d; najbp=a;}
	}

	// kolizja z murem: rg
// if (dmin<ROGKOL) kol=1;

for (wo=&obiekt[1],a=1;a<=lob;wo++,a++)
	{
	Biegu(wo->x,wo->y,&wo->xe);
	if ((!(wo->xe&0xC0))&&wo->odl&&(wo->odl<(3*WYS))&&((!(wo->cechy&256))))
								// bdzie rysowany - do kolejki
		{ /* if ((b=wo->d)<260) */ ww=d+&obucket[0];
		while (*ww) ww++;
			*ww=wo;
		}
	if (d<OBIEKTKOL)		//w pobliu obiektu:
		{wo->nacis=1;

		 if (wo->typ) Kolizja(a);
				else if (wo->cechy&4) { wo->x=0; wo->y=0; wo->typ=0; }

		 if (jade)
			{
			if (wo->z) energ+=wo->enkol/2;
			}
			else energ+=wo->enkol;
						// popychanie
		if ((wo->cechy&1)&&
	(!Kolizmur(wo->x+tsi[camh],wo->y+tsi[(64+camh)&255])) )
		 { wo->x+=tsi[camh]; wo->y+=tsi[(64+camh)&255]; vx=vy=0; }
													// zatrzymanie ruchu
		if (wo->cechy&2) kol=1;
		}

	}

	if (los>lob)
	{

	for (;a<=los;a++,wo++)
		AddTloSfx(abs(wo->x-camx)+abs(wo->y-camy),wo,&gfx[-wo->gfx]);

	}
}

AddTloSfx(WORD d,struct obiekt *o,struct gfx *sfx)
{
if (d<tlo_sfx_min) {tlo_sfx_min=d; tlo_ob=o; tlo_sfx=sfx;}
}

PlayTloSfx()
{
	if (tlo_sfx != tlo_sfx_p)
		{	tlo_sfx_p=tlo_sfx;
			Play8SVX(tlo_sfx,1,0,0,1);
		}
	// glosnosc:
		a=64;
		if (tlo_sfx_min<(tlo_ob->p1<<8))
			a=(tlo_sfx_min<<6)/(tlo_ob->p1<<8);
		SetVol(1,64-a);
}

KillTloSfx()
{
KanOff(1);
tlo_sfx_p=0;
tlo_ob=0;
}
/*
Biegu(UWORD x,UWORD y,WORD *wyn)
{
// efekt uboczny- w zmiennej glob. _d_ jest odlegos !!!
//				  w zmiennej glob  _kat_ jest kt !!!

// wyniki: 0.pozycja x ekr.  1.tzw.wysokosc   2.odleglosc

LONG dx,dy,at;
WORD w;
BYTE okt=0;
#define ROZMOKT 32

   dx=x-camx; dy=y-camy;
	if ((dy==0)&&(dx==0)) {wyn[1]=wyn[2]=d=0; return;}
	if ((abs(dx)+abs(dy))>2000) {wyn[1]=0;  d=wyn[2]=9999; return;}
   if (dx<0) {okt |=4; dx= -dx;}
   if (dy<0) {okt |=2; dy= -dy;}
   if (dx>dy) {d=dx; dx=dy; dy=d; okt |=1;}
   at=tatan[(dx<<8)/dy];
   wyn[2]=d=(dy*todl[at])>>13;

   switch(okt)
	{case 0: kat=at; break;
	case 1: kat=2*ROZMOKT-at; break; 
	case 2: kat=4*ROZMOKT-at; break; 
	case 3: kat=2*ROZMOKT+at; break; 
	case 4: kat=8*ROZMOKT-at; break; 
	case 5: kat=6*ROZMOKT+at; break; 
	case 6: kat=4*ROZMOKT+at; break; 
	case 7: kat=6*ROZMOKT-at; break; 
	}
	wyn[0]=(kat=(((kat-camh)&255)^128))-(128-SZER/2);
	if ((d>=2)&&(d<256))
	wyn[1]=(tpersp[d]*poprawka[kat])>>8;
	else wyn[1]=0;	
}
*/
/* obrobka wstepna mapy */
SprawdzMape()
{
lmu2=0;
for (a=1;a<=lmur;a++)
	{
	if (mur[a].cechy&0x2) // drzwi
		{
		lpkt++;
		CopyMem(&pkt[mur[a].p1],&pkt[lpkt],sizeof(struct pkt));
		mur[a].p1=lpkt;
		}
	if (mur[a].cechy&4) lmu2=a;
	mur[a].gfx=mur[a].initgfx;
	}
for (a=1;a<=lob;a++)
	if ((obiekt[a].gfx=obiekt[a].initgfx)>=0) b=a;

	los=lob;
	lob=b;	

}

