
//  Wczytywanie obrazkw 12bit (LoadSUim)
//  i to samo z zamian na format sciany (LoadSUwall)

#include <exec/types.h>
#include <exec/memory.h>
#include <dos/dos.h>

#include "all_protos.h"

#define ID 'SUim'

__asm	void PPDecrunch( register __a0, register __d0, register __a1 );

struct SUIM { ULONG id; WORD sz,wy; };

WORD *LoadSUim(char *nazwa,WORD *rozm)
{
BYTE *adr;
ULONG len;
WORD *mem=0;
WORD szer,wys;

PPLoadData(nazwa,&adr,&len,0);

if (adr)
	{
	if ( ((struct SUIM*)adr)->id == ID )
		{
		szer=((struct SUIM*)adr)->sz;
		wys=((struct SUIM*)adr)->wy;
		if (rozm) {rozm[0]=szer; rozm[1]=wys;}
		if (mem=malloc(szer*wys*2))
			CopyMem(adr+8,mem,szer*wys*2);
		}
	FreeMem(adr,len);
	}
return mem;
}

WORD *LoadSUwall(char *nazwa,WORD *rozm)
{
BYTE *adr;
ULONG len;
WORD *mem=0,*dst,*src;
WORD szer,wys,x,y,w2;

PPLoadData(nazwa,&adr,&len,0);
if (adr)
	{
	if ( ((struct SUIM*)adr)->id == ID )
		{
		szer=((struct SUIM*)adr)->sz;
		wys=((struct SUIM*)adr)->wy;
			if (rozm) {rozm[0]=szer; rozm[1]=wys;}
			w2=wys-32;
			if (mem=malloc(szer*wys*2))
			{
				src=adr+8;
				dst=mem;
				for (x=0;x<szer;x++)
				{
				dst+=w2;
				for (y=wys;y>32;y--)	*(--dst)=*(src++);
				dst+=w2;
				for (;y;y--)			*(dst++)=*(src++);
				}
			}
		}
	FreeMem(adr,len);
	}
return mem;
}

#define SAFETY	8	/* Safety decrunch margin */

PPLoadData(char *nazwa,APTR *adr,ULONG *len,UWORD szuk)
{
	ULONG decrunched,crunlen;
	UBYTE *src,*dest;
	APTR file;

*adr=0; *len=0;

file=szuk?MOpen(nazwa,MODE_OLDFILE):Open(nazwa,MODE_OLDFILE);
if (!file) return 0;

	Seek(file,-sizeof(ULONG),OFFSET_END);
	Read(file,&decrunched,sizeof(ULONG));
	decrunched=(decrunched>>8) + SAFETY;
	crunlen = Seek(file,0,OFFSET_BEGINNING);

	if (src=AllocMem(crunlen,0))	//MEMF_PUBLIC))
	{
		if (Read(file,src,crunlen) == crunlen)
		{
		if (*(ULONG*)src=='PP20')
			{
				if (dest = AllocMem(decrunched,0))	//MEMF_PUBLIC))
				{
				PPDecrunch(src,crunlen,dest);
				FreeMem(src,crunlen);
				*adr=dest;
				*len=decrunched;
				}
			}
		else
			{
			*adr=src;
			*len=crunlen;
			}
		}
		else
		FreeMem(src,crunlen);
	}

Close(file);
}
