#include <exec/execbase.h>
#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <workbench/startup.h>
#include <workbench/workbench.h>

extern struct Library *IntuitionBase;
extern struct ExecBase *SysBase;
#include "all_protos.h"

int Komunikat(char *, char *);

#include <dos/dos.h>

struct DateStamp datst;


__far char *lttab[150];
__far char *naztab[100];
__far char *fabtab[400];

__far char *pliktab[700];

// ------------------------------- MAIN ------------------------------
extern struct WBStartup *_WBenchMsg;

char jezyk[30]="polski";
char gametoload[30]={0};
extern char txttmp[],str2[];
extern WORD OpcDz;
struct DiskObject *dobj=0;

WORD nosound=0;

main(int argc, char *argv[])
{
int i;

for (i=1;i<argc;i++)
	{
	if (!strncmp(argv[i],"-t",2)) { TestMode(); exit(0); }
	if (!strncmp(argv[i],"-l",2)) strncpy(jezyk,argv[i+1],29);
	if (!strncmp(argv[i],"-n",2)) nosound=1;
	if (!strncmp(argv[i],"-g",2)) strncpy(gametoload,argv[i+1],29);
	if (*argv[i]=='?')	{ printf("UBEK [-t/-test] [-g/-game ...] [-n/-nosound] [-l/-language ...]\n"); exit(0); }
	}

if (_WBenchMsg)
{
if (_WBenchMsg->sm_NumArgs>1)
		strncpy(gametoload,_WBenchMsg->sm_ArgList[1].wa_Name,29);

if (dobj=GetDiskObject(_WBenchMsg->sm_ArgList->wa_Name))
	{
	char	**tt=dobj->do_ToolTypes, *jez;
	if (jez=FindToolType(tt,"LANGUAGE"))
							strncpy(jezyk,jez,29);
	if (FindToolType(tt,"NOSOUND")) nosound=1;
	FreeDiskObject(dobj);
	}
}

strcpy(str2,"languages/");
strcat(str2,jezyk);
strmfn(txttmp,0,str2,"nazwy",0);
CzytText(txttmp,naztab);
strmfn(txttmp,0,str2,"teksty",0);
CzytText(txttmp,lttab);
strmfn(txttmp,0,str2,"fabul",0);
CzytText(txttmp,fabtab);
if ((naztab[1]==naztab[2])||(lttab[1]==lttab[2])||(fabtab[1]==fabtab[2]))
	{ Komunikat("Can't use language",jezyk); exit(0); }
TestSystem();

CzytText("floppy_files",pliktab);

SpritesInit();
CzytOpcje();
if (nosound) OpcDz=-1; else	InitDzwieki();
if (OpcDz==-1) { *((char *)lttab[35])='0'; OpcDz=0; }

if (MenuInit())
	 {	Komunikat(lttab[1],lttab[2]);
		goto wyjscie; }
SpritLoad();
BufInit();
GfxInit();
tablice();
StatusInit();
SpritLoadOff();
DateStamp(&datst);
srand(datst.ds_Tick);

	Menu();

StatusClose();

wyjscie:

CloseDzwieki();
MenuClose();
SpritesClose();
}

static TestSystem()
{
if (!(SysBase->AttnFlags & AFF_68020))
	{	Komunikat(lttab[3],lttab[4]);	exit(60);}
if (AvailMem(0)<(nosound?786000:1026000))
	{ Komunikat(lttab[5],lttab[6]); exit(70); }
//if (((struct Library*)SysBase)->lib_Version<40)
//	{	Komunikat("Ta wersja UBEKa dziala","tylko na Kickstarcie 3.1"); exit(80); }
}

CzytText(char *naz,char *tab[])
{
ULONG len;
char *koniec,*adr,*txt;
WORD i=1;

tab[0]=0;
tab[1]=0;
if (txt=ReadFile(naz,&len))
	{
	koniec=(APTR)((ULONG)txt+len);
	adr=txt;
	while(adr<koniec)
		{
		tab[i++]=adr;
		while(++adr<koniec)
			if (*adr=='\n') { *adr=0; break; }
		adr++;
		}
	}
}

static Komunikat(char *lin1, char *lin2)
{
WORD y,x;
APTR mes;
struct Window *win;
struct NewWindow daneokna=
	{160,40,320,100,
	-1,-1,
	IDCMP_MOUSEBUTTONS,
	WFLG_RMBTRAP | WFLG_ACTIVATE | WFLG_DRAGBAR | WFLG_DEPTHGADGET,
	0,0,
	"Sorry!",
	0,0,0,0,0,0,WBENCHSCREEN};
	if (win=OpenWindow(&daneokna))
		{
		win->BorderLeft=win->BorderRight=win->BorderBottom=win->BorderTop;
		y=win->Height/2;
		SetAPen(win->RPort,1);
		Move(win->RPort,(win->Width-TextLength(win->RPort,lin1,strlen(lin1)))/2,y);
		Text(win->RPort,lin1,strlen(lin1));
		y+=win->BorderTop;
		Move(win->RPort,(win->Width-TextLength(win->RPort,lin2,strlen(lin2)))/2,y);
		Text(win->RPort,lin2,strlen(lin2));
		RefreshWindowFrame(win);
		ScreenToFront(win->WScreen);
		Wait(1<<win->UserPort->mp_SigBit);
		CloseWindow(win);
		} 
}
