#include <intuition/intuition.h>
#include <dos/dos.h>
#include <exec/memory.h>
#include <graphics/gfxbase.h>
#include <graphics/sprite.h>
#include <graphics/gfx.h>
#include "obiekty.h"

#include "all_protos.h"

extern WORD myszx,myszy;
__far extern UWORD celownik[];
extern WORD OpcGr,OpcBr;
extern WORD tsi[];
extern struct obiekt obiekt[];
far extern struct pkt pkt[];
far extern struct mur mur[];
extern WORD lob,lpkt,lmur;
extern __far char *naztab[];

APTR file;
ULONG Chunk,ChuLen;
BYTE* iff=0;
BYTE* iffend;
__far struct {WORD Width,Height;
			WORD Dx,Dy;
			BYTE Depth,Mask;
			BYTE Kompr,Pad;
			WORD transcolor;
			BYTE XAspect, YAspect;
			WORD SWidth,SHeight;} BMHD;

__far struct { WORD sx,sy,x,y,sz,wy; }  MapaBroni[]=
	{
		0,0,0,0,0,0,
// n
			0,0, 0,14,102,21,
// pistolet
			0,21, 5,2,89,45,
// karabin		
			0,66, 0,6,102,41,
// laser		
			0,107, 0,5,102,34,
// widelec		
			32,141, 11,15,74,18,
// klucz		
			32,159, 33,17,40,14,
// dysk		
			0,173, 35,8,36,32, 
// granat		
			0,141, 37,8,32,32,
// rakieta		
			36,173, 13,11,75,26,
// radar
			0,205, 22,3,53,46,
// pojazd
			0,251, 0,5,100,44,
// fantomer
			64,205,	30,4,42,42,
			
	};

#define ILEOBRONI 24
#define ILESPRAK  20

extern WORD energ,amu,wybbron,score,i_am_rambo;
extern __far struct mam mam[MAXMAM];
extern WORD usetrack;
WORD boli;

extern struct GfxBase *GfxBase;

extern APTR ReadFile(char *naz,ULONG* dlug);

extern WORD fire;

#define STATUS_EKRAN "pic/ekran"
#define FAZY_EKRAN "pic/fazy"
#define CYF_EKRAN "pic/cyferki"
#define BRON_EKRAN "pic/bronie"
#define SPRITKIBRON "pic/spritbron"
#define SPRITKILOAD "pic/spritload"
#define BRONMA_EKRAN "pic/bronie1234"

#define SPRITBSIZ 82*2*2
#define SPRITLSIZ 32*2*2
#define SPRITASIZ 18*2*2
#define SPRITDSIZ 32*2*2

extern APTR ub16font,ub8font;

extern struct Screen *ekr;

extern struct Screen *menuekr;
extern struct Window *menuwin;
extern struct RastPort *menurp;
extern struct ViewPort *menuvp,*ekrvp;
extern APTR MesPort;
extern ULONG waitinput;
__far struct BitMap fazybm,bronbm,panelbm,bronmabm,cyfbm;
__far struct BitMap txtbm;
__far struct RastPort txtrp;
__far UWORD paleta_l[] =
{
	0x0000,0x0fff,0x0008,0x0dbb,0x07a0,0x0442,0x0db0,0x0c43,0x0b88,0x0888,
	0x0102,0x0a76,0x0732,0x000e,0x0f97,0x0755,
	0x0000,0x0fff,0x0ddd,0x0bbb,0x0999,0x0666,0x0444,0x0222,0x0050,0x00a0,
	0x00f0,0x0d95,0x0ea6,0x0eb7,0x0147,0x0169
},paleta_b[] =
{
	0x0000,0x0fff,0x0008,0x0dbb,0x07a0,0x0442,0x0db0,0x0c43,0x0b88,0x0888,
	0x0102,0x0a76,0x0732,0x000e,0x0f97,0x0755,
	0x0360,0x0fff,0x0ccc,0x0888,0x0444,0x0000,0x0532,0x0853,0x0a73,0x0d94,
	0x0eb7,0x0ff0,0x0e83,0x0f00,0x0a30,0x00ff
};

extern UWORD menupaleta[];
struct SimpleSprite spr[5];
BYTE *sprbdat,*sprldat,*sprload,*spradat,*sprddat;

__chip struct {ULONG l1,l2;} spritblank={0,0},spritblank2={0,0};
__far APTR sblanktab[4];
extern WORD i,j,k;

BYTE *spritpal,*spritpt,*statpal,*statbpl;

__far BYTE *sbrontab[ILEOBRONI*4],*sloadtabdis[4],*sloadtab[21*4],*sdisktab[15*4];
__far BYTE *cel_adr[2];
WORD bronx,brony;

__far SpritesInit()
{
for(i=0;i<4;i++)
	 GetSprite(&spr[i],i+2);

if (sprbdat=AllocMem(SPRITBSIZ *ILEOBRONI*2*2,MEMF_CHIP))
	if (file=Open(SPRITKIBRON,MODE_OLDFILE)) {Read(file,sprbdat,SPRITBSIZ *ILEOBRONI*2*2); Close(file);}
if (sprldat=AllocMem(SPRITLSIZ *21*2*2,MEMF_CHIP))
	if (file=Open(SPRITKILOAD,MODE_OLDFILE)) {Read(file,sprldat,SPRITLSIZ *21*2*2); Close(file);}
spradat=AllocMem(SPRITASIZ*ILESPRAK,MEMF_CHIP | MEMF_CLEAR);
if (file=Open("pic/spritakcja",MODE_OLDFILE))
	{ Read(file,spradat,SPRITASIZ*ILESPRAK); Close(file); }

sprddat=AllocMem(SPRITDSIZ*15*4,MEMF_CHIP | MEMF_CLEAR);
if (file=Open("pic/spritdisk",MODE_OLDFILE))
	{ Read(file,sprddat,SPRITDSIZ*15*4); Close(file); }

sprload=AllocMem(SPRITLSIZ*4,MEMF_CHIP | MEMF_CLEAR);


for(i=0;i<ILEOBRONI*2*2;i++)
	{ sbrontab[i]=sprbdat+i*SPRITBSIZ;
	 if (i&1) *(sbrontab[i]+3) |= SPRITE_ATTACHED;
	}
for(i=0;i<2*2;i++)
	{ sloadtabdis[i]=sprload+i*SPRITLSIZ;
	  sblanktab[i]=&spritblank;
	 if (i&1) *(sloadtabdis[i]+3) |= SPRITE_ATTACHED;
	}
for(i=0;i<21*2*2;i++)
		sloadtab[i]=sprldat+i*SPRITLSIZ;

for(i=0;i<15*2*2;i++)
		sdisktab[i]=sprddat+i*SPRITDSIZ;
cel_adr[0]=celownik; cel_adr[1]=&spritblank;
}
__far SpritesClose()
{
for(i=0;i<4;i++) if(spr[i].num) FreeSprite(spr[i].num);

FreeMem(sprbdat,SPRITBSIZ *ILEOBRONI	*2*2);
FreeMem(sprldat,SPRITLSIZ *21	*2*2);
FreeMem(sprload,SPRITLSIZ		*4);
FreeMem(sprddat,SPRITDSIZ	*4*15);
FreeMem(spradat,ILESPRAK*SPRITASIZ);

}

APTR LoadILBM(struct BitMap *bm,char *plik,WORD szer,WORD wys,WORD dep)
{
APTR file;
WORD i;

InitBitMap(bm,dep,szer,wys);
	if (bm->Planes[0]=AllocRaster(szer,wys*dep))
		if (file=Open(plik,MODE_OLDFILE))
		{
		Read(file,bm->Planes[0], bm->BytesPerRow * wys * dep);
		Close(file);
		for (i=1;i<dep;i++) bm->Planes[i]=bm->Planes[0]+(bm->BytesPerRow*i);
		}
bm->BytesPerRow*=dep;

return bm->Planes[0];
}

FreeILBM(struct BitMap *bm)
{
if (bm->Planes[0]) FreeRaster(bm->Planes[0],8*bm->BytesPerRow/bm->Depth,bm->Rows*bm->Depth);
}

		//	---- adowanie obrazka z kompresj ------
		//  -----------------------------------------

#define CzytChunk Chunk=*(ULONG*)iff; iff+=4;
#define CzytChuLen ChuLen=*(ULONG*)iff; iff+=4;

BOOL LoadIFF(struct BitMap *bm,char* nazwa)
{
BOOL ok=0;
WORD sz,dl,i,k,x,y;
UBYTE *(ptr[8]);
register BYTE* iff=0,*iff_start;
register BYTE Head,Body;
register ULONG Chunk,ChuLen;
static BYTE* iffend;

	if (iff_start=iff=ReadFile(nazwa,&iffend))
		{
		iffend+=(ULONG)iff;
		CzytChunk; CzytChuLen;
		if (Chunk != 'FORM') goto koniec;
		CzytChunk;
		if (Chunk != 'ILBM') goto koniec;
for (;;){CzytChunk;
	 	CzytChuLen;
		if (Chunk=='BMHD') break;
		else if ((iff+=ChuLen)>=iffend) goto koniec;
		}
		CopyMem(iff,&BMHD,sizeof(BMHD)); iff+=ChuLen;
		if (BMHD.Depth>8) goto koniec;
for (;;){CzytChunk;
	 	CzytChuLen;
		if (Chunk=='BODY') break;
		else if ((iff+=ChuLen)>=iffend) goto koniec;
		}
		sz=(BMHD.Width+15) & 0xfff0;
		dl=sz/8;
		InitBitMap(bm,BMHD.Depth,sz,BMHD.Height);
			for (i=0;i<BMHD.Depth;i++)
				if (!(bm->Planes[i]=ptr[i]=AllocRaster(sz,BMHD.Height)))
						{FreeIFF(bm); goto koniec;}
			
				if (BMHD.Kompr)
				for (y=0;y<BMHD.Height;y++)
					for (i=0;i<BMHD.Depth;i++)
						{
						k=dl;
						while (k)
						{
						Head=*iff++;
						if (Head>=0)
							{
							CopyMem(iff,ptr[i],Head+1);
							k-=1+Head;
							ptr[i]+=1+Head;
							iff+=1+Head;
							}
						else
							if (Head!=-128)
							{
							Body=*iff++;
							Head=1-Head;
							k-=Head;
							for (;Head;Head--) *ptr[i]++=Body;
							}
						}
						}
				else
				for (y=0;y<BMHD.Height;y++)
					for (i=0;i<BMHD.Depth;i++)
						{CopyMem(iff,ptr[i],dl);
						 ptr[i]+=dl; iff+=dl;}
				ok=1;
		}
koniec:
if (iff_start) free(iff_start);
	return ok;
}

FreeIFF(struct BitMap *bm)
{
WORD i;
for (i=0;i<bm->Depth;i++)
	if (bm->Planes[i]) 
			{	FreeRaster(bm->Planes[i],8*bm->BytesPerRow,bm->Rows);
				bm->Planes[i]=0; }
	else break;
}

PlayAn(char *an,ULONG len,struct RastPort *rp,WORD pozx,WORD pozy,WORD t)
{
struct BitMap bm;
struct anim { ULONG id; WORD szer,wys; BYTE dep; } *anim;
BYTE *here,*len2;
UBYTE dep,mode,x,y,sz,wy,*plane;
WORD szer,wys,a,b,c,i,dalej=1;

if (an)
	{
	len2=len+(ULONG)an;
	anim=an;
	here=an+4+2+2+1;
	if (anim->id=='SUan')
		{
		InitBitMap(&bm,dep=anim->dep,(szer=anim->szer)*8,wys=anim->wys);
		for (i=0;i<dep;i++) bm.Planes[i]=AllocMem(szer*wys,MEMF_CHIP | MEMF_CLEAR);
		
	while (here<len2)
		{
		for (i=0;i<dep;i++)
			{
				switch(*(here++))
				{
			case 0:	// nic
				break;
			case 1:
				x=*(here++); y=*(here++);
				sz=*(here++); wy=*(here++);
				plane=((BYTE*)bm.Planes[i])+bm.BytesPerRow*y+x;
				for (;wy;wy--)
					{
					CopyMem(here,plane,sz); here+=sz;
					plane+=szer;
					}
				break;
				}
			}
		Delay(t);
		WaitBOVP(menuvp);
		BltBitMapRastPort(&bm,0,0,rp,pozx,pozy,szer*8,wys,0xc0);
		}
		for (i=0;i<dep;i++) FreeMem(bm.Planes[i],szer*wys);
		}
	}
}

__far StatusOn()
{
WORD i;
APTR file;

SetRast(menurp,0);

LoadRGB4(menuvp,paleta_b,32);

BltBitMapRastPort( &panelbm,0,0,menurp,0,8,320,49,0xC0 );

MoveScreen(menuekr,0,204);
if (OpcGr) { ScreenToFront(menuekr);}

if (!OpcGr)
	{
	LoadCopPal(statpal,paleta_l,16);
	LoadCopBpl(statbpl,menurp->BitMap->Planes,6);
	}

InitBitMap(&txtbm,1,320,8);
txtbm.Planes[0]=menurp->BitMap->Planes[0];
InitRastPort(&txtrp);
txtrp.BitMap=&txtbm;
SetFont(&txtrp,ub8font);
SetAPen(&txtrp,1);

ModifyIDCMP(menuwin,IDCMP_RAWKEY | IDCMP_ACTIVEWINDOW | IDCMP_INACTIVEWINDOW);
MesPort=menuwin->UserPort;
}

StatText(char *txt,WORD d)
{
SetRast(&txtrp,0);
if (d)
	{
	Move(&txtrp,160-4*d,6);
	Text(&txtrp,txt,d);
	}
}

MenuSpritOff()
{
spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=1;
	for (i=0;i<4;i++)
	ChangeSprite(menuvp,&spr[i],&spritblank2);
spritblank2.l1=0;
spritblank2.l2=0;
}

SpritOff()
{
spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=
spr[4].height=0;
if (OpcGr)
	for (i=0;i<4;i++)
	ChangeSprite(ekrvp,&spr[i],&spritblank2);
else
	{
	LoadCopBpl(spritpt,sblanktab,1);
	LoadCopBpl((char*)spritpt+16,sblanktab,4);
	}
//spritblank.l1=0;
//spritblank.l2=0;
}

static UWORD br_x,br_y,br_x2;

__far SpritBron()
{
SpritOff();
spr[0].height=
spr[1].height=
spr[2].height=
spr[3].height=80;
spr[4].height=15;

if (OpcGr==2)
	{ br_x=110-16; br_x2=110+16;
	br_y=30; }
else
	{ br_x=110; br_x2=110+16;
	br_y=120;}

if (OpcGr)
	LoadRGB4(ekrvp,paleta_b,32);
	else
	LoadCopPal(spritpal,paleta_b+16,16);
}

SpritBronRys()
{
spr[0].x=spr[1].x=br_x+bronx;
spr[2].x=spr[3].x=br_x2+bronx;
spr[2].y=spr[3].y=spr[0].y=spr[1].y=br_y+brony;

if (OpcGr)
	{
	if (OpcBr)
		{
		for (i=0;i<4;i++)
		ChangeSprite(ekrvp,&spr[i],sbrontab[i+8*mam[wybbron].co-8+4*fire]);
		}
	}
else
	{
	if (OpcBr)
		{
		for (i=0;i<4;i++) SpritCalc(&spr[i],sbrontab[8*mam[wybbron].co-8+4*fire+i]);
		LoadCopBpl((char*)spritpt+16,&sbrontab[8*mam[wybbron].co-8+4*fire],4);
		}
	spr[4].x=myszx; spr[4].y=myszy; //myszy;
	SpritCalc(&spr[4],celownik);
	LoadCopBpl(spritpt,&cel_adr,2);
	}
}

__far StatusUpdate(WORD zawsze)
{
static WORD popen=-1,popamu=-1,popbro=-1,scoreczek=10,popscore;
#define LCYF 5
static WORD cyf[LCYF];
WORD b;

if (zawsze) {popen=-1; popamu=-1; popbro=-1;
			 scoreczek=10; popscore=-1;
			for (i=0;i<LCYF;i++) cyf[i]=0;}

if (popbro!=wybbron)
	{
	b=mam[wybbron].co;
	BltBitMapRastPort( &panelbm,39,0,
					menurp,39,8,102,49,0xC0 );
	BltBitMapRastPort( &bronbm,MapaBroni[b].sx,MapaBroni[b].sy,
					menurp,39+MapaBroni[b].x,8+MapaBroni[b].y,
						MapaBroni[b].sz,MapaBroni[b].wy, 0xC0 );
	if (b==11)
		{
		SetAPen(menurp,0);
		RectFill(menurp,49,48,49+10*8,48+7);
		SetFont(menurp,ub8font);
		Move(menurp,49,48+6);
		SetAPen(menurp,1);
		SetBPen(menurp,0);
		b=mam[wybbron].txt;
		Text(menurp,naztab[b],naztab[b+1]-naztab[b]-1);
		}
	RysBronma();
	popbro=wybbron;
	usetrack=(mam[wybbron].co==9);
	}

	if (i_am_rambo) { if (energ<32*9+31) energ++; if (amu<83) amu++; }

if (popamu!=amu)
	{
	SetAPen(menurp,0);
	RectFill(menurp,228,6+8,229+83,6+8+8);
	BltBitMapRastPort( &panelbm,228,6,
					menurp,228,6+8,amu+1,8,0xC0 );
		popamu=amu;
	}

	boli=0;


if (popen!=energ)
	{
	if (energ<=0) energ=0; else if (energ>=32*9+31) energ=32*9+31;
	BltBitMapRastPort( &fazybm,32*9-(energ & 0xFE0),0,
					menurp,146,6+8,29,37,0xC0 );
	boli=popen-energ;
	popen=energ;
	}

if ((score!=popscore) || scoreczek)
	{
	j=score;
	for (i=0;i<LCYF;i++)
		{
		k=15*(j-10*(j/10)); j=j/10;
		cyf[i]=(cyf[i]+k)/2;
		 BltBitMapRastPort( &cyfbm,0,cyf[i],
					menurp,228+85-18-16*i,26+8,16,16,0xC0 );		
		}
if (scoreczek) scoreczek--;
if (score!=popscore) scoreczek=10;
	popscore=score;
	}

}

RysBronma()
{
WORD i,y=3;

for (i=0;i<4;i++,y+=11)
		{
		 BltBitMapRastPort(mam[i].co ? &bronmabm : &panelbm,2,y,
					menurp,2,y+8,14,11,0xC0 );
		 BltBitMapRastPort(mam[4+i].co ? &bronmabm : &panelbm,16,y,
					menurp,16,y+8,14,11,0xC0 );
		}
		i=(wybbron&4)?16:2;
		y=(wybbron&3)*11+3;
		 BltBitMapRastPort( &bronmabm,i+32,y,
					menurp,i,y+8,14,11,0xC0 );
}

Rysradar()
{
register WORD o,d,d2;
register struct mur *m;
register struct pkt *p,*p2;

	BltBitMapRastPort( &bronbm,MapaBroni[10].sx,MapaBroni[10].sy,
					menurp,39+MapaBroni[10].x,8+MapaBroni[10].y,
						MapaBroni[10].sz,MapaBroni[10].wy, 0xC0 );


	SetAPen(menurp,63);

for (o=1;o<lob;o++)
		if ((d=obiekt[o].d)<100)
		WritePixel(menurp,
			39+24+MapaBroni[10].x+((tsi[(obiekt[o].xe-32)&255]*d)/128),
			8+24+MapaBroni[10].y-((tsi[(obiekt[o].xe+32)&255]*d)/128));

for (m=&mur[1];m<=&mur[lmur];m++)
		if (((d=(p=&pkt[m->p1])->d)<100)&&((d2=(p2=&pkt[m->p2])->d)<100))
		{
		menurp->cp_x=39+24+MapaBroni[10].x+((tsi[(p->xe-32)&255]*d)/128);
		menurp->cp_y=8+24+MapaBroni[10].y-((tsi[(p->xe+32)&255]*d)/128);
		Draw(menurp,
			39+24+MapaBroni[10].x+((tsi[(p2->xe-32)&255]*d2)/128),
			8+24+MapaBroni[10].y-((tsi[(p2->xe+32)&255]*d2)/128));
		}
}

__far StatusInit()
{
LoadILBM(&panelbm,STATUS_EKRAN,320,49,6);
LoadILBM(&fazybm,FAZY_EKRAN,320,37,6);
LoadILBM(&bronbm,BRON_EKRAN,112,295,6);
LoadILBM(&bronmabm,BRONMA_EKRAN,64,49,6);
LoadILBM(&cyfbm,CYF_EKRAN,16,150,6);
}

__far StatusClose()
{
FreeILBM(&panelbm);
FreeILBM(&fazybm);
FreeILBM(&bronbm);
FreeILBM(&bronmabm);
FreeILBM(&cyfbm);
}

__far StatusHide()
{
MoveScreen(menuekr,0,-204);
SetRast(menurp,0);
LoadRGB4(menuvp,menupaleta,32);
}
