#include <exec/types.h>
#include <math.h>
#include "all_protos.h"

extern UWORD tpersp[256];		/* perspektywa: wysokosc sciany w odl. */
extern WORD tsi[256];
extern WORD tsi2[10][256];
extern UBYTE tatan[257];
extern UWORD todl[256];
extern UWORD poprawka[256];

__far WORD sinp[256][64];
__far WORD sink[256][64];
__far WORD dzielmur[4*256];

float skala=5.0;

tablice()
{
WORD d,i;
float a,b,o,x1,y1,x2,y2;

for (d=1;d<4*256;d++)
	dzielmur[d]=2*64*256/d;

for (d=0;d<256;d++)
	{ a=d * (PI/4) / 256.0;
	  o=(8192.0/cos(a))/skala;
	  todl[d]=(WORD)o;
	}
for (d=1;d<256;d++)	tpersp[d]=(UWORD)(4000/d);

for (d=0;d<128;d++)
{	a=(double)(d*(2.0*PI/256.0));
	tsi[128+d]=-(tsi[d]=(WORD)(22.0*sin(a)));
	for (i=0;i<10;i++)
		tsi2[i][128+d]=-(tsi2[i][d]=((tsi[d]*i)/7));
}

for (d=0;d<257;d++)
	{ a=d / 256.0;
	  b=(32.0*atan(a))/atan(1.0);
	  tatan[d]=(UBYTE)b;
	}

// for (d=0;d<=127;d++)
//	poprawka[128+d]=poprawka[128-d]=(UWORD)(256.0/cos((d*1.54)/127));

for (d=0;d<=63;d++)
	poprawka[128+d]=poprawka[128-d]=(UWORD)(256.0/cos((d*1.20)/63));
for (d=64;d<=127;d++)
	poprawka[128+d]=poprawka[128-d]=poprawka[128+63];

for (d=0;d<256;d++)
	{
	x1=sin((d*6.2831)/256-0.7853);
	y1=cos((d*6.2831)/256-0.7853);
	x2=sin((d*6.2831)/256+0.7853);
	y2=cos((d*6.2831)/256+0.7853);
	for(i=1;i<50;i++)
		{
		a=64*1000.0/i;
		sinp[d][50-i]=(WORD)(a*x1);
		sink[d][50-i]=(WORD)(a*(x2-x1)/64.0);
		}
	sinp[d][50]=sinp[d][49];
	sink[d][50]=sink[d][49];
	}
}

